<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/**
 * 配置相关
 */
class AvatarBox extends MY_Controller
{
    public $postData = array('frombg' => 1, 'lid' => 1, 'sid' => 1);

    const AVATAR_TYPE_PASSPORT = 1;
    const AVATAR_TYPE_VIP = 2;
    const AVATAR_TYPE_THEME = 3;
    const AVATAR_TYPE_COMMUNITY = 4;
    const AVATAR_TYPE_NORMAL = 5;
    const AVATAR_TYPE_ISLAND = 6;
    public $avatarTypes = [
        self::AVATAR_TYPE_PASSPORT => '通行证头像框',
        self::AVATAR_TYPE_VIP => 'vip头像框',
        self::AVATAR_TYPE_THEME => '限时卡组主题头像框',
        self::AVATAR_TYPE_COMMUNITY => '社区专属头像框',
        self::AVATAR_TYPE_NORMAL => '通用头像框',
        self::AVATAR_TYPE_ISLAND => '限时岛屿头像框',
    ];
    public $statusMap = [
        0 => '未激活',
        1 => '已激活',
    ];
    public $randomMap = [
        0 => '否',
        1 => '是',
    ];
    public function __construct()
    {
//        date_default_timezone_set("Asia/Shanghai");
        parent::__construct();
        $this->load->helper('url');
        $this->load->helper('cookie');
        $this->load->library('curl');
        $this->load->library('pagination');
        $this->env = get_cookie($this->_wenenv);
        $this->_url = $this->config->item('officialUrl');
        //判断model是否存在
        if (file_exists(APPPATH.'models/Common.php'))
        {
            $this->load->model('common');
        }
        $levelTiele = oo::cfg('lang')['lang_level'];
        $this->level_title = array_merge(["关卡"],array_values($levelTiele),['图标ID','体力奖励','金币奖励','上传卡片']);
    }

    public function index(){
        $avatarTable = otable::avatarConfig();
        $avatarList = oo::commonOprDb('slavedb')->getAll("select * from {$avatarTable} ");

        $themeTable = otable::cardgroup_limit_theme_config();
        $themeList = oo::commonOprDb('slavedb')->getAll("select * from {$themeTable} ");
        $data = [
            'statusMap' => $this->statusMap,
            'randomMap' => $this->randomMap,
            'avatarTypes' => $this->avatarTypes,
            'avatarList' => $avatarList,
            'themeList' => array_column($themeList, 'theme_res', 'id'),
        ];

        $this->load->view('avatarBox/index', $data);
    }

    public function editAvatarBox($id = 0){
        $avatarTable = otable::avatarConfig();
        $avatar = oo::commonOprDb('slavedb')->getOne("select * from {$avatarTable} where avatar_id=".intval($id));

        $themeTable = otable::cardgroup_limit_theme_config();
        $themeList = oo::commonOprDb('slavedb')->getAll("select * from {$themeTable} ");
        $data = [
            'statusMap' => $this->statusMap,
            'randomMap' => $this->randomMap,
            'avatarTypes' => $this->avatarTypes,
            'avatar' => $avatar,
            'themeList' => array_column($themeList, 'theme_res', 'id'),
        ];
        $this->load->view('avatarBox/edit', $data);
    }

    public function saveAvatarBox(){
        $avatarTable = otable::avatarConfig();
        $params = $this->input->post();
        $params['id'] = intval($params['id']);
        $replacement = array(
            "\r\n" => '',
            "\r" => '',
            "\n" => '',
            " " => '',
            " " => '',
        );
        foreach ($params as $k => $v){
            if(!is_scalar($v))continue;
            $v = strtr($v, $replacement);
            $params[$k] = addslashes(trim($v));
        }
        // 校验头像框名称是否重复
        $this->checkRepeat($params);

        if(empty($params['id'])){
            $sql = "insert {$avatarTable} (`name`,`active`,`type`,`theme_id`,`is_random`) values ('{$params['name']}','{$params['active']}','{$params['type']}','{$params['theme_id']}','{$params['is_random']}')";
        }else{
            $sql = "update {$avatarTable} set `name`='{$params['name']}',`active`='{$params['active']}',`type`='{$params['type']}',`theme_id`='{$params['theme_id']}',`is_random`='{$params['is_random']}' where avatar_id=".$params['id'];
        }
        $res = oo::commonOprDb('games')->query($sql);
        if($res){
            $avatarKey = okeys::avatarConfig();
            oo::commonOprRedis('games')->delete($avatarKey);

            $avatarList = oo::commonOprDb('slavedb')->getAll("select * from {$avatarTable} ");

            $filename = 'AvatarBoxConfig' . time() . '.json';
            oo::commonOprModel("json")->SaveJson($avatarList, $filename);
            oo::commonOprModel("json")->setStaticConfig("AvatarBoxConfig", $filename);

            $this->response(1, '保存成功');
        }
        $this->response(-1, '保存失败');
    }

    private function checkRepeat($params){
        $avatarTable = otable::avatarConfig();
        $sql = "select * from {$avatarTable} where `name`='{$params['name']}' ";
        if(!empty($params['id']))$sql .= " and avatar_id <>{$params['id']}";
        $repeatRecords = oo::commonOprDb('games')->getAll($sql);
        if (!empty($repeatRecords)) $this->response(-1, '保存失败,头像框名称重复:'.$params['name'], $repeatRecords);
    }
}
