<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/**
 * 配置相关
 */
class Community extends MY_Controller
{
    # 涂色小游戏投票数据
    public function paintVote(){
        $uid = get_cookie('uid') ?? 0;
        $list = SvenModel::voteList(0, $uid, 3000);
        $data = [
            'title' => '涂色小游戏数据',
            'list' => $list,
            'uid' => $uid ? '' : $uid,
            'headerTable' => $this->paintVoteColumns(),
            'exportUrl' => 'community/paintVoteExport',
        ];
        $this->load->view('community/paintVote', $data);
    }
    public function paintVoteExport(){
        $uid = get_cookie('uid') ?? 0;
        $list = SvenModel::voteList(0, 0, 3000);
        $headers = $this->paintVoteColumns();
        foreach ($headers as $k => $t){
            $headers[$k] = $t['name'];
        }
        $this->exportData($headers, $list, '涂色小游戏投票排名数据');
    }
    private function paintVoteColumns(){
        return [
            'uid' => ['name' => 'UID'],
            'img' => ['name' => '上传图', 'type' => 'image'],
            'votes' => ['name' => '票数'],
            'rank' => ['name' => '排名'],
            'created_time' => ['name' => '上传时间'],
        ];
    }
    public function views(){
        $type = get_cookie('type') ?? '';
        $socialTbl = otable::socialActTable();
        $types = oo::commonOprDb('report')->getAll("select type from {$socialTbl} group by type");
        $data = oo::commonOprDb('report')->getAll("select * from {$socialTbl} where type='{$type}' order by date asc");
        $header = [];
        foreach ($data as $k =>$datum){
            $dataContent = json_decode($datum['data'], true);
            $headerTmp = array_keys($dataContent);
            if (count($headerTmp) > count($header)){
                $header = $headerTmp;
            }
            $data[$k]['data'] = $dataContent;
        }
        $uids = oo::commonOprRedis('games')->sMembers(okeys::fansActKey('JOIN_USERS'));
        $this->load->view('community/views', [
            'type' => $type,
            'list' => $data,
            'header' => $header,
            'types' => $types,
            'uids' => implode(',', $uids),
        ]);
    }
    public function export(){
        $type = get_cookie('type') ?? '';
        $socialTbl = otable::socialActTable();
        $types = oo::commonOprDb('report')->getAll("select type from {$socialTbl} group by type");
        $data = oo::commonOprDb('report')->getAll("select * from {$socialTbl} where type='{$type}' order by date asc");
        $header = [];
        foreach ($data as $k =>$datum){
            $dataContent = json_decode($datum['data'], true);
            $headerTmp = array_keys($dataContent);
            if (count($headerTmp) > count($header)){
                $header = $headerTmp;
            }
            $data[$k] = array_merge($datum, $dataContent);
        }
        array_unshift($header, 'date');
        $header = array_combine($header, $header);
        $this->exportData($header, $data, '社区活动数据-'.$type);
    }
    public function exportUids(){
        $header = [
            'uid' => 'uid',
        ];
        $uids = oo::commonOprRedis('games')->sMembers(okeys::fansActKey('JOIN_USERS'));
        $data = [];
        foreach ($uids as $uid){
            $data[] = [
                'uid' => $uid,
            ];
        }
        $this->exportData($header, $data, '社区活动参与用户');
    }
}