<?php


defined('BASEPATH') OR exit('No direct script access allowed');
/**
 * Created by liqx.
 * User: Administrator
 * Date: 2018/1/31
 * Time: 11:35
 */
class Notice extends MY_Controller
{
//['TH'=>"泰国",'DE'=>"德国",'BR'=>"巴西",'FR'=>"法国",'US'=>"美国",'IN'=>"印度",'RO'=>"罗马尼亚",'GB'=>"英国",'IT'=>"意大利",'ES'=>"西班牙",'BE'=>"比利时",'VN'=>"越南",'NO'=>"挪威"];
    public function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->helper('cookie');
        $this->load->library('curl');
        $this->load->library('pagination');
        //请求地址
        $this->env = get_cookie($this->_wenenv);
        $this->_url = $this->config->item('officialUrl');

    }

    public function msgModel($type){
        $arr['buyVip'] = [
            "type"=>"buyVip",
            "content"=>[
                'ZH'=> '恭喜! {0}成为了尊贵的VIP',
                'TW'=> '恭喜! {0} 成為了尊貴的VIP',
                'EN'=> 'Congratulations! {0} became the VIP!',
                'FR'=> 'Félicitations ! {0} a devenu VIP!',
                'DE'=> 'Glückwunsch! {0} wurde der VIP!',
            ],
            'conf'=>["status"=>1]
        ];
        $arr['getCard'] = [
            "type"=>"getCard",
            "content"=>[
                'ZH'=> '哇！{0}获得了一张小丑卡！',
                'TW'=> '哇！{0}獲得了一張小丑卡！',
                'EN'=> 'Amazing! {0} got a Joker Card!',
                'FR'=> 'Parfait ! {0} gagne une Carte Joker !',
                'DE'=> 'Toll! {0} hat eine Joker-Karte bekommen!',
            ],
            'conf'=>["status"=>1]
        ];
        $arr['fulCardGroup'] = [
            "type"=>"fulCardGroup",
            "content"=>[
                'ZH'=> '恭喜！{0}集齐了{1}卡组！',
                'TW'=> '恭喜！{0}集齊了{1}卡組！',
                'EN'=> 'Congratulations! {0} completed the {1} set!',
                'FR'=> 'Félicitations ! {0} complète {1} set !',
                'DE'=> 'Glückwunsch! {0} hat das Set {1} vervollständigt!',
            ],
            'conf'=>["status"=>1]
        ];
        $arr['getMaxSpins'] = [
            "type"=>"getMaxSpins",
            "content"=>[
                'ZH'=> '太棒了！{0}在{2}中获得了{1}体力！',
                'TW'=> '太棒了！{0}在{2}中獲得了{1}體力！',
                'EN'=> 'Awesome! {0} won {1} spins in {2}!',
                'FR'=> 'Bravo ! {0} gagne {1} tours sur {2}!',
                'DE'=> 'Bravo! {0} hat {1} Drehungen im {2} gewonnen!',
            ],
            'conf'=>["maxSpins"=>1000,"status"=>1]
        ];
        $arr['buyCrazyPass']=[
            "type"=>"buyCrazyPass",
            "content"=>[
                'ZH'=> '{0} 购买了疯狂通行证',
                'TW'=> '{0} 購買了瘋狂通行證',
                'EN'=> '{0} purchased Crazy Pass',
                'FR'=> '{0} a acheté le Crazy Pass',
                'DE'=> '{0} hat Verrückten Pass gekauft',
            ],
            'conf'=>["status"=>1]
        ];
        return $arr[$type];
    }

    public function index(){
        foreach (['buyVip','getCard','fulCardGroup','getMaxSpins','buyCrazyPass'] as $type ){
            $this->setNoticeMsg($this->msgModel($type));
        }
        $list = $this->getAllNoticeMsg();
        echo "<pre>";
        var_dump($list);
//        $this->load->view('activity/index', $list);
    }

    /**
     * Notes:设置跑马灯消息配置
     * User: wsc
     * Time: 2021/1/20 15:28
     * @param $data
     * @return mixed
     */
    public function setNoticeMsg($data){
        $type = $data['type'];
        $tb = otable::noticeMsg();
        $saveData['type'] = $type;
        $saveData['conf'] = json_encode($data['conf'],256);
        $saveData['content'] = str_replace("\/", "/", json_encode($data['content'],256));
        if(!empty($this->getNoticeMsgByType($type))){
            unset($saveData['type']);
            $sql = funs::db_updateSQL($tb,$saveData," type='{$type}'");
        }else{
            $sql = funs::db_insertSQL($tb,$saveData);
        }

        $res = oo::commonOprDb('games')->query($sql);
//        echo ($sql);var_dump($res);echo "<br>";
        if($res){
            $this->getNoticeMsgByType($type,true);
        }
        return $res;
    }

    /**
     * Notes:通过类型获取跑马灯配置
     * User: wsc
     * Time: 2021/1/20 15:28
     * @param $type
     * @param bool $db
     * @return array|mixed
     */
    public function getNoticeMsgByType($type,$db=false){
        $key=okeys::noticeMsg();
        $info = oo::commonOprRedis('games')->hGet($key,$type);
        if(empty($info)||$db){
            $tb = otable::noticeMsg();
            $sql = "SELECT * FROM {$tb} where type ='{$type}'";
            $data = oo::commonOprDb('slavedb')->getOne($sql,1);
            if(!empty($data)){
                $arr['type'] = $data['type'];
                $arr['conf']=json_decode($data['conf'],true);
                $arr['content']=json_decode($data['content'],true);
                $info = str_replace("\/", "/", json_encode($arr,256));
                oo::commonOprRedis('games')->hSet($key,$type,$info);
            }
        }
        return !empty($info)?json_decode($info,true):[];
    }

    /**
     * Notes:获取所有跑马灯消息配置
     * User: wsc
     * Time: 2021/1/20 15:29
     * @param bool $db
     * @return array
     */
    public function getAllNoticeMsg($db=false){
        $key=okeys::noticeMsg();
        $list = oo::commonOprRedis('games')->hGetAll($key);
        if(empty($list)||$db){
            $tb = otable::noticeMsg();
            $sql = "SELECT * FROM {$tb}";
            $data = oo::commonOprDb('slavedb')->getAll($sql,1);
            if(!empty($data)){
                foreach ($data as $v){
                    $v['conf']=json_decode($v['conf'],true);
                    $v['content']=json_decode($v['content'],true);
                    $list[$v['type']] = str_replace("\/", "/", json_encode($v,256));
                }
                oo::commonOprRedis('games')->hMset($key,$list);
            }
        }
        $retData = !empty($list)?funs::getArrFromJsonArr($list):[];
        $filename = "NoticeMsg".time().".json";
        $res =$this->SaveJson($retData,$filename);
        if($res){
            oo::commonOprModel('json')->setStaticConfig("NoticeMsg",$filename);
        }
        return $retData;
    }


}