<?php
defined('BASEPATH') or exit('No direct script access allowed');

/**
 * 指定条件触发奖励
 */
class OptionalChest extends MY_Controller
{
    /**
     * @var array Post 数据
     */
    private $postData;

    public function __construct()
    {
        parent::__construct();

        $this->postData = $this->input->post();
    }

    /**
     * 配置列表
     */
    public function index()
    {
        $tb = otable::optionalChestConfig();
        $list = oo::commonOprDb('games')->getAll("SELECT * from {$tb} WHERE 1");

        $imgContent = oo::commonOprModel('config')->getActiveImgNameConfig("optional_chest", true)['content'];

        $data = [];
        $data['skinList'] = array_column($imgContent, 'type', 'name');
        $data['list'] = $list;

        $this->load->view("optionalChest/index", $data);
    }

    /**
     * 触发奖励配置变动
     */
    public function updateConfig()
    {
        $formData = $this->postData;

        list($ret, $msg) = OptionalChestModel::updateConfig($formData['conf']);
        if ($ret != 0) {
            return $this->response($ret, $msg);
        }

        return $this->response(0, '操作成功');
    }
}
