<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Sven extends CI_Controller
{
    private function nextLine($isHtml = false){
        echo $isHtml ? '<br>' : PHP_EOL;
    }
    private function jsonResponse($code, $msg = 'success', $data = []){
        $data = [
            'code' => $code,
            'msg' => $msg,
            'data' => $data,
        ];
        exit(json_encode($data));
    }

    public function inviteActions(){
        date_default_timezone_set('UTC');
        define("CURRENT_TIMESTAMP", time());
//        if(CURRENT_TIMESTAMP > 1676887200){
//            return $this->jsonResponse(__LINE__, 'The event has ended.');
//        }
        $post = $_REQUEST;
//        jsonDump($post);
        oo::logs()->debug3(["postData"=>$post],"inviteActions.log");
        if (empty($post['action'])){
            return $this->jsonResponse(__LINE__, 'Wrong operation！');
        }
        $table = otable::adBoard();
        $key = okeys::adActions('getCrazyFox3');
        $data = [];

        // 记录活动参与人数 活动结束之后需手动删除
        if(!empty($post['uid'])) {
            oo::commonOprRedis('games')->sAdd(okeys::fansActKey("JOIN_USERS"), $post['uid']);
            oo::commonOprRedis('games')->expire(okeys::fansActKey("JOIN_USERS"), 86400 * 15);
        };
        try {
            if(!empty($post['mod'])){
                $data = SvenModel::runInviteAction($post['mod'], $post['action'], $post);
            }else{
                switch ($post['action']){
                    case 'getInfo':
                        $beginTime = intval($post['beginTime']);
                        if (empty($post['token']) || empty($beginTime)){
                            $this->jsonResponse(__LINE__, 'Wrong operation！');
                        }
                        $beginDate = date('Y-m-d', $beginTime);
                        $installCnt = 0;
                        $sql = "select * from ".otable::TAdjust()." where `trackers_channel_token`='{$post['token']}' and `date` >= '{$beginDate}' ";
                        $installRecords = oo::commonOprDb('report')->getAll($sql);
                        foreach ($installRecords as $installRecord){
                            $kpi = json_decode($installRecord['kpi_values'], true) ?? [];
                            $installCnt += intval($kpi[1]);
                        }
                        $cntData = oo::commonOprRedis('statistics')->hGetAll($key);
                        $cntData['installCnt'] = $installCnt;
                        $cntData['boards'] = oo::commonOprDb('report')->getAll("select * from {$table} where `time`>{$beginTime} order by id desc limit 200");
                        $this->jsonResponse(0, '获取成功', $cntData);
                        break;
                    case 'share':
                    case 'install':
                    case 'download':
                        oo::commonOprRedis('statistics')->hIncrBy($key, $post['action'].'Cnt', 1);
                        $this->jsonResponse(0);
                        break;
                    case 'submitBoard':
                        if (empty($post['uid']) || empty($post['content'])){
                            $this->jsonResponse(__LINE__, 'Wrong operation！');
                        }
                        $insertData = [
                            'uid' => $post['uid'],
                            'content' => $post['content'],
                            'time' => time(),
                        ];
                        $sql = funs::db_intsertArrSQL($table, [$insertData]);
                        $res = oo::commonOprDb('report')->query($sql);
                        if ($res)$this->jsonResponse(0, '提交成功', $insertData);
                        $this->jsonResponse(__LINE__, '提交失败');
                    case 'getUserInfoByFbuid':
                        if(empty($post['fbuid']))$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $siteuid = $post['fbuid'];
                        $tb = otable::taccount($siteuid);
                        $sql = "select siteuid, uid, createtime from {$tb} where siteuid='{$siteuid}' limit 1";
                        $row = oo::commonOprDb('slavedb')->getOne($sql,1);

                        if (empty($row['uid']))$this->jsonResponse(__LINE__, 'Your FB account is not yet linked to Crazy Fox. Please log in the game and link your account before proceeding.');
//                        if(!empty($row['uid'])){
//                            SvenModel::setFirstLogin($row['uid']);
//                        }
                        $tb = otable::userinfo();
                        $sql = "select * from {$tb} where uid='{$row['uid']}' limit 1";
                        $row = oo::commonOprDb('slavedb')->getOne($sql,1);
                        $this->jsonResponse(0, 'success', $row);
                        break;
                    case 'uploadImage':
                        // 校验参数
                        if(empty($post['actName']) || empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');

//                是否有记录
                        if(SvenModel::isSubmitPaint($post['uid']))$this->jsonResponse(__LINE__, 'You have already submitted your art.');

//                获取上传文件
                        $file = $this->getUploadFile('public/images/'.$post['actName']);
                        if($file['state'] != 'SUCCESS')$this->jsonResponse(__LINE__, 'File upload failed:'.$file['state']);

//                生成记录
                        if(!SvenModel::savePaint($file, $post))$this->jsonResponse(__LINE__, 'You have already submitted your art.');

                        break;
                    case 'voteData':
                        if(empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $data = SvenModel::getVoteData($post['uid'], date('Y-m-d'));
                        break;
                    case 'shareBak':
                        $uid = intval($post['uid']);
                        if(empty($uid) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $msg = SvenModel::share($uid);
                        $data = SvenModel::user214Info($uid);
                        $data['alertCnt'] = 0;
                        if($data['scoreInfo']['total_score'] >= 50){
                            $date = date('Ymd', CURRENT_TIMESTAMP);
                            $key = okeys::config214($post['uid']);
                            $data['alertCnt'] = oo::commonOprRedis('games')->hIncrBy($key, 'SCORE_OVER_50', 1);
                        }
                        if($msg !== true)$this->jsonResponse(__LINE__, $msg, $data);
                        break;
                    case 'vote':
                        if(empty($post['touid']) || empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $msg = SvenModel::vote($post['uid'], $post['touid']);
                        $data = SvenModel::getVoteData($post['uid'], date('Y-m-d'));
                        if($msg !== true)$this->jsonResponse(__LINE__, $msg, $data);
                        break;
                    case 'voteList':
                        $offset = intval($post['offset']);
                        $list = SvenModel::voteList($offset, $post['uid']);
                        $data = [
                            'list' => $list
                        ];
                        break;
                    case 'initData':
                        $uid = intval($post['uid']);
                        if(empty($uid ))$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $num = SvenModel::christmasInviteNum($uid);

                        $key = okeys::christmasInviteReward($uid);
                        $collectedNums = oo::commonOprRedis('statistics')->sMembers($key);
                        $data = [
                            'num' => $num,
                            'collectedNums' => $collectedNums,
                        ];
                        break;
                    case 'christmasInviteNum':
                        if(empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $num = SvenModel::christmasInviteNum($post['uid']);
                        $data = [
                            'num' => $num
                        ];
                        break;
                    case 'christmasCards':
                        if(empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $list = SvenModel::christmasCards($post['uid']);
                        $data = [
                            'list' => $list
                        ];
                        break;
                    case 'christmasCardDetail':
                        if(empty($post['cardId']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $cardDetail = SvenModel::christmasCardDetail($post['cardId']);
                        $data = [
                            'cardDetail' => $cardDetail
                        ];
                        break;
                    case 'getInviteReward':
                        if(empty($post['uid']) ||empty($post['inviteNum']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $cardDetail = SvenModel::getInviteReward($post['uid'], $post['inviteNum']);
                        $data = [
                            'errorCode' => $cardDetail
                        ];
                        break;
                    case 'saveCard':
                        if(empty($post['uid'])
                            ||empty($post['bgid'])
                            ||empty($post['to'])
                            ||empty($post['from'])
                            ||empty($post['content'])
                        ){
                            oo::logs()->commlog(["postData"=>$post,"err"=>"Wrong operation 2！"],"errAct");
                            $this->jsonResponse(__LINE__, 'Wrong operation！');
                        }
                        $res = SvenModel::saveCard($post);
                        $data = [
                            'cardId' => $res
                        ];
                        break;
                    case 'sharePage':
                        if(empty($post['uid']))$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $res = SvenModel::sharePage($post['uid']);
                        $data = [
                            'shareTimes' => $res
                        ];
                        break;
                    case 'getUserAnnualReport':
                        if(empty($post['uid']))$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $userinfo = SvenModel::getUserAnnualReport($post['uid']);
                        $data = [
                            'userinfo' => $userinfo
                        ];
                        break;
                    case 'loginFB':
                        if(empty($post['uid']))$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $shareTimesKey = okeys::annualReportLogin();
                        oo::commonOprRedis('statistics')->hIncrBy($shareTimesKey, $post['uid'] , 1);
                        oo::commonOprRedis('statistics')->expireAt($shareTimesKey, strtotime('2023-02-01'));
                        break;
                    case 'init214':
                        $data['initInfo'] = SvenModel::init214($post['uid']);
                        $data['userInfo'] = SvenModel::user214Info($post['uid']);
                        break;
                    case 'load214rank':
                        $data['rankList'] = SvenModel::load214rank(intval($post['offset']));
                        break;
                    case 'updateUser214Score':
                        oo::logs()->debug3($post,"214request.log");
                        SvenModel::updateUser214Score(intval($post['uid']), intval($post['moreScore']));
//                $data['initInfo'] = SvenModel::init214($post['uid']);
                        $data['userInfo'] = SvenModel::user214Info($post['uid']);
                        $data['alertCnt'] = 0;
                        if($data['userInfo']['scoreInfo']['total_score'] >= 50){
                            $date = date('Ymd', CURRENT_TIMESTAMP);
                            $key = okeys::config214($post['uid']);
                            $data['alertCnt'] = oo::commonOprRedis('games')->hIncrBy($key, 'SCORE_OVER_50', 1);
                        }
                        break;
                    case 'easterUserData':
                        if(empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $userData = SvenModel::userEasterInfo($post['uid']);
                        $utable = otable::userinfo();
                        $table = otable::easterInviterRecord();
                        $sql = "select * from {$utable} where uid={$post['uid']}";
                        $userinfo = oo::commonOprDb('slavedb')->getOne($sql, 1);

                        // 自己邀请的用户
                        $sql = "select * from {$table} where inviter={$post['uid']}";
                        $records = oo::commonOprDb('report')->getAll($sql, 1);
                        $userData['invitee'] = implode(',', array_column($records, 'uid'));

                        // 通过注册时间判断是否是新用户
                        $userData['isNewer'] = $userinfo['createtime'] >= 1681205064 ? 1 : 0;//2023-04-11 17:24:24 北京时间
                        if($userData['isNewer']){ // 是新用户的情况下判断是否 绑定邀请关系
                            $sql = "select * from {$table} where uid={$post['uid']}";
                            $record = oo::commonOprDb('report')->getOne($sql, 1);
                            if(!empty($record))$userData['isNewer'] = 0;// 如果绑定邀请关系，则认为不是新用户
                        }
                        $data['data'] = $userData;
                        break;
                    case 'getEasterEggs':
                        if(empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $date = date('Ymd',CURRENT_TIMESTAMP);
                        $eggs = [
                            'right' => [
                                'ids' => [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20],
                                'dir' => 'eggs',
                                'limit' => 1,
                            ],
                            'error' => [
                                'ids' => [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40],
                                'dir' => 'noeggs',
                                'limit' => 2,
                            ]
                        ];
                        $cards = [];
                        foreach ($eggs as $eggType => $eggItem){
                            $usedEggsKey = okeys::fansActKey("{$eggType}:USED:{$post['uid']}:{$date}");
                            $usedEggs = oo::commonOprRedis('games')->sMembers($usedEggsKey);
                            $unusedEggs = array_diff($eggItem['ids'], $usedEggs);
                            if(count($unusedEggs) < $eggItem['limit']){
                                $unusedEggs = $eggItem['ids'];
                            }
                            $data['$unusedEggs'][$eggType] = $unusedEggs;
                            $cardIdxes = array_rand($unusedEggs, $eggItem['limit']);
                            if(!is_array($cardIdxes))$cardIdxes = [$cardIdxes];
                            foreach ($cardIdxes as $cardIdx){
                                oo::commonOprRedis('games')->sadd($usedEggsKey, $unusedEggs[$cardIdx]);
                                $cards[] = [
                                    'dir' => $eggItem['dir'],
                                    'className' => $eggType . '-item',
                                    'id' =>  $unusedEggs[$cardIdx],
                                ];
                            }

                            oo::commonOprRedis('games')->expire($usedEggsKey, 86400 * 10);
                        }
                        $data['cards'] = $cards;
                        break;
                    case 'answerError':
                    case 'chooseReward':
                        if(empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        switch ($post['action']){
                            case 'answerError':$actType = 'errorTimes';break;
                            case 'share':$actType = 'shareTimes';break;
                            case 'chooseReward':
                                $actType = 'rightTimes';
                                if(empty($post['rewardType']) || !in_array($post['rewardType'],  [1, 2]))$this->jsonResponse(__LINE__, 'Wrong operation！');
                                SvenModel::chooseEasterReward($post['uid'], $post['rewardType']);
                                break;
                        }
                        $date = date('Ymd',CURRENT_TIMESTAMP);
                        $userDataKey = okeys::fansActKey("USER_DATA:{$post['uid']}:{$date}");
                        oo::commonOprRedis('games')->hIncrBy($userDataKey, $actType, 1);
                        $userData = SvenModel::userEasterInfo($post['uid']);
                        $data['data'] = $userData;
                        break;
                    case 'setInviterUid':
                        if(empty($post['uid']) || empty($post['inviterUid']))$this->jsonResponse(__LINE__, 'Wrong operation！');
                        SvenModel::setInviterRecord($post['uid'], $post['inviterUid']);
                        $userData = SvenModel::userEasterInfo($post['uid']);
                        $data['data'] = $userData;
                        break;
                    case 'rewardsRecords':
                        if( empty($post['uid']) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $data['data'] = SvenModel::rewardsRecord($post['uid']);;
                        break;
                    case 'collectReward':
                        $uid = intval($post['uid']);
                        $id = intval($post['id']);
                        if( empty($uid) || empty($id) )$this->jsonResponse(__LINE__, 'Wrong operation！');
                        $res = SvenModel::collectReward($uid, $id);
                        if(!$res)$this->jsonResponse(__LINE__, 'Wrong operation！');
                        break;
                    default:
                        $model = new SvenModel();
                        if(!method_exists($model, $post['action']))$this->jsonResponse(__LINE__, 'Wrong operation！', $post);
                        $data = $model->{$post['action']}($post);
                }
            }
        }catch (\throwable $e){
            oo::logs()->debug3(["response"=>$data, 'request' =>$post],"inviteActions.log");
            $this->jsonResponse($e->getCode(), $e->getMessage(), $data);
        }
        oo::logs()->debug3(["response"=>$data, 'request' =>$post],"inviteActions.log");
        $this->jsonResponse(0, 'success', $data);
    }

    private function divideName($name){
        $nameArr = explode(' ', $name);
        $firstName = array_shift($nameArr);
        return [$firstName, implode(' ', $nameArr)];
    }

    private function getUploadFile($savePath){
        $config = array(
            'savePath' => $savePath,//,             //存储文件夹
            'maxSize'  => 1024*50,                   //允许的文件最大尺寸，单位KB
            'allowFiles' => array('.png','.gif','.bmp', '.jpeg','.jpg')  //允许的文件格式
        );
        $this->load->library('uploader', $config);
        return $this->uploader->getFileInfo();
    }
    function __construct()
    {
        parent::__construct();
        $this->load->library('curl');
        $this->load->model('common');
        $this->load->model('oo');

        $config = array(
            'savePath' => 'Excel/uploads',             //存储文件夹
            'maxSize'  => 1024*5,                   //允许的文件最大尺寸，单位KB
            'allowFiles' => array('.xls','.xlsx','.csv')  //允许的文件格式
        );
        $this->load->library('uploader', $config);
    }

    private function getImportData($file): array
    {
        ini_set('memory_limit', -1);
        $extensionType = $this->getExtensionType($file);
        $xlsReader = IOFactory::createReader($extensionType);
        $xlsReader->setReadDataOnly(true);
        $xlsReader->setLoadSheetsOnly(true);
        $Sheets = $xlsReader->load($file);
        $sheetsCnt = $Sheets->getSheetCount();
        $dataArray = [];
        for($i=0 ; $i< $sheetsCnt; $i++){
            $tmpData = $Sheets->getSheet($i)->toArray() ?? [];
            foreach ($tmpData as $k => $item){
                foreach ($item as $k1 => $value){
                    $item[$k1] = trim($value);
                }
                $line = array_filter($item);
                if(empty($line))unset($tmpData[$k]);
            }
            $dataArray[$i] = $tmpData;
        }
        return $dataArray;

    }

    public function index()
    {
        $payInfo = oo::commonOprRedis('Statistics')->hMGet('svenx',['a','b','e']);
        echo json_encode($payInfo);
    }
    public function getLogs()
    {
        $time = time();
        $uidStr = '<951813><494305><1401879><435278><1007017><2665223><2665192><2208752><1200954><1543816><2634229><1774431><2095582><186243><1285671><2667515><1873305><1159505><502829><1896134><1359899><732663><130523><189650><1079916><2195057><2337151><2153158><2666290><1956383><275359><420528><2170720><2027441><424679><1860742><1706229><1548223><2665333><2307319><1067618><2510512><2101837><1599260><2668489><499945><2541888><1888542><2599527><1888542><2663256><585620><557341><2339980><510269><2201595><1502959><1233865><420782><498884><1011259><1019211><2051591>';
        $uidStr = strtr($uidStr, ['><'=>',', '<' => '', '>' =>'']);
        $logRootPath = 'deBUG/clientErrorLogFiles/';
        $uids = explode(',', $uidStr);
        $beginDate = '20211209';
        $endDate = date('Ymd', $time);
        $beginTime = strtotime($beginDate);
        $endTime = max(strtotime($endDate), $beginTime);
        for($tmpTime = $beginTime; $tmpTime <= $endTime; $tmpTime += 86400){
            $tmpDate = date('Ymd', $tmpTime);
            foreach ($uids as $uid){
                $logPath = $logRootPath . "{$tmpDate}/{$uid}";
                if(!is_dir($logPath)){
                    echo "--------dir not found for uid:{$uid}, date:{$tmpDate}" . PHP_EOL;
                    continue;
                }

                $dirHandle = opendir($logPath);
                while($file = readdir($dirHandle)){
                    if(strpos($file, $uid) === false)continue;
                    echo $logPath . '/'.$file . PHP_EOL;
                }
            }
        }
    }

    public function updateUserShushuGroups(){
        date_default_timezone_set('Asia/Shanghai');
        ini_set('memory_limit', -1);
        if (!class_exists("UserModel")){
            require_once __DIR__ . '/../models/UserModel.php';
        }
        while(true){
            $sleepTime = 1 * 60;   #每1分判断一次
            $time = time();
            $h = date('H', $time);
            $i = date('i', $time);
            if(($h == 18 && $i >= 10) || ($h > 18)){
                if($this->checkRefreshStatus()){
                    try {
                        $this->updateGroups();
                    }catch (\throwable $e){
                        oo::logs()->debug3('数数分组更新异常：'.$e->getMessage(), 'updateShushuGroups.log');
                    }
                }else{
                    oo::logs()->debug3('数数方分组更新未完成', 'updateShushuGroups.log');
                    $sleepTime = 10;   # 未更新，每10秒判断一次
                }
            }else{
                oo::logs()->debug3('未到时间，不做处理', 'updateShushuGroups.log');
            }
            sleep($sleepTime);
        }
    }
    public function updateGroupsTemp($token){
        if ($token != 'temp')return;
        date_default_timezone_set('Asia/Shanghai');
        ini_set('memory_limit', -1);
        oo::logs()->debug3('拉取数数方最新分组用户开始;', 'updateShushuGroupsTemp.log');
        $config = oo::commonOprModel('config')->getUserGroupConfigByCid(5);
        //需要每日更新的分组
        $updateGroups = oo::commonOprRedis('statistics')->hgetall(okeys::configSSGroupUpdate());
        $updateGroupsIds = array_keys($updateGroups);
        $uidGroupsNewerList = [];
        $validGroups = [];
        $activeUids = UserModel::getActiveUids();
        oo::logs()->debug3('30日活跃用户数：'.count($activeUids), 'updateShushuGroupsTemp.log');
        oo::logs()->debug3('总分组数：'.count($config), 'updateShushuGroupsTemp.log');
        foreach ($config as $idx => $v){
            if($v['groupId'] == 0 || $v['name'] == '数数-默认分组'){
                continue;
            }
            if(!in_array($v['id'], $updateGroupsIds))continue;
            oo::logs()->debug3('分组索引：'.$idx . ':::'.json_encode($v), 'updateShushuGroupsTemp.log');
            $validGroups[$v['id']] = $v['name'];
            $uidList = oo::commonOprModel('SSdata')->getUidListByGroupName($v['name']);
            if(!empty($uidList)){
                $uidList = array_intersect($uidList, $activeUids);
                oo::logs()->debug3('分组活跃用户数：' . count($uidList), 'updateShushuGroupsTemp.log');
                foreach ($uidList as $uid){
                    $uidGroupsNewerList[$uid] = $uidGroupsNewerList[$uid] ?? [];
                    $uidGroupsNewerList[$uid][] = $v['id'];
                }
            }
        }
        unset($activeUids);
        oo::logs()->debug3('拉取数数方最新分组用户完毕；开始计算用户最新分组', 'updateShushuGroupsTemp.log');
        oo::logs()->debug3('拉取的数数分组列表：'.json_encode($validGroups), 'updateShushuGroupsTemp.log');
        oo::logs()->debug3('重新分组用户数：'.count($uidGroupsNewerList), 'updateShushuGroupsTemp.log');

        foreach ($uidGroupsNewerList as $uid => $groupsNew){
//            $debugData[$uid] = [
//                'new' => implode(',', $groupsNew)
//            ];
            $removeGroups = [];
            $userData = oo::commonOprModel('member')->getUserDynamicsData($uid);
            $groupsOld = empty($userData['groupId3']) ? [] : explode(',', $userData['groupId3']);
            sort($groupsOld);
//            $debugData[$uid]['old'] = implode(',', $groupsOld);
            foreach ($updateGroupsIds as $groupId){    #遍历用户新的分组
                if(!in_array($groupId, $groupsNew)){  # 如果用户最新分组数据不在分组里，从老的分组删除该分组
                    $removeGroups[] = $groupId;
                    $idx = array_search($groupId,$groupsOld);
                    if($idx !== false)unset($groupsOld[$idx]);
                }
            }
            $groupsNew = array_merge($groupsOld, $groupsNew);
            $groupsNew = array_filter(array_unique($groupsNew));
            sort($removeGroups);
            sort($groupsNew);
//            $debugData[$uid]['removed'] = implode(',', $removeGroups);
//            $debugData[$uid]['newest'] = implode(',', $groupsNew);

            $userData['groupId3'] = implode(',', $groupsNew);
            oo::commonOprModel('member')->setUserDynamicsDataV2($uid, $userData);
            oo::logs()->debug3($uid.':'.$userData['groupId3'], 'userNewestSSGroups.log');
        }
        oo::logs()->debug3('用户数数分组数据更新结束', 'updateShushuGroupsTemp.log');
    }
    private function updateGroups(){
        $time = time();
        $isUpdatedKey = okeys::shushuGroupUpdateCompleteKey(date('Ymd', $time));
        $isUpdated = oo::commonOprRedis('statistics')->get($isUpdatedKey);
        if($isUpdated){ #已更新，不做处理
           oo::logs()->debug3('今日分组更新已完成', 'updateShushuGroups.log');
            return true;
        }

        oo::logs()->debug3('拉取数数方最新分组用户开始;', 'updateShushuGroups.log');
        $config = oo::commonOprModel('config')->getUserGroupConfigByCid(5);
        //需要每日更新的分组
        $updateGroups = oo::commonOprRedis('statistics')->hgetall(okeys::configSSGroupUpdate());
        $updateGroupsIds = array_keys($updateGroups);
        $uidGroupsNewerList = [];
        $validGroups = [];
        $activeUids = UserModel::getActiveUids();
        oo::logs()->debug3('30日活跃用户数：'.count($activeUids), 'updateShushuGroups.log');
        foreach ($config as $v){
            if($v['groupId'] == 0 || $v['name'] == '数数-默认分组'){
                continue;
            }
            if(!in_array($v['id'], $updateGroupsIds))continue;
            $validGroups[$v['id']] = $v['name'];
            $uidList = oo::commonOprModel('SSdata')->getUidListByGroupName($v['name']);
            if(!empty($uidList)){
                $uidList = array_intersect($uidList, $activeUids);
                foreach ($uidList as $uid){
                    $uidGroupsNewerList[$uid] = $uidGroupsNewerList[$uid] ?? [];
                    $uidGroupsNewerList[$uid][] = $v['id'];
                }
            }
        }
        unset($activeUids, $uidList);
        oo::logs()->debug3('拉取数数方最新分组用户完毕；开始计算用户最新分组', 'updateShushuGroups.log');
        oo::logs()->debug3('拉取的数数分组列表：'.json_encode($validGroups), 'updateShushuGroups.log');
        oo::logs()->debug3('重新分组用户数：'.count($uidGroupsNewerList), 'updateShushuGroups.log');
//        $debugData = [];
        foreach ($uidGroupsNewerList as $uid => $groupsNew){
//            $debugData[$uid] = [
//                'new' => implode(',', $groupsNew)
//            ];
            $removeGroups = [];
            $userData = oo::commonOprModel('member')->getUserDynamicsData($uid);
            $groupsOld = empty($userData['groupId3']) ? [] : explode(',', $userData['groupId3']);
            sort($groupsOld);
//            $debugData[$uid]['old'] = implode(',', $groupsOld);
            foreach ($updateGroupsIds as $groupId){    #遍历用户新的分组
                if(!in_array($groupId, $groupsNew)){  # 如果用户最新分组数据不在分组里，从老的分组删除该分组
                    $removeGroups[] = $groupId;
                    $idx = array_search($groupId,$groupsOld);
                    if($idx !== false)unset($groupsOld[$idx]);
                }
            }
            $groupsNew = array_merge($groupsOld, $groupsNew);
            $groupsNew = array_filter(array_unique($groupsNew));
            sort($removeGroups);
            sort($groupsNew);
//            $debugData[$uid]['removed'] = implode(',', $removeGroups);
//            $debugData[$uid]['newest'] = implode(',', $groupsNew);

            $userData['groupId3'] = implode(',', $groupsNew);
            oo::commonOprModel('member')->setUserDynamicsDataV2($uid, $userData);
            oo::logs()->debug3($uid.':'.$userData['groupId3'], 'userNewestSSGroups.log');
            unset($uidGroupsNewerList[$uid]);
        }
        # 更新完毕，设置已更新标识,存在一天
        oo::commonOprRedis('statistics')->setex($isUpdatedKey, 1);

        oo::logs()->debug3('用户数数分组数据更新结束', 'updateShushuGroups.log');
    }
    private function checkRefreshStatus(){
        # 获取所有数数分组
        $config = oo::commonOprModel('config')->getUserGroupConfigByCid(5);

        #获取需要更新的数数分组id
        $updateGroups = oo::commonOprRedis('statistics')->hgetall(okeys::configSSGroupUpdate());
        $updateGroupsIds = array_keys($updateGroups);
        $progressList = [];
        foreach ($config as $v){
            if($v['groupId'] == 0 || $v['name'] == '数数-默认分组'){
                continue;
            }
            if(!in_array($v['id'], $updateGroupsIds))continue;

            #校验数数方分组刷新进度
            $response = oo::commonOprModel('SSdata')->checkRefreshStatusByGroupName($v['name']);
            if(is_string($response))$response = json_decode($response, true);
            $progressList[$v['name']] = $response['data']['progress'] ?? 0;
            if($progressList[$v['name']] < 100){
                oo::logs()->debug3('用户数数分组数据更新未完成:'.$v['name'], 'updateShushuGroupsRefresh.log');
                return false;    #进度未到100 这当前数数方分组刷新未完成
            }
        }
        return true;
    }
    public function checkScriptStatus(){
        $scriptList = [
            'updateUserShushuGroups' => '更新用户数数分组脚本',
        ];
        foreach ($scriptList as $scriptName => $scriptTitle){
            $num = $this->getProcessNumByName($scriptName);
            if(empty($num))EnWechatModel::feishuNotify("[PHP服务预警]:".$scriptTitle.' 进程不存在', ['管理后台群']);
        }
    }
    public function getProcessNumByName($name = ''){
        if(empty($name))return;
        echo 'params:'.$name;
        $cmd = "ps -aux | grep -v checkScriptStatus|grep -v grep |grep {$name} -c";
        exec($cmd, $result);
        $pNum = current($result);
        return $pNum;
    }

    public function tiktokCallback(){
        $params = $this->input->get();
        oo::commonOprRedis('Statistics')->set(okeys::tiktokParamsKey(), json_encode($params));
    }

    public function getTikTokAuthParams(){
        $params = oo::commonOprRedis('Statistics')->get(okeys::tiktokParamsKey());
        exit($params);
    }

    public function getTikTokAuthToken(){
        $path = "/open_api/v1.2/oauth2/access_token/";
        $url = "https://business-api.tiktok.com" . $path;


        $secret = '196ca870c4aa8a58fb750a51c2b2918d88b60551';
        $app_id = '7068569320179105794';
        $params = oo::commonOprRedis('Statistics')->get(okeys::tiktokParamsKey());
        $auth_code = json_decode($params, true)['auth_code'] ?? '';

        /* Args in JSON format */
        $json_str = sprintf("{\"secret\": \"%s\", \"app_id\": \"%s\", \"auth_code\": \"%s\"}", $secret, $app_id, $auth_code);

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $json_str,
            CURLOPT_HTTPHEADER => array(
                "Content-Type: application/json",
            ),
        ));

        $response = curl_exec($curl);
        curl_close($curl);
        oo::commonOprRedis('Statistics')->set(okeys::tiktokTokenParamsKey(), $response);
        exit($response);

    }


    public function getUserReturns(){
        $datetime = strtotime('2021-11-01');
        $curTime = time();
        $endtime = $curTime - 30 * 86400;
        $userTbl = otable::userinfo();
        $dayAfterArr = [30, 90];
        $data = [];
        while($datetime < $endtime){
            $curDate =  date('Ymd', $datetime);
            echo $curDate . PHP_EOL;
            $fbUids = $guestUids = [];
            $dayStartTime = $datetime;
            $dayEndTime   = $datetime + 86400;
            $sql = "select uid,isFb from {$userTbl} where createtime >={$dayStartTime} and createtime <{$dayEndTime} ";
            $registerUser = oo::commonOprDb('gameslave')->getAll($sql);
            foreach ($registerUser as $user){
                if($user['isFb'])$fbUids[] = $user['uid'];
                else $guestUids[] = $user['uid'];
            }
            $data[$curDate] = [
                'fbCount' => count($fbUids),
                'guestCount' => count($guestUids),
            ];
            $datetime += 86400;
            foreach ($dayAfterArr as $days){
                $afterTime = $dayStartTime + $days * 86400;
                $loginUids = [];
                if($afterTime < ($curTime - 86400)){
                    $afterDate = date('Ymd', $afterTime);
                    $loginTbl = otable::newloginLog($afterDate);
                    $sql = "select uid from {$loginTbl} group by uid";
                    $loginUsers = oo::commonOprDb('report')->getAll($sql);
                    $loginUids = array_column($loginUsers, 'uid');
                }
                $data[$curDate][$days.'FbReturnUids'] = count(array_intersect($fbUids, $loginUids));
                $data[$curDate][$days.'GuestReturnUids'] = count(array_intersect($guestUids, $loginUids));
            }
        }

        $header = [
            '日期', 'FB注册人数', '游客注册人数', '30FB留存', '30游客留存', '90FB留存', '90游客留存'
        ];
        $f = fopen(__DIR__."/留存数据{$curTime}.csv", 'w');
        fputcsv($f, $header);
        foreach ($data as $date => $item){
            $line = [
                $date, $item['fbCount'], $item['guestCount'], $item['30FbReturnUids'], $item['30GuestReturnUids'], $item['90FbReturnUids'], $item['90GuestReturnUids']
            ];
            fputcsv($f, $line);
        }
        fclose($f);
        echo 'ok';
    }
    public function getThUserReturns(){
        $datetime = strtotime('2022-02-01');
        $curTime = time();
        $endtime = $curTime - 2 * 86400;
        $userTbl = otable::registerLog();
        $dayAfterArr = [1, 3, 7];
        $data = [];
        while($datetime < $endtime){
            $curDate =  date('Ymd', $datetime);
            echo $curDate . PHP_EOL;
            $sql = "select uid from {$userTbl} where date ='{$curDate}' and country='TH' ";
            $registerUser = oo::commonOprDb('report')->getAll($sql);
            $uids = array_column($registerUser, 'uid');
            $data[$curDate] = [
                'count' => count($uids),
            ];
            foreach ($dayAfterArr as $days){
                $afterTime = $datetime + $days * 86400;
                $loginUids = [];
                if($afterTime < ($curTime - 86400)){
                    $afterDate = date('Ymd', $afterTime);
                    $loginTbl = otable::newloginLog($afterDate);
                    $sql = "select uid from {$loginTbl} group by uid";
                    $loginUsers = oo::commonOprDb('report')->getAll($sql);
                    $loginUids = array_column($loginUsers, 'uid');
                }
                $ReturnUids = count(array_intersect($uids, $loginUids));
                $data[$curDate][$days.'ReturnUids'] = $ReturnUids;
                $data[$curDate][$days.'ReturnRate'] = empty($ReturnUids) ? 0 : $ReturnUids/count($uids);
            }
//            echo json_encode($data);die;
            $datetime += 86400;
        }

        $header = [
            '日期', '注册人数',  '1留存', '3留存', '7留存',  '1留存率', '3留存率', '7留存率'
        ];
        $f = fopen(__DIR__."/留存数据{$curTime}.csv", 'w');
        fputcsv($f, $header);
        foreach ($data as $date => $item){
            $line = [
                $date, $item['count'],  $item['1ReturnUids'],$item['3ReturnUids'],$item['7ReturnUids'],  $item['1ReturnRate'],$item['3ReturnRate'],$item['7ReturnRate']
            ];
            fputcsv($f, $line);
        }
        fclose($f);
        echo 'ok';
    }

    public function formatOnlineData(){
        date_default_timezone_set('UTC');
        $tbl = otable::staData();
        $timestamp = time();
        $yesterday = date('Ymd', $timestamp - 86400);
        $sql = "select * from {$tbl} where date='{$yesterday}' and type='foxOnlinePlaying' limit 1";
        $yesterdayOnlinePlaying = oo::commonOprDb('statistics')->getOne($sql, 1);
        $onlineData = json_decode($yesterdayOnlinePlaying['data'], true)[1];
        ksort($onlineData);

        $hiData = [];
        $lastNum = 0;
        foreach ($onlineData as $timestampKey => $onlineNum){
            if(empty($onlineNum))$onlineNum = $lastNum;
            $hi = date('Ymd H:i', $timestampKey);
            $lastNum = $onlineNum;
            $hiData[$hi] = $onlineNum;
        }

        $yesterdayBegin = strtotime($yesterday);
        $yesterdayEnd = $yesterdayBegin+86400;
        $time = $yesterdayBegin;
        while($time < $yesterdayEnd){
            $hi = date('Ymd H:i', $time);
            if(empty($hiData[$hi])){
                $lhi = date('Ymd H:i', $time-60);
                echo $hi . PHP_EOL;
                echo strtotime($hi) . PHP_EOL;
                $onlineData[strtotime($hi)] = $hiData[$lhi];
            }
            $time += 60;
        }
        ksort($onlineData);
        $data = [
            1 => $onlineData
        ];
        $data = json_encode($data);
        $sql = "update {$tbl} set data='{$data}' where date='{$yesterday}' and type='foxOnlinePlaying' limit 1";
        echo $sql . PHP_EOL;
        $yesterdayOnlinePlaying = oo::commonOprDb('statistics')->query($sql, 1);
        var_dump($yesterdayOnlinePlaying);
        echo json_encode($onlineData);
    }


    public function onlineData(){
        date_default_timezone_set('UTC');
        $tbl = otable::staData();
        $timestamp = time();
        $yesterday = date('Ymd', $timestamp - 86400);
        $sql = "select * from {$tbl} where date='{$yesterday}' and type='foxOnlinePlaying' limit 1";
        $yesterdayOnlinePlaying = oo::commonOprDb('statistics')->getOne($sql, 1);
        $onlineData = json_decode($yesterdayOnlinePlaying['data'], true)[1];
        ksort($onlineData);
        $lastNum = 0;
        $foxOnlineData = [];
        foreach ($onlineData as $timestampKey => $onlineNum){
            if(empty($onlineNum))$onlineNum = $lastNum;
            $lastNum = $onlineNum;
            $i = date('i', $timestampKey)	;
            if($i%5)continue;
            $foxOnlineData[date('H:i', $timestampKey + 8 * 3600)] = $onlineNum;
        }
        echo json_encode($foxOnlineData);

    }


    public function delExpiredLogs(){
        $paths = [
            PATH_DAT."logs/",
            PATH_DAT."clientErrorLogFiles/",
            PATH_DAT."mysql/",
            PATH_DAT."userShushuGroups/",
        ];
        $expireTime = time() - 8 * 86400;
        foreach ($paths as $path){
            echo $path .'::::::::'. PHP_EOL;
            $d = opendir($path);
            while($f = readdir($d)){
                if(in_array($f, ['.', '..']))continue;
                $array = explode('.', $f);
                $date = $array[0];
                $time = strtotime($date);
                if(empty($time))continue;
                $filePath = $path  . $f;
                if($time < $expireTime){
                    echo $filePath . '过期' . PHP_EOL;
                    if(is_dir($filePath)){

                        $cmd = "rm -rf {$filePath}";
                        exec($cmd);
                    }else{
                        unlink($filePath);
                    }
                }else{
                    echo $filePath . '未过期' . PHP_EOL;
                }
            }
            closedir($d);
        }
    }

    public function removeDir($path = ''){
        if(empty($path) || !is_dir($path))return true;
        echo '开始删除目录：'.$path  . PHP_EOL;
        $d = opendir($path);
        while($f = readdir($d)){
            echo $f .PHP_EOL;
            if(in_array($f, ['.', '..']))continue;
            $filePath = $path . DIRECTORY_SEPARATOR . $f;
            echo $filePath .PHP_EOL;
            if(is_dir($filePath)){
                echo $filePath  . ' 是目录：'.PHP_EOL;
                $this->removeDir($filePath);
            }else{
                unlink($filePath);
            }
        }
        closedir($d);
        rmdir($path);
        echo '删除目录：'.$path  . PHP_EOL;

    }

    public function delUnusedConfigFile(){
        $configUrl = 'http://testhttp-crazyfox.superant.cc/api/config_crazy.php';
        $oos_debug = $this->config->item('oos_debug');
        if(!$oos_debug){
            $configUrl = 'https://fox.crazyfox.vip/api/config_crazy.php';
        }
        $config = file_get_contents($configUrl);
        $config = @json_decode($config, true) ?? [];
        if(empty($config))return;
        $path =  './public/game/config/';
        echo '有用文件数：'.count($config) . PHP_EOL;
        if(is_dir($path)) {
            $dirHandler = opendir($path);
            $fileCnt = 0;
            $cntMap = [];
            while($tf = readdir($dirHandler)){
                if(in_array($tf, ['.','..']))continue;
                $filePath = $path . $tf;
                if(is_dir($filePath))continue;
                $fileCnt++;
                if(in_array($tf, $config)){
                    $cntMap['存在']++;
                    unset($config[array_search($tf,$config)]);
                }else{
                    $cntMap['不存在']++;
//                    unlink($filePath);
                }
            }
            echo '总文件数：'.$fileCnt . PHP_EOL;
            echo json_encode($cntMap, JSON_UNESCAPED_UNICODE) . PHP_EOL;
            echo json_encode($config, JSON_UNESCAPED_UNICODE) . PHP_EOL;
        }

    }

    public function subNsq(){
        $nsq_lookupd = new NsqLookupd("10.0.24.134:4161"); //the nsqlookupd http addr
        $nsq = new Nsq();
        $config = array(
            "topic" => "stopservie_config",
            "channel" => "struggle",
            "rdy" => 2,                //optional , default 1
            "connect_num" => 1,        //optional , default 1
            "retry_delay_time" => 5000,  //optional, default 0 , if run callback failed, after 5000 msec, message will be retried
            "auto_finish" => true, //default true
        );

        $nsq->subscribe($nsq_lookupd, $config, function($msg,$bev){

            echo $msg->payload.PHP_EOL;
            echo $msg->attempts.PHP_EOL;
            echo $msg->messageId.PHP_EOL;
            echo $msg->timestamp.PHP_EOL.PHP_EOL.PHP_EOL.PHP_EOL;

        });
    }
    public function pubNsq(){
        $res = $this->SendNsqMsg('test', ['a' => 'A']);
        var_dump($res);
    }


    public function SendNsqMsg($topic,$body,$hearder = []){
        $nsqdAddrs = $this->config->item('nsqAddress');
        $bodyArr = $body;
        $data =array_values( unpack("C*", json_encode($body)));
        $nsq = new Nsq();
        $isTrue = false;
        foreach ($nsqdAddrs as $nsqdAddr){
            $isTrue = $nsq->connectNsqd([$nsqdAddr]);
            if($isTrue)break;
        }

        if($isTrue){
            $res = $nsq->publish($topic,json_encode($data));
            if(!$res)
                oo::logs()->debug3(['nsqdAddrs' => $nsqdAddrs, "msg"=>"publish failed","topic"=>$topic,"info"=>$bodyArr],"publishNsq.log");
            else
                oo::logs()->debug3(['nsqdAddrs' => $nsqdAddrs, "msg"=>"publish successed","topic"=>$topic,"info"=>$bodyArr],"publishNsq.log");
            $nsq->closeNsqdConnection();
        }else{
            oo::logs()->debug3(['nsqdAddrs' => $nsqdAddrs, "msg"=>"lose connect...","topic"=>$topic,"info"=>$bodyArr],"publishNsq.log");
        }
        return $res;
    }

//    public function refreshShushuGroups(){
//        # 当前系统所有数数分组
//        $tb = otable::UserGroupConfig(2);
//        $localGroups = oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb} where cid=5 and sort >= 0",MYSQLI_ASSOC);
//
//
//        # 数数方最新数数分组
//        $data = oo::commonOprModel('SSdata')->getGroupList();
//        $datas = [];
//        $existGroups = [];
//        foreach ($data as $k=>$v){
//            $existGroups[] = $v['id'];
//            $datas[$k] =[
//                'cid'=>5,
//                'groupId'=>$v['id'],
//                'name'=>$v['clusterName'],
//                'remark'=>$v['displayName'],
//                'update'=>1,
//                'count'=>$v['usersNum']
//            ];
//        }
//
//        # 后台存在，数数不存在的分组
//        $delGroups = [];
//        foreach ($localGroups as $group){
//            if(!empty($group['groupId']) && !in_array($group['groupId'], $existGroups)){
//                $delGroups[] = $group['id'];
//            }
//        }
//
//        oo::logs()->debug3(['后台数数分组数据'=>$localGroups,'数数最新分组数据'=>$datas,'需要删除的分组数据'=>$delGroups],"refreshShushuGroups.log");
//        if(!empty($delGroups)){
//            $delIdsStr = implode(',', $delGroups);
//
//            # 将数数那边删除的分数在这边废弃
//            oo::commonOprDb('games')->query("update  {$tb} set sort=-1 where cid=5 and id in ({$delIdsStr})",MYSQLI_ASSOC);
//            $updateKey = okeys::configSSGroupUpdate();
//            $hideKey = okeys::configSSGroupShow();
//            foreach ($delGroups as $id){
//                oo::commonOprRedis('statistics')->hSet($hideKey,$id,$id);   # 显示状态为隐藏
//                oo::commonOprRedis('statistics')->hDel($updateKey, $id);    # 更新状态为不更新
//            }
//        }
//
//    }


    public function formatAAAData(){
        $date = $startDate = '2022-04-12';
        $endDate = '2022-04-25';
        $updateCnt = [];
        while(true){
            echo $date. PHP_EOL;
            $date = date('Y-m-d', strtotime('+1day', strtotime($date)));
            if($date > $endDate)break;


            $updateCnt[$date] = [];
            $table = otable::TAdjustPeriodView();//'t_adjust_period_view';
            $sql = "select * from {$table} where date = '{$date}' and creatives_id = '' and campaigns_name like '%AAA%'";
            $rows = oo::commonOprDb('report')->getAll($sql);
            $patter = '/\((\d+)\_\d+\)$/';
            echo count($rows) . PHP_EOL;
            foreach ($rows as $row){
                preg_match($patter, $row['creatives_name'], $matchs);
                if(!empty($matchs[1])){
                    $data = [
                        'creatives_id' => $matchs[1]
                    ];
                    $updateSql = funs::db_updateSQL($table, $data, ' id='.$row['id']);
                    $res = oo::commonOprDb('report')->query($updateSql);
                    $updateCnt[$date][intval($res)]++;
                }
            }
        }
        echo json_encode($updateCnt) . PHP_EOL;
    }

    public function setRedis(){
        return;
        $aid = 11056;
        $userBindKey = okeys::ACT_USER_BIND_LIST($aid);
        $uids = oo::commonOprRedis('games')->sMembers($userBindKey);
        echo json_encode($uids) . PHP_EOL;
//        $uids = [3108758];
        $cnt = 0;
        foreach ($uids as  $uid){
            $cnt++;
            $key = "ACT_USER_BIND:spins_master-{$uid}";
            oo::commonOprRedis('games')->delete($key);
        }
        echo $cnt;
    }

    public function genSyncCmds(){
        $cmdPrefix = '/mnt/sven/script/shell/rsync-prod.sh ';
        $pathPrefix = 'activity';
        $platforms = [
            'Android',
            'iOS'
        ];

        $dirs = [
//            'cyberpickone',
//            'moderndramarank',
//            'sunstriderrank',
//            'treasureraiderrank',
            'clubgarden',
        ];

        $result = [];
        $this->nextLine();
        foreach ($dirs as $dir){
            foreach ($platforms as $platform){
                $cmd = "{$cmdPrefix} {$pathPrefix}/{$platform}/{$dir}";
                echo $cmd;
                $this->nextLine();
//                exec($cmd, $output, $result) ;
//                $result[$cmd] = [
//                    'output' => $output,
//                    'result' => $result
//                ];
            }
        }
        echo json_encode($result);
        $this->nextLine();
    }


    public function scanWapInviteInfo(){
        $minTime = 1676282400; //2023-02-13 18:00 北京时间
        $scanEndTime = time();
        $inviteScanTimeKey = okeys::inviteScanTime();
        $scanBeginTime = oo::commonOprRedis('games')->get($inviteScanTimeKey);
        oo::commonOprRedis('games')->set($inviteScanTimeKey, max($scanEndTime, $minTime));
        $scanBeginTime = $scanBeginTime ? : $minTime;

        $inviteTbl = otable::AdJustData();
        $where = "where  created_at > {$scanBeginTime} and created_at <= {$scanEndTime} and `tracker_token`='qsu9pwh' and label <>''";
        $sql = "select * from  {$inviteTbl} {$where}  ";
        $list = oo::commonOprDb('slavedb')->getAll($sql, 1);
        $inviteInfo = [];
        foreach ($list as $item){
            $uid = abs(base64_decode($item['label']));
            $inviteInfo[$uid] = $inviteInfo[$uid] ?? 0;
            $inviteInfo[$uid]++;
        }
        oo::logs()->debug3($inviteInfo,"wapInvite.log");
        SvenModel::updateUserInviteInfo($inviteInfo);
    }


    public function exportUserInfo(){
        set_time_limit(0);
        date_default_timezone_set("UTC");
        ini_set('memory_limit', -1);
//        return;
        $uids = $this->getExportUids();
        echo count($uids) . PHP_EOL;
        $this->exportDataByUid($uids);
    }
    public function getExportUids(): array
    {
        $payTable = otable::paidStat();
        $userTable = otable::userinfo();
        $gameTable = otable::gh_gameserver();
        $regTime = strtotime('2024-01-01');
        $lasttime = time()-86400*30;
        $sql = "select uid from {$payTable} where uid in (select tu.uid FROM  {$userTable} tu inner JOIN {$gameTable} tg on tu.uid=tg.mid where   tg.levelId >=20 and tu.lasttime >= {$lasttime})";
//        $sql = "select uid from {$userTable} where createtime >= 1672502400 and lasttime <= 1704038400";

//        $sql = "";

        $users = oo::commonOprDb('gameslave')->getAll($sql, 1);
        return array_map(function ($v){return $v['uid'];}, $users);
    }
    private function exportUidsOld(){
        $countryCodes = [
            '英' => 'GB',
            '美' => 'US',
            '德' => 'DE',
            '法' => 'FR',
            '意' => 'IT',
            '西' => 'ES',
            '葡' => 'PT',
            '罗马尼亚' => 'RO',
            '波兰' => 'PL',
            '巴西'  => 'BR',
        ];
        $countryCodeStr = implode("','", $countryCodes);
        $whereCountryStr = " and country_code in ('{$countryCodeStr}')";
        $lastLoginTime = time() - 30 * 86400;
        $firstLoginTime = time() - 365 * 86400;
        $userTbl = otable::userinfo();
        $userAddrTbl = otable::useraddress();
        $regLostUsers = oo::commonOprDb('gameslave')->getAll("select uid from {$userTbl} where lasttime >= {$firstLoginTime} and lasttime < {$lastLoginTime}", 1);
        $regLostUids = array_map(function($v){return $v['uid'];}, $regLostUsers);
        $regLostUids = array_chunk($regLostUids, 10000);

        $lostCountryUids = [];
        foreach ($regLostUids as $uids){
            $uidsStr = implode(',', $uids);
            $lostCountryUids = array_merge($lostCountryUids,oo::commonOprDb('gameslave')->getAll("select uid from {$userAddrTbl} where uid in ({$uidsStr}) {$whereCountryStr}", 1));
        }
        $lostCountryUids = array_map(function($v){return $v['uid'];}, $lostCountryUids);
        $lostCountryUids = array_unique($lostCountryUids);
        return array_filter($lostCountryUids);
    }
    private function exportUids0119():array{
        $lastLoginTime = strtotime("2023-01-12");
        $regTime = strtotime("2022-12-01");
        $userTbl = otable::userinfo();
        $userAddrTbl = otable::useraddress();
        $sql = "select uid from {$userTbl} where createtime >= {$regTime} and lasttime < {$lastLoginTime}";
        $regLostUsers = oo::commonOprDb('gameslave')->getAll($sql, 1);
        $regLostUids = array_map(function($v){return $v['uid'];}, $regLostUsers);
//        $regLostUids = array_chunk($regLostUids, 10000);

        return $regLostUids;
    }
    public function exportDataByUid($uids){

        $userTbl = otable::userinfo();
        $userAddressTbl = otable::useraddress();
        $gameinfoTbl = otable::gh_gameserver();
        $dynamicTbl = otable::UserDynamicsData();
        $friendTbl = otable::userfriends(1);
        $payTable = otable::paidStat();


        $timestamp = time();
        $date = date('Y-m-d',$timestamp);
        $datetime = date('YmdHi', $timestamp);
        $file = __DIR__ . "/../../deBUG/csvs/{$datetime}.csv";
        $f = fopen($file, 'w');
        $header = [
            'uid',
            '昵称',
            'FN',
            'LN',
            'Email',
            '性别',
            '国家',
            '金额',
            '注册时间',
            '最后登陆时间',
            '等级',
        ];
        fputcsv($f, $header);

        $page = 1;
        $limit = 1000;
        $processedCnt = 0;
        $uidsList = array_chunk($uids, $limit);
        foreach ($uidsList as $uids){
            $offset = ($page - 1) * $limit;
            $uidStr = implode(',', $uids);
            $sql = "select * from {$userTbl} tu inner join {$userAddressTbl} ta on ta.uid=tu.uid  where tu.uid in ({$uidStr})   limit {$offset},{$limit} ";
            $result = oo::commonOprDb('gameslave')->getAll($sql, 1);

            $userGameInfos = oo::commonOprDb('gameslave')->getAll("select * from {$gameinfoTbl} where mid in ({$uidStr}) ", 1);
            $userGameInfos = array_column($userGameInfos, null, 'mid');

//            $dynamicInfos = oo::commonOprDb('gameslave')->getAll("select * from {$dynamicTbl} where uid in ({$uidStr}) ", 1);
//            $dynamicInfos = array_column($dynamicInfos, null, 'uid');

//            $friendsInfos = oo::commonOprDb('gameslave')->getAll("select * from {$friendTbl} where uid in ({$uidStr}) ", 1);
//            $friendsInfos = array_column($friendsInfos, null, 'uid');

            $paysql = "select amount as money ,uid from {$payTable} where uid in ({$uidStr})  group by uid";
            $paymentInfos = oo::commonOprDb('gameslave')->getAll($paysql, 1);
//            var_dump($paymentInfos);
            $paymentInfos = array_column($paymentInfos, 'money', 'uid');
//            $paymentInfosOld = oo::commonOprDb('gameslave')->getAll("select sum(sl_pusd) as money ,sl_uid as uid from {$paymentTblOld} where sl_uid in ({$uidStr})  and  sl_status=2 group by sl_uid", 1);
//            $paymentInfosOld = array_column($paymentInfosOld, 'money', 'uid');
//
//            foreach ($paymentInfosOld as $uid => $money){
//                $paymentInfos[$uid] = $paymentInfos[$uid] ?? 0;
//                $paymentInfos[$uid] += $money;
//            }

            foreach ($result as $k => $user){
                $processedCnt++;
                $uid = $user['uid'];
                $regTime = date('Y-m-d H:i:s', $user['createtime']);
                $payedMoney = empty($paymentInfos[$uid]) ? 0.00 : $paymentInfos[$uid];
                $lastLoginTime = date('Y-m-d H:i:s', $user['lasttime']);
                list($fn, $ln) = $this->divideName($user['nick']);
                $gameInfo = empty($userGameInfos[$uid]) ? oo::commonOprDb('gameslave')->getOne("select * from {$gameinfoTbl} where mid='{$uid}'", 1) : $userGameInfos[$uid];
                $level = $gameInfo['levelId'];
                if(empty($user['email']))continue;
                if($level < 5)continue;

//                $spins= $gameInfo['spins'];
//                $coins= $gameInfo['money'];
//                $stars= $gameInfo['star'];
//
//                $dynamicInfo = empty($dynamicInfos[$uid]) ? oo::commonOprDb('gameslave')->getOne("select * from {$dynamicTbl} where uid='{$uid}'", 1) : $dynamicInfos[$uid];
//                $actDays= intval($dynamicInfo['activeDay']);
//
//                $friendsInfo = empty($friendsInfos[$uid]) ? oo::commonOprDb('gameslave')->getOne("select * from {$friendTbl} where uid='{$uid}'", 1) : $friendsInfos[$uid];
//                $friends = empty($friendsInfo['game_list']) ? [] : explode(',', $friendsInfo['game_list']);
//                $friendCnt= count($friends);

                $line = [
                    $user['uid'],
                    $user['nick'],
                    $fn,
                    $ln,
                    $user['email'],
                    $user['sex'],
                    $user['country_code'],
                    $payedMoney,
                    $regTime,
                    $lastLoginTime,
                    $level,
//                    $spins,
//                    $coins,
//                    $stars,
//                    $actDays,
//                    $friendCnt,
                ];
                fputcsv($f, $line);
            }
            echo $processedCnt . '-';

        }

        echo $datetime . PHP_EOL;
        fclose($f);
        echo $file . PHP_EOL;
        echo 'ok';
    }

    public function testSign(){
        $lastId = 1001;
        $shareKey = md5('3yz@VASObh');
        $str = "id={$lastId}";
        $sign = md5("{$str}&cfk={$shareKey}");
        echo $sign;
    }

    public function sendPaintReward(){
        $msgId = 636;
        $rankSpinsNum = [
            1 => 10000,
            2 => 8000,
            3 => 5000,
            4 => 3000,
            5 => 3000,
            6 => 3000,
            7 => 3000,
            8 => 1000,
            9 => 1000,
            10 => 1000,
            11 => 800,
            12 => 800,
        ];
        $voteList = SvenModel::voteList();
        foreach ($voteList as $value){
            if(empty($rankSpinsNum[$value['rank']]))continue;
            $num = $rankSpinsNum[$value['rank']];
            $value['uid'] = 4637757;
            $num = 10;
            $rewards = [
                [
                    'propsId' => 15,
                    'num' => $num,
                ]
            ];
            SvenModel::sendRewardToEmail($msgId, $value['uid'], $rewards);
            echo $value['rank'] . ':'.$value['uid'] . PHP_EOL;
        }
    }


    function getFileData($file)
    {
        if (!is_file($file)) {
            exit('没有文件');
        }

        $handle = fopen($file, 'r');
        if (!$handle) {
            exit('读取文件失败');
        }
        $i=0;
        while (($data = fgets($handle)) !== false) {
            $data = explode(',', $data);
//            echo $data[0] . PHP_EOL;
            $uid = intval($data[0]);
            if(empty($uid)){
                echo implode(',', $data). PHP_EOL;
            }else{
                $list[] = intval($data[0]);
            }
            $i++;
//            if($i > 10)break;
//            if($data[0]&&$data[1]){
//                $list[$data[0]] = $data[1];
//            }
        }

        fclose($handle);
        return $list;
    }

    public function sendFBRewards(){
        $uids = $this->getFileData(__ROOT__ . '/Excel/0109.csv');
        $uids = array_unique($uids);
        $uids = array_filter($uids);
        $uids = [4806046];
        echo count($uids);die;
        $msgId = 640;
        $rewards = [
            [
                "propsId"=>15,
                "num"=>2500,
                "skin"=>0
            ]
        ];
        $cnt = 0;
        $i = 0;
        foreach ($uids as $uid){
            SvenModel::sendRewardToEmail($msgId, $uid, $rewards);

            $i++;
            $cnt++;
            if($i == 1000){
                echo $cnt . PHP_EOL;
                $i = 0;
                sleep(1);
            }
        }
        echo $cnt . PHP_EOL;
    }

    public function resetEmailExpireTime($msgId = 0, $addDays = 7){
        $msgId = intval($msgId);
        $addDays = intval($addDays);
        if(empty($msgId)){
            echo '请输入正确的邮件id';
            return;
        }
        $i = 0;
        $total = 0;
        $expireTime = time() + 86400 * $addDays;
        while($i < 100){
            $i++;
            echo $i . "\t:";
            $emailTable = otable::userSysMail($i);

            $updateSql = " update {$emailTable} set `expire`={$expireTime} where `msgid`={$msgId} and `got`=0";
            $res = oo::commonOprDb('games')->query($updateSql);
            if(!$res){
                echo $emailTable . PHP_EOL;
                continue;
            }
            $sql = " select * from {$emailTable} where `msgid`={$msgId} and `got`=0";
            $unreadEmails = oo::commonOprDb('slavedb')->getAll($sql);

            echo count($unreadEmails) . PHP_EOL;
            foreach ($unreadEmails as $data){
                $key = okeys::sysMsgGet($data['uid']);
                $eid = $data['id'];
                $data['id'] = $eid;
                $data['rewards'] = json_decode($data['rewards'],true);
                $field = "{$msgId}_{$eid}";
                unset($data['supplement']);
                $res = oo::commonOprRedis('games')->hSet($key,$field,json_encode($data, JSON_NUMERIC_CHECK));
                var_dump($data['uid'], $res);
                echo $data['uid'] .  "\t:" . $res;
            }
        }
    }
    public function resetEmailExpireTimeByUser(){
        return;
        $i = 0;
        $total = 0;
        $msgId = 641;
        $expireTime = time() + 86400 * 7;
        $i = 1162578;
        $emailTable = otable::userSysMail($i);

        $updateSql = " update {$emailTable} set `expire`={$expireTime} where `msgid`=641 and `got`=0";
        $res = oo::commonOprDb('onlinemaster')->query($updateSql);
        if(!$res){
            echo $emailTable . PHP_EOL;
            return;
        }
        $sql = " select * from {$emailTable} where `msgid`={$msgId} and `got`=0";
        $unreadEmails = oo::commonOprDb('gameslave')->getAll($sql);

        foreach ($unreadEmails as $data){
            if($data['uid'] != 1162578)continue;
            $key = okeys::sysMsgGet($data['uid']);
            $eid = $data['id'];
            $data['id'] = $eid;
            $data['rewards'] = json_decode($data['rewards'],true);
            $field = "{$msgId}_{$eid}";
            oo::commonOprRedis('games')->hSet($key,$field,json_encode($data, JSON_NUMERIC_CHECK));
            echo $data['uid'] . PHP_EOL;
            return;
        }
    }

    public function getRedisConfig(){
        $configname = 'games';
        $configname = strtolower($configname);
        var_dump(oo::$config['redis_'.$configname]);
    }
    public function callbackFbUserByEmail(){
        $redisConn = 'games';
        $key = 'RECALL_LOST_USER_EMAIL_LIST:SX';
        $maxNum = 15000;
        $i = 0;
        $cid = 8;
//        $test = false;
//        if($test){
//            $cid = 8;
//            $maxNum = 1;
//            $testUser = [123, '824785442@qq.com', 123];
////            $testUser = [123, 'liuliadelaidegg@gmail.com', 123];
//            $testUser = [123, 'hewhisper@163.com', 123];
//            oo::commonOprRedis($redisConn)->lPush($key,json_encode($testUser));
//        }
        if(empty($cid))return;
        while($i < $maxNum){
            $item = oo::commonOprRedis($redisConn)->lpop($key);
            $item = json_decode($item, true);
            $res = oo::commonOprModel('email')->sendEmailByCid($item[1], $cid);
            $res = intval($res);
            $i++;
            if(!( $i%100 ))sleep(1);
            echo "{$i} \t {$item[1]}\t {$res}" . PHP_EOL;
        }
    }


    // 情人节活动结算奖励
    public function rankRewards214(){
        $rankRewards = [
            10000,
            8000,
            5000,
            3000,
            3000,
            3000,
            3000,
            1000,
            1000,
            1000,
        ];
        $scoreTable = otable::loverScores();
        $ranksUsers = oo::commonOprDb('report')->getAll("select uid,invite_score ,total_score from {$scoreTable} order by total_score desc,updated_at asc",1);
        foreach ($ranksUsers as $rank => $user){
            $rewardNum = $rankRewards[$rank];
            $propsId = 15;
            $msgId = 656;
            if(empty($rewardNum)){
                $msgId = 657;
                $propsId = 14;
                $rewardNum = 1000000;
            }
            $rewards = [
                [
                    'propsId' => $propsId,
                    'num' => $rewardNum,
                ]
            ];
//            SvenModel::sendRewardToEmail($msgId, $user['uid'], $rewards);

            if(empty($user['invite_score']))continue;
            $inviteReward = [
                [
                    'propsId' => $propsId,
                    'num' => $user['invite_score'] * 50,
                ]
            ];
//            SvenModel::sendRewardToEmail(655, $user['uid'], $inviteReward);
        }
        echo json_encode($ranksUsers);
    }

    public function searchRepeatRewards(){
            $uids = [
                6302230	,
                6676862	,
                6040493	,
                5412899	,
                2510630	,
                2418136	,
                6607677	,
                6356233	,
                5128903	,
                2507997	,
            ];
            $msgId = 656;
            $records = [];
            foreach ($uids as $uid){
                $tb = otable::userSysMail($uid);
                $key = okeys::sysMsgGet($uid);
                $userMsgs = oo::commonOprDb('games')->getAll("select * from {$tb} where uid={$uid} and msgid={$msgId}",1);
//                if(count($userMsgs)>1){
//                    $repeatMsg = $userMsgs[1];
//                    $hkey = "{$repeatMsg['msgid']}_{$repeatMsg['id']}";
//                    $userMsgs = oo::commonOprDb('games')->query("delete from {$tb} where id={$repeatMsg['id']}",1);
//                    echo oo::commonOprRedis('games')->hdel($key, $hkey);
//                }
                $records[$uid] = $userMsgs;
            }
            echo json_encode($records);

    }

    public function getExtensionType($fileName){
        $pathinfo = pathinfo($fileName);
        $extensionType = NULL;
        switch (strtolower($pathinfo['extension'])) {
            case 'xls':				//	Excel (BIFF) Spreadsheet
            case 'xlsx':			//	Excel (OfficeOpenXML) Spreadsheet
            case 'xlsm':			//	Excel (OfficeOpenXML) Macro Spreadsheet (macros will be discarded)
            case 'xltx':			//	Excel (OfficeOpenXML) Template
            case 'xltm':			//	Excel (OfficeOpenXML) Macro Template (macros will be discarded)
                $extensionType = 'Excel2007';
                break;
            case 'xlt':				//	Excel (BIFF) Template
                $extensionType = 'Excel5';
                break;
            case 'ods':				//	Open/Libre Offic Calc
            case 'ots':				//	Open/Libre Offic Calc Template
                $extensionType = 'OOCalc';
                break;
            case 'slk':
                $extensionType = 'SYLK';
                break;
            case 'xml':				//	Excel 2003 SpreadSheetML
                $extensionType = 'Excel2003XML';
                break;
            case 'gnumeric':
                $extensionType = 'Gnumeric';
                break;
            case 'htm':
            case 'html':
                $extensionType = 'HTML';
                break;
            case 'csv':
                $extensionType = 'CSV';
                break;
            default:
                $this->response(-1, '文件格式异常');
                break;
        }
        return $extensionType;
    }
    public function getUserEmails(){
        ini_set('memory_limit', -1);
        $file = __ROOT__ . '/Excel/callbackusers.xlsx';
        $userTbl = otable::userinfo();
        $extensionType = $this->getExtensionType($file);
        $xlsReader = IOFactory::createReader($extensionType);
        $xlsReader->setReadDataOnly(true);
        $xlsReader->setLoadSheetsOnly(true);
        $Sheets = $xlsReader->load($file);
        $users = $Sheets->getSheet(0)->toArray();
        array_shift($users);
        $users = array_column($users, null, 0);
        $flag = '未成功登录过流失'; //8
        $usersArray = array_chunk($users, 10);
        $listKeyPrefix = 'RECALL_LOST_USER_EMAIL_LIST:SX';
        $shareUidKey = "SHARE_LINK_USER_LIST:1713";
        $noEmailCnt = 0;
        $totalUser = 0;
        foreach ($usersArray as $users){
            if(empty($users))continue;
            $userFlagMap = [];
            $uids = [];
            foreach ($users as $user){
                $userFlagMap[$user[0]] = $user[4];
                $uids[] = $user[0];
            }

            $uidsStr = implode(',', $uids);
            $sql = "select uid,email from {$userTbl} where uid in ({$uidsStr})";
            $users = oo::commonOprDb('games')->getAll($sql);
            foreach ($users as $user){
                if($userFlagMap[$user['uid']] == $flag){
                    $cid = 8;
                }else{
                    $cid = 9;
                }
                $listKey = $listKeyPrefix;
                if(empty($user['uid']))continue;
                $totalUser++;
                if(empty($user['email'])){
                    $noEmailCnt++;
                }else{
                    oo::commonOprRedis('games')->hset($shareUidKey, $user['uid'], $user['email']);
                    oo::commonOprRedis('games')->rpush($listKey,json_encode([$user['uid'], $user['email'], $cid]));
                }
            }
        }
        $validCnt = $totalUser - $noEmailCnt;
        echo "总人数：{$totalUser},没有email的人数：{$noEmailCnt},有email的人数:{$validCnt}".PHP_EOL;
    }

    public function getSSGroups(){

        $data = oo::commonOprModel('SSdata')->getGroupList();
        $list = array_column($data, 'clusterName');
        echo json_encode($list);
    }

    public function migrationTrafficData(){
        $aid = 16861;
        $actInfoTable = otable::activityConf();
        $actStageTable = otable::activityStageRewardConf();
        $actInfo = oo::commonOprDb('slavedb')->getOne("select * from {$actInfoTable} where id={$aid} limit 1");
        $extraData = json_decode($actInfo['extraData'],  true);
        $actRewards = oo::commonOprDb('slavedb')->getOne("select * from {$actStageTable} where aid={$aid} limit 1");
        $actRewards['reward'] = json_decode($actRewards['reward'],  true);

        $conditionKeys = okeys::activityConditionKeys($aid);
        $stageRewardKeys = okeys::activityRewardsStageKeys($aid);
//echo $conditionKeys . PHP_EOL . $stageRewardKeys;die;
        $data = [
            1 => [
                'lvStart' => 1,
                'lvEnd' => 1000,
                'maxRewards' => $extraData['maxReward'],
                'levels' => $actRewards['reward'],
            ]
        ];

        foreach ($data as $idx3 => $item3) {
            $stageKey = $idx3;
            $stageConditions = [
                [
                    "start" => $item3['lvStart'],
                    "end" => $item3['lvEnd'],
                    "shushu" => [],
                    "type" => CONDITION_TYPE_LV
                ],
            ];
            oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, JSON_NUMERIC_CHECK));
            oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3, JSON_NUMERIC_CHECK));
        }

        $expireTime = 1680346500;#redis最少一分钟
        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));

        $this->writeActConfCacheToDB($aid);
    }


    private function writeActConfCacheToDB($aid = 0)
    {
        $aid = intval($aid);
        if (empty($aid)) return;
        # redis key
        $conditionKeys = okeys::activityConditionKeys($aid);
        $stageRewardKeys = okeys::activityRewardsStageKeys($aid);
        $stageExtraKeys = okeys::activityStageExtraConfigKeys($aid);

        #表名
        $conditionTable = otable::actStageConditionConf();
        $rewardsTable = otable::actStageRewardsConf();

        # 清除老数据
        oo::commonOprDb('games')->query("delete from {$conditionTable} where aid={$aid}");
        oo::commonOprDb('games')->query("delete from {$rewardsTable} where aid={$aid}");
        # 获取redis 数据 写入数据库
        # condition数据
        $conditionConfig = oo::commonOprRedis('games')->hgetall($conditionKeys);
        foreach ((array)$conditionConfig as $stage => $condition) {
            $conditionConfig[$stage] = json_decode($condition, true);
        }
        $conditionConfig = json_encode($conditionConfig, 32);
        $insertSql = "insert into {$conditionTable} (`aid`, `condition`) values ({$aid}, '{$conditionConfig}')";

        oo::commonOprDb('games')->query($insertSql);
        # rewards数据
        $extraConfig = oo::commonOprRedis('games')->hgetall($stageExtraKeys);
        $rewardsConfig = oo::commonOprRedis('games')->hgetall($stageRewardKeys);
        if (!empty($rewardsConfig) && is_array($rewardsConfig)) {
            $insertSql = "insert into {$rewardsTable} (`aid`,`stage`, `rewards`, `extra`) values ";
            foreach ($rewardsConfig as $stage => $rewards) {
                $extra = $extraConfig[$stage] ?? '';
                $insertSql .= " ({$aid}, '{$stage}', '{$rewards}', '{$extra}'),";
            }
            $insertSql = trim($insertSql, ',');
            oo::commonOprDb('games')->query($insertSql);
        }
    }

    function getCsvData($file)
    {
        if (!is_file($file)) {
            exit('没有文件');
        }

        $handle = fopen($file, 'r');
        if (!$handle) {
            exit('读取文件失败');
        }
        $list = [];
        while (($data = fgetcsv($handle)) !== false) {
            $list[] = $data;
        }

        fclose($handle);
        return $list;
    }

    function updateGoogleSpendsData(){
        $data = $this->getCsvData(__ROOT__ . '/Excel/cost/0509cost.csv');
        $i = 1;
        while($i>0){
            $i--;
            array_shift($data);
        }
        echo count($data);
        $tb = otable::googleCampaign();
        $keys = [
            'country',
            'date_start',
            'campaign_id',
            'campaign_name',
            'currency',
            'spend',
            'clicks',
            'impressions',
            'conversions',
        ];
        $res = [];
        foreach ($data as $k => $v){
            $v[] = 0;
            $v[] = 0;
            $v[] = 0;
            if(!$k)continue;
            $v = array_combine($keys, $v);
            $v["country"] = strtoupper($v['country']);
            $v['date_start'] = date('Y-m-d', strtotime($v['date_start'] ));
            unset($v["currency"]);
            $where = " date_start = '{$v["date_start"]}' AND campaign_id = '{$v["campaign_id"]}' AND campaign_name = '{$v["campaign_name"]}' AND country = '{$v["country"]}'";
            $sql2 = "SELECT COUNT(*) AS count FROM {$tb} WHERE {$where}";
            $retTemp = oo::commonOprDb('report')->getOne($sql2,1);
//            var_dump($retTemp);
            if($retTemp["count"]){
                $sql2 = funs::db_updateSQL($tb,$v,$where);
            }else{
                $sql2 = funs::db_insertSQL($tb,$v);
            }
            var_dump($sql2);
            $res[] = oo::commonOprDb('report')->query($sql2);
        }
        var_dump($res);

    }
    function test(){
        $uid = 2939983;
        $date = 20230727;
        $key = okeys::fansActKey("USER_DATA:{$uid}:{$date}");
//        $key = okeys::fansActKey("USER_RECORDS:{$uid}");
        var_dump($key);
        var_dump(oo::commonOprRedis('games')->hGetAll($key));
    }


    public function userReg(){
        $envUrlMaps = [
//            'cf-test' => 'http://testsx.superant.cc/sven/userRegPrivate',
            'cf-test' => 'http://testadmin.superant.cc/sven/userRegPrivate',
            'cf-prod' => 'https://crazycoin.superant.cc/sven/userRegPrivate',
            'cc-test' => 'http://cc-testadmin.superant.cc/sven/userRegPrivate',
            'cc-prod' => 'https://coin-admin.crazycoin.link/sven/userRegPrivate',
        ];
        foreach ($envUrlMaps as $env => $url){
            $res = funs::sendCurl($url, $_GET, 'post');
            if($res != 'ok')EnWechatModel::feishuNotify("环境：{$env}, 员工入职后台自动添加账号失败：" . $res, ['管理后台群']);
        }

    }

    public function userRegPrivate(){
        $mobile   = intval($this->input->post('mobile'));
        $username = $this->input->post('username');
        $userpwd  = '123654';
        if(empty($username) || empty($userpwd)) {
            $retData = $this->retData;
            $retData['state'] = 'error';
            $retData['message'] = '用户名和密码和手机号不能为空';
            exit("用户名和密码和手机号不能为空");
        }


        $this->load->database();
        $row = $this->db->query('SELECT * FROM cmsadmin WHERE username = "'.$username.'" LIMIT 1')->row_array();
        if(!empty($row)){//用户名错误
            exit("姓名：{$username} 重复！！");
        }

        $userRole = -1;
        if($userRole == 'admin') {
            $urllist = [];
            $package = [];
        }else {
            $urllist= $this->input->post('urllist');
            $package = [];
        }
        $sidList = json_encode($package);
        //插入用户信息表
        if($userRole != 'admin'){
            $is_admin = 0;
            $role = $userRole;
        }else{
            $is_admin = 1;
            $role = 0;
        }
        $data = array(
            'username' => $username,
            'pwd' => md5($userpwd),
            'chinesename' => $username,
            'is_admin' => $is_admin,
            'role' => $role,
            'mobile' => $mobile,
        );
        $this->db->insert('cmsadmin', $data);

        //插入用户权限表
        $permissionData = array(
            'adminid' => $this->db->insert_id(),
            'list' => serialize($urllist),
            'sidList' => $sidList
        );
        $this->db->insert('permission', $permissionData);
        $this->retData['referer'] = 'permission/list';
        exit('ok');
    }

    public function halloweenPuzzle(){
        date_default_timezone_set('UTC');
        define("CURRENT_TIMESTAMP", time());
        jsonDump(HalloweenPuzzle::index(666666)) ;
    }

    public function setUserSsGroups(){
        return;
        $ssGroups = [];
        $uids = [2514677];

        foreach ($uids as $uid){
            $key = okeys::UserDynamicsData($uid);
            $cache    = oo::commonOprRedis('games')->get($key);
            if(empty($cache))continue;
            $userData = json_decode($cache, true);
            $groups = explode(',', $userData['groupId3']);
            $afterGroups = array_unique(array_merge($groups, $ssGroups));
            $userData['groupId3'] = implode(',', $afterGroups);
            oo::commonOprRedis('games')->set($key, json_encode($userData));
        }
    }

    public function genGoodsByGoogsType(){
        $goodsTbl = otable::goodsCrazy();
        $gtypeTbl = otable::gTypeGoods();
        $lastGoods = oo::commonOprDb('games')->getOne("select * from {$goodsTbl} order by gid desc limit 1");
        $existGoodsGtype =  floor(($lastGoods['gid']) / 10000);
        if(empty($existGoodsGtype)){
            echo 'gen failed'.PHP_EOL;
            return;
        }
        $gtypes = oo::commonOprDb('games')->getAll("select * from {$gtypeTbl} where g_type > '{$existGoodsGtype}'");
        $insertData = [];
        foreach ($gtypes as $gtype){
            $insertData[] = [
                'gid' => $gtype['g_type'] * 10000,
                'gpid' => $gtype['g_type'],
                'gname' => $gtype['zh_name'],
                'gname_en' => $gtype['zh_name'],
                'gtype' => $gtype['g_type'],
            ];
        }
        if(empty($insertSql)){
            echo 'no more data'.PHP_EOL;
            return;
        }
        $insertSql = funs::db_intsertArrSQL($goodsTbl, $insertData);
        $res = oo::commonOprDb('games')->query($insertSql);
        var_dump($res);
    }

    public function getUids(){
        $file = __DIR__.'/tokens';
        $f = fopen($file, 'r');
        $arr = [];
        $total = 0;
        while($line = fgets($f)){
            $total++;
            $line = strtr($line, [
                "\r\n" => '',
                "\n" => '',
            ]);
            $arr[$line] = $arr[$line] ?? 0;
            $arr[$line]++;
        }
        fclose($f);
        $tokens = array_keys($arr);
        $tbl = otable::userinfo();
        $tokensList = array_chunk($tokens, 1000);
        $redisKey = 'FBLoginFailedUidSet20231201';
        $result = [];
        foreach ($tokensList as $tokens){
            if (empty($tokens))continue;
            $tokenStr = implode("','", $tokens);
            $sql = "select uid from $tbl where token in ('{$tokenStr}')";
            $uids = oo::commonOprDb('slavedb')->getAll($sql);
            $uids = array_column($uids, 'uid');

            foreach ($uids as $uid){
                $res = oo::commonOprRedis('games')->sAdd($redisKey, $uid);
                $result[$res]++;
            }
            echo 1000 . PHP_EOL;
        }
        echo $total . PHP_EOL;
        echo json_encode($result) . PHP_EOL;
    }

    public function formatAnnualData(){
        return;
        echo time() . PHP_EOL;
        ini_set('memory_limit', -1);
        $rankTbl = otable::annual_rank('2023');
        $table = otable::annual_report('2023');
//        $table .= '_test';
//        $rankTbl .= '_test';
        $rankType = [
            "build",
            "cardset",
            "attack",
            "steal",
        ];
        $list = [];
        $total = 0;
        foreach ($rankType as $type){
            $annualDataList = oo::commonOprDb('report')->getAll("select uid from {$table}  order by {$type} desc");
            if(empty($total))$total = count($annualDataList);

            echo time() . PHP_EOL;
            foreach ($annualDataList as $k => $item){
                $list[$item['uid']][$type.'rank'] = (($total-$k)/$total)*100;
            }
        }

        foreach ($list as $uid => $item){
            $list[$uid]['uid'] = $uid;
        }
        $list = array_chunk($list, 2000);
        foreach ($list as $items){
            $insertSql = funs::db_intsertArrSQL($rankTbl, $items);
            oo::commonOprDb('report')->query($insertSql);
            sleep(1);
        }
        echo time() . PHP_EOL;

    }


    public function testmap(){
        echo time() . PHP_EOL;
       $sql = "select * from crazygod_roport_statistics.t_facebook_ads where date_start >= '2024-01-01' ";
       $res = oo::commonOprDb('report')->getAll($sql);
        echo time() . PHP_EOL;
        echo count($res);
    }


    public function adEffect()
    {
        date_default_timezone_set("UTC");
        $dates = [
            '2023-04-01',
            '2023-05-01',
            '2023-06-01',
        ];
        $dataMonths = [
            7, 8
        ];
        $spendMap = [
            '2023-04-01' => [
                strtolower("Winnie")=>47790.79,
                strtolower("Cindy") => 71850.47,
                strtolower("Lulu") => 79999.52,
                strtolower("Yvette") => 78973.18,
            ],
            '2023-05-01' => [
                strtolower("Winnie")=>77166.03,
                strtolower("Cindy") =>71595.12,
                strtolower("Lulu") => 78679.99,
                strtolower("Yvette") => 78819.62,
            ],
            '2023-06-01' => [
                strtolower("Winnie")=>43699.97,
                strtolower("Cindy") => 66173.40,
                strtolower("Lulu") => 70584.21,
                strtolower("Yvette") => 65932.35,
            ],
        ];
        $userTbl = otable::userinfo();
        $orderTbl = otable::gameOrder();
        $adjustTbl = otable::AdJustData();
        $adjustCliectTbl = otable::AdJustClientUidData();
        $users = [
            strtolower("Winnie")=>47790.79,
            strtolower("Cindy") => 71850.47,
            strtolower("Lulu") => 79999.52,
            strtolower("Yvette") => 78973.18,
        ];
        $aduserAdidMap = [];
        $dataMap = [];
        foreach ($dates as $date){
            echo $date.':'.PHP_EOL;
            $dataMap[$date] = [];
            foreach ($dataMonths as $month) {
                $days = $month * 30;

                $beginTime = strtotime($date);
                $endTime = strtotime('+1 month', $beginTime);
                $orderEndTime = strtotime("+{$month} month", $endTime);
                $orderEndDate = date('Y-m-d H:i:s', $orderEndTime);
                $loginBeginTime = strtotime("+{$month} month", $beginTime);

                $sql = "select adid, campaign_name from {$adjustTbl} where created_at > {$beginTime} and created_at< {$endTime}";
                $adids = oo::commonOprDb('slavedb')->getAll($sql);
                foreach ($users as $user=>$spend){
                    $aduserAdidMap[$user] = [];
                    foreach ($adids as $k => $item){
                        if (empty($item['campaign_name'])){
                            unset($adids[$k]);
                            continue;
                        }
                        if (strpos(strtolower($item['campaign_name']), "_{$user}_") !== false){
                            $aduserAdidMap[$user][] = $item['adid'];
                            unset($adids[$k]);
                        }
                    }
                }

                foreach ($aduserAdidMap as $user => $adids){
                    $adidStr = implode("','", $adids);
                    $sql = " SELECT uid FROM  {$adjustCliectTbl}  WHERE adid in ('$adidStr') ";
                    $userData = oo::commonOprDb('slavedb')->getAll($sql);
                    $uids = array_column($userData, 'uid');

                    $uidStr = implode("','", $uids);
                    $sql = "select sum(price) as price from {$orderTbl} where status=4 and uid in ('$uidStr') and created_at < '{$orderEndDate}'";
                    $paymentData = oo::commonOprDb('slavedb')->getOne($sql);

                    $sql = "select count(uid) as total from {$userTbl} where  uid in ('$uidStr') and lasttime > '{$loginBeginTime}'";
                    $loginData = oo::commonOprDb('slavedb')->getOne($sql);

                    $spend = $spendMap[$date][$user];
                    $userCnt = count($uids);
                    $liucun = number_format($loginData['total'] / $userCnt, 4);
                    $roi = $paymentData['price']/$spend;
                    $dataMap[$date][$user] = $dataMap[$date][$user] ?? [
                        '用户' =>$user,
                        '月份' => $date,
                        "买量用户" => $userCnt,
                        "买量花费" => $spend,
                        "{$days}收入" => $paymentData['price'],
                        "{$days}留存用户" => $loginData['total'],
                        "{$days}留存率" => $liucun,
                        "{$days}ROI" => $roi,
                    ];
                    $dataMap[$date][$user]["{$days}收入"] = $paymentData['price'];
                    $dataMap[$date][$user]["{$days}留存用户"] = $loginData['total'];
                    $dataMap[$date][$user]["{$days}留存率"] = $liucun;
                    $dataMap[$date][$user]["{$days}ROI"] = $roi;
                }
                echo json_encode($dataMap[$date]);
            }
            echo PHP_EOL;
            echo PHP_EOL;
        }

        $file = './ads'.time().'.csv';
        $f = fopen($file, 'w');
        $header = ['用户', '月份', '买量用户', '买量花费', '210收入', '210留存用户', '210留存率', '210ROI', '240收入', '240留存用户', '240留存率', '240ROI'];
        fputcsv($f, $header);
        foreach ($dataMap as $date => $userMap){

            foreach ($userMap as $user => $item){
                $line = [];
                foreach ($header as $hk){
                    $line[] = $item[$hk];
                }
                fputcsv($f, $line);
            }

        }
        fclose($f);
    }



    public function parseSpinsMasterUserRewards(){
        ini_set('memory_limit', -1);
        $file = __ROOT__ . '/Excel/spinsmasteruserrewards.xlsx';
        $extensionType = $this->getExtensionType($file);
        $xlsReader = IOFactory::createReader($extensionType);
        $xlsReader->setReadDataOnly(true);
        $xlsReader->setLoadSheetsOnly(true);
        $Sheets = $xlsReader->load($file);

        $sheet = $Sheets->getSheet(0)->toArray();
        $userRewardsMap = [];
        $antModel = new ActBaseModel();
        for($i= 1;$i<count($sheet);$i++){
            $lineData = $sheet[$i];
            $rewards = $antModel->parseLineRewards(array_slice($lineData, 1));
            foreach ($rewards as $k => $reward){
                $rewards[$k] = [
                    "propsId" => $reward['type'],
                    "rtype" => $reward['rtype'],
                    "num" => $reward['num'],
                    "skin" => $reward['skin']
                ];
            }
            $userRewardsMap[$lineData[0]] = $rewards;
        }
        echo json_encode($userRewardsMap);
    }

    public function getCountryIncome()
    {
        ini_set('memory_limit', -1);
        $userAddrTbl = otable::useraddress();
        $userAddrRows = oo::commonOprDb('slavedb')->getAll("Select * From {$userAddrTbl} Where `uid` >= 1321383");
        $userAddrMap = array_column($userAddrRows, 'country_code', 'uid');
        unset($userAddrRows);

        $tb = otable::paidStat();
        $paidRows = oo::commonOprDb('slavedb')->getAll("Select `amount`,`uid`  From {$tb} Where `uid` >= 1321383");


        $incomeMap = [];
         foreach ($paidRows as $row){
             $countryCode = $userAddrMap[$row['uid']] ?? 'null';
             $incomeMap[$countryCode] = $incomeMap[$countryCode] ?? 0;
             $incomeMap[$countryCode] += $row['amount'];
         }

         echo json_encode($incomeMap);
    }

    public function updateLastTime()
    {
        $time = time() - 3600 * 180;
        $uids = [4956413, ];
        $res = [];
        foreach ($uids as $uid){
            $res[$uid] = [];
            $key = okeys::t_userinfoNew($uid);
            $tbl = otable::userinfo();
            $res[$uid]['redis'] = oo::commonOprRedis('games')->hSet($key, 'lasttime', $time);
            $res[$uid]['db'] = oo::commonOprDb('games')->query("update {$tbl} set lasttime='{$time}' where uid='{$uid}'");
        }
        echo 'newtime:'.$time;
    }

    public function formatPublicGroupConfigData()
    {
        return;
        ini_set('memory_limit', -1);

        $inserts = [];
        $groupConfMap = [
//            'cf' => [
//                'prod'
//            ],
//            'cc' => [
//                'test',
//                'prod',
//            ],
            'cc3' => [
                'test',
                'prod',
            ],
        ];
        $publicGroupConfigTbl = 'game_cms.group_config';
        foreach ($groupConfMap as $game => $envList){
            foreach ($envList as $env){
                $tbl = "game_cms.{$env}_group_config";
                $groupConfigs = oo::commonOprDb("{$game}_cms")->getAll("select * from {$tbl} ");
                $parentIdMap = [
                    1 => 1
                ];
                foreach ($groupConfigs as $groupConfig){
                    $oldId = $groupConfig['id'];
                    $groupConfig['parent'] = $parentIdMap[$groupConfig['parent']] ?? 1;
                    $groupConfig['game'] = $game;
                    $groupConfig['env'] = $env;
                    unset($groupConfig['id']);
                    $insertSql = funs::db_insertSQL($publicGroupConfigTbl, $groupConfig);
                    $res = oo::commonOprDb("public")->query($insertSql);
                    if (!$res){
                        echo 'insert error:'.json_encode($groupConfig);
                        die;
                    }
                    $parentIdMap[$oldId] = oo::commonOprDb("public")->insertID();
                }
            }
        }

    }
    public function formatPublicUserGroupConfigData()
    {
        return;
        ini_set('memory_limit', -1);
        $groupConfMap = [
//            'cf' => [
//                'test',
//                'prod'
//            ],
//            'cc' => [
//                'test',
//                'prod',
//            ],
            'cc3' => [
                'test',
                'prod',
            ],
        ];

        $publicGroupConfigTbl = 'game_cms.group_config';
        $groupConfigs = oo::commonOprDb("public")->getAll("select * from {$publicGroupConfigTbl}");
        $groupConfigIdMap = [];
        foreach ($groupConfigs as $groupConfig){
            $key = "{$groupConfig['game']}_{$groupConfig['env']}_{$groupConfig['name']}";
            $groupConfigIdMap[$key] = $groupConfig['id'];
        }
        $insertData = [];
        foreach ($groupConfMap as $game => $envList){
            foreach ($envList as $env){
                echo "{$game}:{$env} begin" . PHP_EOL;
                $tmpGroupNameIdMap = [];
                $tbl = "game_cms.{$env}_group_config";
                $groupConfigs = oo::commonOprDb("{$game}_cms")->getAll("select * from {$tbl} ");
                foreach ($groupConfigs as $groupConfig){
                    $tmpGroupNameIdMap[$groupConfig['id']] = "{$game}_{$env}_{$groupConfig['name']}";
                }

//                echo json_encode($tmpGroupNameIdMap);
                $tbl = "game_cms.{$env}_user_group";
                $userGroupConfigs = oo::commonOprDb("{$game}_cms")->getAll("select * from {$tbl} ");
                foreach ($userGroupConfigs as $userGroupConfig){
                    $oldGroupIdKey = $tmpGroupNameIdMap[$userGroupConfig['group_id']] ?? "";
                    $newGroupId = $groupConfigIdMap[$oldGroupIdKey] ?? 0;
                    $insertData[] = [
                        'game' => $game,
                        'env' => $env,
                        'uid' => $userGroupConfig['uid'],
                        'group_id' => $newGroupId,
                        'creator' => $userGroupConfig['creator'],
                        'created_at' => $userGroupConfig['created_at'],
                        'updated_at' => $userGroupConfig['updated_at'],
                    ];
                }
            }
        }


        $publicUserGroupTbl = 'game_cms.user_group';
        $insertSql = funs::db_intsertArrSQL($publicUserGroupTbl, $insertData);
        $res = oo::commonOprDb("public")->query($insertSql);
        var_dump($res);

    }

    public function redeliveryRewards()
    {
        return;
        $msgId = 100028;
        $file = __DIR__ . '/../../Excel/20240805_060352_05890_a3rp6.xlsx';
        $data = $this->getImportData($file);
        if (empty($data[0])){
            echo "data id empty!" . PHP_EOL;
            die;
        }
        $errItem = [];
        $sendErr = [];
        for ($i = 1; $i < count($data[0]); $i++) {
            echo $i . PHP_EOL;
            $uid = intval($data[0][$i][0]);
            $num = intval($data[0][$i][1]);
            if(empty($uid) || empty($num)){
                $errItem[] = [
                    'uid' => $uid,
                    'num' => $num,
                ];
            }
            $rewards = [
                [
                    'propsId' => 15,
                    'num' => $num,
                ]
            ];
            $res = SvenModel::sendRewardToEmail($msgId, $uid, $rewards);
            if (!$res){
                $sendErr[] =  [
                    'uid' => $uid,
                    'num' => $num,
                ];
            }
        }

        echo json_encode([$errItem, $sendErr]);
    }
}


