<?php

require_once __DIR__ . '/Activity/ActInterface.php';
$actModelDir = __DIR__ . '/Activity';
$dh = opendir($actModelDir);
while ($file = readdir($dh)) {
    if (in_array($file, ['.', '..'])) continue;
    require_once __DIR__ . '/Activity/' . $file;
}

class ActBaseModel
{
    static $gtypeMap;
    static $gid;
    const ACT_LIST = [
        MAYA_WHEEL,
        LUCKY_FOX,
        SUPER_GASHAPON,
        PINATA,
        LUCKY_JOURNEY,
        TREASURE,
        COLLECT_ACT_COUPON,
        TRAFFIC_PERMIT,
        SERIAL_MISSIONS,
        CRAZY_TOKEN,
        CHOOSE_ONE,
        WARMUP_NOTICE,
        TIME_LIMITED_ISLAND,
        SLOT_WEIGHT_FIX,
        ONEPLUSMORE,
        MYSTERY_MINE,
        SUPER_BINGO,
        DREAM_MISSIONS,
        SURPRISE_DICE,
        KING_OF_CARDS_NEW,
        KING_OF_CARDS_LEGEND,
        FREE_SPIN,
        CLUB_TOURNAMENT,
        HIDDEN_TREASURES,
        SPIN_PIGGY_REWARD,
        CRAZY_TOKEN_2,
        MULTIROUND_TIME_LIMITED_CARD,
    ];
    const IMPORT_ACT_LIST = [
        MAYA_WHEEL          =>'玛雅转盘' ,
        LUCKY_FOX           =>'幸运狐狸' ,
        SUPER_GASHAPON      =>'超级扭蛋' ,
        PINATA              =>'皮纳塔' ,
        LUCKY_JOURNEY       =>'幸运旅途' ,
//        TREASURE            =>'宝藏活动' ,
        COLLECT_ACT_COUPON  =>'活动券收集' ,
        TRAFFIC_PERMIT      =>'通行证' ,
        SERIAL_MISSIONS     =>'连环成就任务' ,
        CRAZY_TOKEN         =>'疯狂代币' ,
        CHOOSE_ONE          =>'导入二选一' ,
        WARMUP_NOTICE       =>'预热公告' ,
        TIME_LIMITED_ISLAND =>'限时岛屿' ,
        ONEPLUSMORE         =>'1+n礼包' ,
        MYSTERY_MINE         =>'神秘宝矿' ,
        SUPER_BINGO         =>'超级宾果' ,
        DREAM_MISSIONS      =>'梦想任务',
        SURPRISE_DICE      =>'惊喜骰子',
        KING_OF_CARDS_NEW   =>'卡牌之王-大奖版',
        KING_OF_CARDS_LEGEND =>'卡牌之王-传说版',
        FREE_SPIN =>'freespin金币老虎机',
        CLUB_TOURNAMENT =>'公会锦标赛',
        HIDDEN_TREASURES =>'隐秘宝藏',
        SPIN_PIGGY_REWARD =>'体力罐限时奖励',
        CRAZY_TOKEN_2 =>'代币宝藏',
        MULTIROUND_TIME_LIMITED_CARD =>'多轮限时卡组',
    ];

    static $taskMapping = [
        1 => '累计登陆天数',// Task_sumLogin
        2 => '建造次数',// Task_build
        3 => '偷次数',// Task_steal
        4 => '打次数',// Task_attack
        5 => '用宠物偷次数',// Task_useStealPet
        6 => '用宠物打次数',// Task_useAttackPet
        7 => '喂食宠物次数',// Task_feedPet
        8 => '喂食偷宠物次数',// Task_feedStealPet
        9 => '喂食打宠物次数',// Task_feedAttackPet
        10 => '喂食盾宠物次数',// Task_feedShieldPet
        11 => '升级宠物次数',// Task_upPetLevel
        12 => '升级偷宠物次数',// Task_upStealPetLevel
        13 => '升级打宠物次数',// Task_upAttackPetLevel
        14 => '升级盾宠物次数',// Task_upShieldPetLevel
        15 => '获取卡片次数',// Task_getCard
        16 => '获取新的黑金卡次数',// Task_getBlackGoldCard
        17 => '使用小丑卡次数',// Task_useJokerCard
        18 => '支付次数',// Task_pay
        19 => '开启付费通行证',// Task_openPassGame
        20 => '购买偷惊喜礼包',// Task_buyStealSurpriseGift
        21 => '购买打惊喜礼包',// Task_buyAttackSurpriseGift
        22 => '锦标赛排名第1名',// Task_rankingLimit_1
        23 => '锦标赛排名前3',// Task_rankingLimit_3
        24 => '锦标赛排名前10',// Task_rankingLimit_10
        25 => '完成体力大师层数',// Task_passSpinMaster
        26 => '完成拼图张数',// Task_finishJigasw
        27 => '打开限时宝箱个数',// Task_openTimelimitedChest
        28 => '通关金币老虎机次数',// Task_PassTreasureTimes
        29 => '收集黑金卡张数',//Task_getBlackGoldCard
        30 => '收集金卡张数',//Task_getGoldCard
        31 => '锦标赛排名前5',//Task_rankingLimit_5
        32 => '分享游戏次数',//Task_share
        33 => '锦标赛排名前20',//Task_rankingLimit_20
        34 => '使用皮纳塔代币',//Task_usePinataToken
        35 => '使用玛雅代币',//Task_useMayaToken
        36 => '使用扭蛋代币',//Task_useSuperEggToken
        37 => '使用幸运狐狸代币',//Task_useLuckyFoxToken
        38 => '使用幸运旅途代币',//Task_useLuckyJourney
        39 => '使用限时岛屿建造代币',//Task_useLTBuildToken 
        40 => '使用神秘宝矿代币',//Task_useMysteryMineToken
        41 => '使用惊喜骰子代币',//Task_useSurpriseDice
        42 => '使用隐秘宝藏代币',//Task_useHiddenTreasureToken
        43 => 'freespin金币老虎机通关'//Task_passFreeSpin
    ];

    static $actTypeMapping = [];
    static $actGroupMapping = [];
    static $multiNumTypeReward = [
        '随机金卡',
        '随机黑金卡',
        '随机限时金卡',
        '随机限时黑金卡',
        '随机限时彩虹卡',
        '金币'
    ];
    static $rewardNames = [];
    static $needSkinRewards = [];

    static $actModels = [];

    protected $goodSku;
    protected $actType;

    function __construct($actType = '')
    {

        $actTypes = oo::commonOprDb('report')->getAll("SELECT * FROM " . otable::actTypes());
        foreach ($actTypes as $row){
            self::$actTypeMapping[$row['activity_type']] = $row['name'];
        }

        $this->goodSku = oo::cfg('sku');
        $this->actType = $actType;
    }
    // redis最少一分钟, 最大7天
    static function getActCacheExpireTime($endTime){
        $time = time();
        return min(max($endTime, $time + 60), $time + 86400 * 7 );
    }

    static function getActModel(string $actType): ActInterface
    {
        if (isset(self::$actModels[$actType]) && self::$actModels[$actType] instanceof ActInterface) return self::$actModels[$actType];
        switch ($actType) {
            case MAYA_WHEEL:
                self::$actModels[$actType] = new MayaActModel($actType);
                break;
            case LUCKY_FOX:
                self::$actModels[$actType] = new LuckyFoxActModel($actType);
                break;
            case SUPER_GASHAPON:
                self::$actModels[$actType] = new SuperGashaponActModel($actType);
                break;
            case PINATA:
                self::$actModels[$actType] = new PinataActModel($actType);
                break;
            case LUCKY_JOURNEY:
                self::$actModels[$actType] = new LuckyJourneyModel($actType);
                break;
            case TREASURE:
                self::$actModels[$actType] = new TreasureActModel($actType);
                break;
            case COLLECT_ACT_COUPON:
                self::$actModels[$actType] = new CollectActCouponActModel($actType);
                break;
            case TRAFFIC_PERMIT:
                self::$actModels[$actType] = new TrafficPermitActModel($actType);
                break;
            case SERIAL_MISSIONS:
                self::$actModels[$actType] = new SerialMissionsActModel($actType);
                break;
            case CRAZY_TOKEN:
            case CRAZY_TOKEN_2:
                self::$actModels[$actType] = new CrazyTokenModel($actType);
                break;
            case CHOOSE_ONE:
                self::$actModels[$actType] = new ChooseOneActModel($actType);
                break;
            case TIME_LIMITED_ISLAND:
                self::$actModels[$actType] = new TimeLimitedIslandModel($actType);
                break;
            case WARMUP_NOTICE:
                self::$actModels[$actType] = new WarmupNoticeActModel($actType);
                break;
            case SLOT_WEIGHT_FIX:
                self::$actModels[$actType] = new SlotWeightFixActModel($actType);
                break;
            case ONEPLUSMORE:
                self::$actModels[$actType] = new OnePlusMoreActModel($actType);
                break;
            case MYSTERY_MINE:
                self::$actModels[$actType] = new MysteryMineActModel($actType);
                break;
            case SUPER_BINGO:
                self::$actModels[$actType] = new SuperBingoActModel($actType);
                break;
            case DREAM_MISSIONS:
                self::$actModels[$actType] = new DreamMissionsActModel($actType);
                break;
            case SURPRISE_DICE:
                self::$actModels[$actType] = new SurpriseDiceActModel($actType);
                break;
            case KING_OF_CARDS_NEW:
            case KING_OF_CARDS_LEGEND:
                self::$actModels[$actType] = new KingOfCardNewActModel($actType);
                break;
            case FREE_SPIN:
                self::$actModels[$actType] = new FreeSpinActModel($actType);
                break;
            case CLUB_TOURNAMENT:
                self::$actModels[$actType] = new ClubTournamentActModel($actType);
                break;
            case HIDDEN_TREASURES:
                self::$actModels[$actType] = new HiddenTreasuresActModel($actType);
                break;
            case SPIN_PIGGY_REWARD:
                self::$actModels[$actType] = new SpinPiggyRewardActModel($actType);
                break;
            case MULTIROUND_TIME_LIMITED_CARD:
                self::$actModels[$actType] = new MultiRoundTimeLimitedCardsModel($actType);
                break;
            default:
                self::response(__LINE__, "活动类型model不存在：" . $actType);
        }
        return self::$actModels[$actType];
    }

    static function response($ret = 0, $msg = '', array $data = array(), $type = false): string
    {
        header('Content-type:text/json');
        $result = [
            'ret' => $ret,
            'msg' => $msg,
            'data' => $data,
            'state' => $ret ? "error" : 'success'
        ];
        if ($type) {
            die(json_encode($result));
        } else {
            die(json_encode($result, JSON_NUMERIC_CHECK));
        }
        return '';
    }

    // 解析三层映射关系 等级 => 体力 => 数数分组 3层嵌套
    public function parseLvSpinsShushuStagesMapping(array $stagesMappingArray): array
    {
        $rewardsConfig = $idxMapping = [];

        foreach ($stagesMappingArray as $k => $item) {
            if (empty($k)) continue;
            list($idx, $lvMin, $lvMax, $spinsMin, $spinsMax, $ssGroup) = $item;
            $lvKey = "{$lvMin}-$lvMax";
            $spinsKey = "{$spinsMin}-{$spinsMax}";

            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);
            $spinsIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SPINS, $spinsKey, $lvIdx);
            $ssIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SHUSHU, $ssGroup, "{$spinsIdx}_{$lvIdx}");

            if (empty($rewardsConfig[$lvIdx]))
                $rewardsConfig[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                    'start' => $lvMin,
                    'end' => $lvMax,
                ];
            if (empty($rewardsConfig[$lvIdx]['stages'][$spinsIdx]))
                $rewardsConfig[$lvIdx]['stages'][$spinsIdx] = [
                    'stages' => [],
                    'spinsStart' => $spinsMin,
                    'spinsEnd' => $spinsMax,
                    'start' => $spinsMin,
                    'end' => $spinsMax,
                ];

            $shushus = $this->parseShushuGroups($ssGroup);
            if (empty($rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]))
                $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx] = [
                    'stages' => [],
                    'shushu' => $shushus,
                ];


            $idxMapping[$idx] = [$lvIdx, $spinsIdx, $ssIdx];
        }


        return [$rewardsConfig, $idxMapping];
    }

    // 解析两层映射关系 等级 => 体力 2层嵌套
    public function parseLvSpinsStagesMapping(array $stagesMappingArray): array
    {
        $rewardsConfig = $idxMapping = [];

        for ($i = 1; $i < count($stagesMappingArray); $i++) {
            $item = $stagesMappingArray[$i];
            if (empty(array_filter($item))) continue;

            list($idx, $lvMin, $lvMax, $spinsMin, $spinsMax) = $item;
            $lvKey = "{$lvMin}-$lvMax";
            $spinsKey = "{$spinsMin}-{$spinsMax}";
            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);
            $spinsIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SPINS, $spinsKey, $lvIdx);

            if (empty($rewardsConfig[$lvIdx]))
                $rewardsConfig[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                    'start' => $lvMin,
                    'end' => $lvMax,
                ];
            if (empty($rewardsConfig[$lvIdx]['stages'][$spinsIdx]))
                $rewardsConfig[$lvIdx]['stages'][$spinsIdx] = [
                    'stages' => [],
                    'spinsStart' => $spinsMin,
                    'spinsEnd' => $spinsMax,
                    'start' => $spinsMin,
                    'end' => $spinsMax,
                ];

            $idxMapping[$idx] = [$lvIdx, $spinsIdx];
        }

        return [$rewardsConfig, $idxMapping];
    }

    public function parseLvStagesMapping(array $stagesMappingArray): array
    {
        $rewardsConfig = $idxMapping = [];
        for ($i = 1; $i < count($stagesMappingArray); $i++) {
            $item = $stagesMappingArray[$i];
            if (empty(array_filter($item))) continue;

            list($idx, $lvMin, $lvMax) = $item;
            $lvKey = "{$lvMin}-$lvMax";
            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);

            if (empty($rewardsConfig[$lvIdx]))
                $rewardsConfig[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                    'start' => $lvMin,
                    'end' => $lvMax,
                ];

            $idxMapping[$idx] = [$lvIdx];
        }

        return [$rewardsConfig, $idxMapping];
    }

    // 解析两层映射关系 等级 => 数数分组 2层嵌套
    public function parseLvShushuStagesMapping(array $stagesMappingArray): array
    {
        $rewardsConfig = $idxMapping = [];

        for ($i = 1; $i < count($stagesMappingArray); $i++) {
            $item = $stagesMappingArray[$i];
            if (empty(array_filter($item))) continue;

            list($idx, $lvMin, $lvMax, $shushuGroups) = $item;
            $lvKey = "{$lvMin}-$lvMax";
            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);
            $ssIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SHUSHU, $shushuGroups, $lvIdx);

            if (empty($rewardsConfig[$lvIdx]))
                $rewardsConfig[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                    'start' => $lvMin,
                    'end' => $lvMax,
                ];
            if (empty($rewardsConfig[$lvIdx]['stages'][$ssIdx]))
                $rewardsConfig[$lvIdx]['stages'][$ssIdx] = [
                    'stages' => [],
                    'shushu' => $this->parseShushuGroups($shushuGroups),
                ];

            $idxMapping[$idx] = [$lvIdx, $ssIdx];
        }

        return [$rewardsConfig, $idxMapping];
    }

    // 解析一层映射关系 数数分组 2
    public function parseShushuStagesMapping(array $stagesMappingArray): array
    {
        $rewardsConfig = $idxMapping = [];

        for ($i = 1; $i < count($stagesMappingArray); $i++) {
            $item = $stagesMappingArray[$i];
            if (empty(array_filter($item))) continue;

            list($idx, $shushuGroups) = $item;
            $ssIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SHUSHU, $shushuGroups);

            if (empty($rewardsConfig['stages'][$ssIdx]))
                $rewardsConfig['stages'][$ssIdx] = [
                    'stages' => [],
                    'shushu' => $this->parseShushuGroups($shushuGroups),
                ];

            $idxMapping[$idx] = [$ssIdx];
        }

        return [$rewardsConfig, $idxMapping];
    }


    # 通过奖励名 解析奖励类型以及皮肤id
    public function parseRewardTypeAndSkinId($rewardName, $line = 0)
    {
        // 无皮肤道具
        if (empty(self::$rewardNames)){
            self::$rewardNames = ConfigModel::getPropsNameIdMapBySkinStatus(0);
        }

        // 有皮肤道具
        if (empty(self::$needSkinRewards)){
            self::$needSkinRewards = ConfigModel::getPropsNameIdMapBySkinStatus(1);
        }

        #常规奖励 无皮肤
        if (!empty(self::$rewardNames[$rewardName])) {
            return [self::$rewardNames[$rewardName], ''];
        }
        $prizeList = oo::commonOprModel('config')->getPropsConfigFromLocal();
        foreach ($prizeList as $item) {
            if (empty($item['skinList'])) continue;
            foreach ($item['skinList'] as $skinItem) {
                if ($skinItem['name'] == $rewardName && !empty(self::$needSkinRewards[$item['name']])) {
                    return [self::$needSkinRewards[$item['name']], $skinItem['id']];
                }
            }
        }
        #判断奖励是否存在
        self::response(-1, "第{$line}行,奖励或皮肤不存在:'{$rewardName}'", [$prizeList, self::$needSkinRewards, self::$rewardNames]);
    }

    # 通过分组名，解析分组id
    public function parseShushuGroups($shushuGroups, $line = 0)
    {
        if (empty($shushuGroups)) self::response(-1, $line . '行，数数分组为空');
        if (is_string($shushuGroups)) {
            $shushuGroups = strtr($shushuGroups, ['，' => ',']);
            $shushuGroups = explode(',', $shushuGroups);
        }
        $allGroups = array_column(oo::commonOprModel('config')->getUserGroupConfigByCid(5), 'name', 'id');
        $allGroups = oo::commonOprModel('config')->hideSSGroup($allGroups);;
        $shushuGroupIds = [];
        foreach ($shushuGroups as $shushuGroup) {
            if (!in_array($shushuGroup, $allGroups)) self::response(-1, "第{$line}行,数数分组不存在:'{$shushuGroup}'");
            $shushuGroupIds[] = array_search($shushuGroup, $allGroups);
        }
        return $shushuGroupIds;
    }

    # 通过虎机概率分组名，解析 老虎机概率分组id
    public function parseSlotWeightGroups(string $slotWeightGroupName, $line = 0): int
    {
        if (empty($slotWeightGroupName)) self::response(-1, $line . '行，老虎机概率分组为空');

        $groupsTbl = otable::slotWeightGroups();
        $groups = oo::commonOprDb('slavedb')->getOne("select * from {$groupsTbl} where `name`='{$slotWeightGroupName}'");
        if (empty($groups['id'])) self::response(-1, "第{$line}行,老虎机概率分组不存在:'{$slotWeightGroupName}'");
        return intval($groups['id']);
    }

    # 解析分层映射的每层idx
    public function getGroupMappingIdx($type, $val, $parentsKey = 0)
    {
        self::$actGroupMapping[$type] = self::$actGroupMapping[$type] ?? [];
        self::$actGroupMapping[$type][$parentsKey] = self::$actGroupMapping[$type][$parentsKey] ?? [];
        if (empty(self::$actGroupMapping[$type][$parentsKey][$val])) {
            self::$actGroupMapping[$type][$parentsKey][$val] = count(self::$actGroupMapping[$type][$parentsKey]) + 1;
        }
        return intval(self::$actGroupMapping[$type][$parentsKey][$val]);
    }

    # 解析一行奖励
    public function parseLineRewards(array $rewards, $line = 0)
    {
        $rewardsTemp = [];
        $i = 0;
        while ($i < count($rewards)) {
            $reward = $rewards[$i++];
            $isFixNum = $rewards[$i++];
            $rewardNum = intval($rewards[$i++]);
            if (!empty($reward)) {
                if (!in_array($reward, self::$multiNumTypeReward)) $isFixNum = '是';   #非金币奖励，全部固定值奖励
                $isFixNum = ($isFixNum == '是') ? 1 : 2;#固定值奖励 1 按等级取值 2
                list($type, $skin) = $this->parseRewardTypeAndSkinId($reward, $line);

                if (empty($rewardNum)) self::response(-1, "第{$line}行,奖励数为空", $rewards);
                $currentId = count($rewardsTemp) + 1;
                $rewardsTemp[] = [
                    'id' => $currentId,
                    "num" => $rewardNum,
                    "type" => $type,
                    "rtype" => $isFixNum,
                    "skin" => intval($skin)
                ];
            }
        }
        return $rewardsTemp;
    }

    # 解析是否 是 1 否 0
    public function parseYesOrNo($text): int
    {
        return $text == '是' ? 1 : 0;
    }

    public function writeActCacheCommonLvSpinsShushu(array $actConfig, string $configColumn = 'reward_info'): bool
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $rewardInfo = json_decode($actConfig[$configColumn], true);
        foreach ($rewardInfo as $idx1 => $item1) {
            foreach ($item1['stages'] as $idx2 => $item2) {
                foreach ($item2['stages'] as $idx3 => $item3) {
                    $stageKey = "{$idx1}_{$idx2}_{$idx3}";
                    $stageConditions = $this->getStageConditionLvSpinsShushu($item1, $item2, $item3);
                    oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, JSON_NUMERIC_CHECK));
                    oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3, JSON_NUMERIC_CHECK));
                }
            }
        }

        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        return true;
    }

    protected function getStageConditionLvSpinsShushu(array $lvItem, $spinsItem, $shushuItem): array
    {

        return [
            [
                "start" => $lvItem['lvStart'] ?? $lvItem['start'],
                "end" => $lvItem['lvEnd'] ?? $lvItem['end'],
                "shushu" => [],
                "type" => CONDITION_TYPE_LV
            ],
            [
                "start" => min($spinsItem['spinsStart'] ?? $spinsItem['start'], PHP_INT_MAX),
                "end" =>   min($spinsItem['spinsEnd'] ?? $spinsItem['end'], PHP_INT_MAX),
                "shushu" => [],
                "type" => CONDITION_TYPE_SPINS
            ],
            [
                "start" => 0,
                "end" => 0,
                "shushu" => $shushuItem['shushu'],
                "type" => CONDITION_TYPE_SHUSHU
            ],

        ];
    }
    protected function getStageConditionLvYShushu(array $lvItem, $yItem, $shushuItem): array
    {

        return [
            [
                "start" => $lvItem['lvStart'] ?? $lvItem['start'],
                "end" => $lvItem['lvEnd'] ?? $lvItem['end'],
                "shushu" => [],
                "type" => CONDITION_TYPE_LV
            ],
            [
                "start" => min($yItem['yStart'] ?? $yItem['start'], PHP_INT_MAX),
                "end" =>   min($yItem['yEnd'] ?? $yItem['end'], PHP_INT_MAX),
                "shushu" => [],
                "type" => CONDITION_TYPE_COIN_Y
            ],
            [
                "start" => 0,
                "end" => 0,
                "shushu" => $shushuItem['shushu'],
                "type" => CONDITION_TYPE_SHUSHU
            ],

        ];
    }
    protected function getStageConditionLv(array $lvItem): array
    {
        return [
            [
                "start" => $lvItem['lvStart'] ?? $lvItem['start'],
                "end" => $lvItem['lvEnd'] ?? $lvItem['end'],
                "shushu" => [],
                "type" => CONDITION_TYPE_LV
            ],
        ];
    }
    protected function getStageConditionLvSpins(array $lvItem, $spinsItem): array
    {
        return [
            [
                "start" => $lvItem['lvStart'] ?? $lvItem['start'],
                "end" => $lvItem['lvEnd'] ?? $lvItem['end'],
                "shushu" => [],
                "type" => CONDITION_TYPE_LV
            ],
            [
                "start" => min($spinsItem['spinsStart'] ?? $spinsItem['start'], PHP_INT_MAX),
                "end" =>   min($spinsItem['spinsEnd'] ?? $spinsItem['end'], PHP_INT_MAX),
                "shushu" => [],
                "type" => CONDITION_TYPE_SPINS
            ]

        ];
    }
    protected function getStageConditionLvShushu(array $lvItem, $ssItem): array
    {
        return [
            [
                "start" => $lvItem['lvStart'] ?? $lvItem['start'],
                "end" => $lvItem['lvEnd'] ?? $lvItem['end'],
                "shushu" => [],
                "type" => CONDITION_TYPE_LV
            ],
            [
                "start" => 0,
                "end" => 0,
                "shushu" => $ssItem['shushu'],
                "type" => CONDITION_TYPE_SHUSHU
            ]

        ];
    }

    //
    protected function getSkuByPrice($price, $allowedFree = false): string
    {
        foreach ($this->goodSku as $skuPrice) {
            if ($skuPrice['price'] == $price) {
                return $skuPrice['sku'];
            }
        }
        if(!empty($price))$this->response(__LINE__, '价格配置异常：' . $price);
        if ($allowedFree) return '';
        return $this->response(__LINE__, '价格配置异常：' . $price);
    }

    protected function saveTokenGoods(array &$actConfig, string $savedColumn)
    {
        $gtype = $this->getGtypeByActType($actConfig['type']);
        self::$gid = $gtype * 10000;
        foreach ($actConfig['tokenGoods'] as $k => $tokenGood) {
            self::$gid += 1000;
            $actConfig['tokenGoods'][$k] = $this->formatTokenGoods($actConfig['type'], $tokenGood);
        }
        $actConfig[$savedColumn] = $actConfig['tokenGoods'];
        unset($actConfig['tokenGoods']);
    }

    // 代币商品格式化
    protected function formatTokenGoods(string $actType, array $tokenGoods): array
    {
        switch ($actType) {
            case MAYA_WHEEL:
                $propId = 45;
                break;
            case LUCKY_FOX:
                $propId = 51;
                break;
            case SUPER_GASHAPON:
                $propId = 60;
                break;
            case PINATA:
                $propId = 62;
                break;
            case LUCKY_JOURNEY:
                $propId = 65;
                break;
            case MYSTERY_MINE:
                $propId = 71;
                break;
            case SURPRISE_DICE:
                $propId = 74;
                break;
            case HIDDEN_TREASURES:
                $propId = 77;
                break;
            default:
                self::response(__LINE__, '不支持代币弹窗的活动：' . $actType);
        }
        $goods = [
            'exceed' => $tokenGoods['exceed'],
            'goods' => []
        ];
        foreach ($tokenGoods['goods'] as $tokenGood) {
            if(empty($tokenGood['tokenNum'])){
                self::response(__LINE__, '代币数为空');
            }
           if(floatval($tokenGood['discount'])<=0||floatval($tokenGood['discount'])>1){
                self::response(__LINE__, '折扣配置异常，不能为空或0或大于1');
            }
            $tokenGood['sku'] = $this->getSkuByPrice($tokenGood['price']);
            $tokenGood['gid'] = self::$gid++;
            $tokenGood['prize'] = [
                [
                    "id" => "1",
                    "rtype" => "1",
                    "num" => $tokenGood['tokenNum'],
                    "type" => $propId,
                ]
            ];
            $goods['goods'][] = $tokenGood;
        }
        return $goods;
    }

    // 代币商品格式化
    protected function formatTokenGoodsSheet(array &$actConfig, $noTokenConfigArray, $idxMapping)
    {
        $gtype = $this->getGtypeByActType($actConfig['type']);
        if(empty($gtype))self::response(__LINE__, '不支持代币弹窗的活动：' . $actConfig['type']);

        $tokenGoods = [];
        $tokenGoodsMax = 3;
        foreach ($noTokenConfigArray as $k => $item) {
            if (empty($k)) continue;
            if (empty(array_filter($item))) continue;
            @list($idx, $stage, $price, $discount, $tokenNum, $exceed) = $item;
            if (empty($idxMapping[$idx])) self::response(__LINE__, '索引id不存在：' . $idx);
            $stageKey = $this->getStageKey($idxMapping[$idx]);
            $tokenGoods[$stageKey] = $tokenGoods[$stageKey] ?? [
                'exceed' => $exceed,
                'goods' => [],
            ];
            $sku = $this->getSkuByPrice($price);
            $goodsLen = count($tokenGoods[$stageKey]['goods']);
            if ($goodsLen >= $tokenGoodsMax) {
                self::response(__LINE__, '代币商品大于最大限制：' . $tokenGoodsMax);
            }
            $tokenGoods[$stageKey]['goods'][$goodsLen] = [
                'id' => $goodsLen + 1,
                'gid' => $gtype * 10000 + $goodsLen,
                'price' => $price,
                'sku' => $sku,
                'gtype' => $gtype,
                'discount' => $discount,
                'tokenNum' => $tokenNum,
            ];
        }
        $actConfig['tokenGoods'] = $tokenGoods;
    }

    protected function getStageKey(array $idxMapping): string
    {
        $stageKey = '';
        foreach ($idxMapping as $k) {
            if (strlen($stageKey) == 0) $stageKey .= $k;
            else $stageKey .= '_' . $k;
        }
        return $stageKey;
    }


    protected function parseBasicConfig2($type, $basicConfArray): array
    {
        return ActivityModel::parseBasicConfig2($type, $basicConfArray);
    }
    public static function parseExtraBasicConfig($fieldMapping, $sheetData): array
    {
        $baseConfig = [];
        foreach ($sheetData as $line) {
            $configField = $fieldMapping[$line[0]];
            if (!empty($configField)) {
                $baseConfig[$configField] = $line[1];
            }
        }
        return $baseConfig;
    }

    public function getActBasicConfig(): array
    {
        return [];
    }

    // 解析三层映射关系 等级 => 体力 => 数数分组 3层嵌套
    public function parseLvSpinsSsGroupStages(array $stagesSheet): array
    {
        $stages = [];
        for ($i = 1; $i < count($stagesSheet); $i++) {
            $row = array_filter($stagesSheet[$i]);
            if (empty($row)) continue;

            list($idx, $lvMin, $lvMax, $spinsMin, $spinsMax, $ssGroup) = $row;
            $lvKey = "{$lvMin}-$lvMax";
            $spinsKey = "{$spinsMin}-{$spinsMax}";

            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);
            $spinsIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SPINS, $spinsKey, $lvIdx);
            $ssIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SHUSHU, $ssGroup, "{$spinsIdx}_{$lvIdx}");

            if (empty($stages[$lvIdx])) {
                $stages[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                ];
            }

            if (empty($stages[$lvIdx]['stages'][$spinsIdx])) {
                $stages[$lvIdx]['stages'][$spinsIdx] = [
                    'stages' => [],
                    'spinsStart' => $spinsMin,
                    'spinsEnd' => $spinsMax,
                ];
            }

            $shushus = $this->parseShushuGroups($ssGroup);
            if (empty($stages[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx])) {
                $stages[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx] = [
                    'id' => $idx,
                    'stages' => [],
                    'shushu' => $shushus,
                ];
            }
        }

        return $stages;
    }

    // 解析三层映射关系 等级 => Y值 => 数数分组 3层嵌套
    public function parseLvYSsGroupStages(array $stagesSheet): array
    {
        $stages = [];
        for ($i = 1; $i < count($stagesSheet); $i++) {
            $row = array_filter($stagesSheet[$i]);
            if (empty($row)) continue;

            list($idx, $lvMin, $lvMax, $yMin, $yMax, $ssGroup) = $row;
            $lvKey = "{$lvMin}-$lvMax";
            $yKey = "{$yMin}-{$yMax}";

            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);
            $yIdx = $this->getGroupMappingIdx(CONDITION_TYPE_COIN_Y, $yKey, $lvIdx);
            $ssIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SHUSHU, $ssGroup, "{$yIdx}_{$lvIdx}");

            if (empty($stages[$lvIdx])) {
                $stages[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                ];
            }

            if (empty($stages[$lvIdx]['stages'][$yIdx])) {
                $stages[$lvIdx]['stages'][$yIdx] = [
                    'stages' => [],
                    'yStart' => $yMin,
                    'yEnd' => $yMax,
                ];
            }

            $shushus = $this->parseShushuGroups($ssGroup);
            if (empty($stages[$lvIdx]['stages'][$yIdx]['stages'][$ssIdx])) {
                $stages[$lvIdx]['stages'][$yIdx]['stages'][$ssIdx] = [
                    'id' => $idx,
                    'stages' => [],
                    'shushu' => $shushus,
                ];
            }
        }

        return $stages;
    }
    public function parseLvCoinYShushuStagesMapping(array $stagesMappingArray): array
    {
        $rewardsConfig = $idxMapping = [];

        foreach ($stagesMappingArray as $k => $item) {
            if (empty($k)) continue;
            list($idx, $lvMin, $lvMax, $coinsyMin, $coinsyMax, $ssGroup) = $item;
            $lvKey = "{$lvMin}-$lvMax";
            $coinsyKey = "{$coinsyMin}-{$coinsyMax}";

            $lvIdx = $this->getGroupMappingIdx(CONDITION_TYPE_LV, $lvKey);
            $coinsyIdx = $this->getGroupMappingIdx(CONDITION_TYPE_COIN_Y, $coinsyKey, $lvIdx);
            $ssIdx = $this->getGroupMappingIdx(CONDITION_TYPE_SHUSHU, $ssGroup, "{$coinsyIdx}_{$lvIdx}");

            if (empty($rewardsConfig[$lvIdx]))
                $rewardsConfig[$lvIdx] = [
                    'stages' => [],
                    'lvStart' => $lvMin,
                    'lvEnd' => $lvMax,
                    'start' => $lvMin,
                    'end' => $lvMax,
                ];
            if (empty($rewardsConfig[$lvIdx]['stages'][$coinsyIdx]))
                $rewardsConfig[$lvIdx]['stages'][$coinsyIdx] = [
                    'stages' => [],
                    'coinsyStart' => $coinsyMin,
                    'coinsyEnd' => $coinsyMax,
                    'start' => $coinsyMin,
                    'end' => $coinsyMax,
                ];

            $shushus = $this->parseShushuGroups($ssGroup);
            if (empty($rewardsConfig[$lvIdx]['stages'][$coinsyIdx]['stages'][$ssIdx]))
                $rewardsConfig[$lvIdx]['stages'][$coinsyIdx]['stages'][$ssIdx] = [
                    'stages' => [],
                    'shushu' => $shushus,
                ];


            $idxMapping[$idx] = [$lvIdx, $coinsyIdx, $ssIdx];
        }


        return [$rewardsConfig, $idxMapping];
    }

    // 通过活动类型获取活动商品gtype
    public function getGtypeByActType(string $actType):int{
        if (empty(self::$gtypeMap[$actType])){
            $tb = otable::gTypeGoods();
            $ret = oo::commonOprDb('slavedb')->getOne("SELECT * FROM {$tb} Where act_type='".$actType."'");
            if(empty($ret['g_type'])){
                $this->response(-1 * __LINE__, "活动无相关付费项：{$actType}");
            }
            self::$gtypeMap[$actType] = intval($ret['g_type']);
        }
        return self::$gtypeMap[$actType];
    }


    public function checkConflictActs($actType, $startTime, $endTime){
        return;
        $tb = otable::activityConf();
        $acts = oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb} Where type='{$actType}' and `start_time`<{$endTime} and `end_time` > {$startTime}");
        if(!empty($acts)){
            $actType = self::$actTypeMapping[$actType] ?? $actType;
            $startTimeFormat =  date('Y-m-d H:i:s', $startTime);
            $endTimeFormat =  date('Y-m-d H:i:s', $endTime);
            $this->response(-1 * __LINE__, "时间段:{$startTimeFormat}~~{$endTimeFormat} 存在活动-{$actType}");
        }
    }
}