<?php

class ChooseOneActModel extends ActBaseModel implements ActInterface
{

    function serializeShowConf(array &$actConfig)
    {
        foreach ($actConfig['stages'] as $idx1 => &$items1) {
            foreach ($items1['stages'] as $idx2 => &$items2) {
                if (isset($items2['stages'][0]['id'])) {
                    $items2['stages'] = [$items2['stages']];
                }
            }
        }
    }

    function formatActData(array &$actConfig)
    {
//        $this->response(__LINE__, '奖励不能为空', $actConfig);
        $tmp = $actConfig['reward_conf'];
        $rewardInfo = [];
        foreach ($tmp as $k => $reward) {
            if(count($reward) != 2)
                $this->response(__LINE__, '配置异常', $reward);
            foreach ($reward as $gid => $val) {
                if(empty($reward[$gid]['gprice']) || empty($reward[$gid]['gsku']))
                    $this->response(__LINE__, '未配置价格');
                $prize = isset($actConfig['reward'][$k], $actConfig['reward'][$k][$gid]) ? urldecode($actConfig['reward'][$k][$gid]['prize']) : '[]';
                $reward[$gid]['gid'] = $gid;
                $reward[$gid]['prize'] = (array)json_decode($prize, true);
                if(empty($reward[$gid]['prize']))
                    $this->response(__LINE__, '奖励不能为空');
                foreach ($reward[$gid]['prize'] as $kk => $v) {
                    if (empty($v['skin'])) {
                        unset($v['skin']);
                    }
                    $reward[$gid]['prize'][$kk] = $v;
                }
            }
            $group = isset($actConfig['scoreStage'][$k], $actConfig['scoreStage'][$k]['gid']) ? $actConfig['scoreStage'][$k]['gid'] : [];
            $rewardInfo[] = ['data' => $reward, 'gid' => $group];
        }
        unset($actConfig['reward_conf'], $actConfig['scoreStage'], $actConfig['reward']);

        $extra_reward = [
            'groupRid' => 5
        ];
        $actConfig['extra_reward'] = json_encode($extra_reward);
        $actConfig['reward_info'] = json_encode($rewardInfo, JSON_NUMERIC_CHECK);
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $rewardInfo = json_decode($actConfig['reward_info'], true) ?? [];
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        foreach ($rewardInfo as $idx3 => $item3) {
            $condition[CONDITION_TYPE_SHUSHU] = [
                'shushu' => $item3['gid'],
                'start' => 0,
                'end' => 0,
                'type' => CONDITION_TYPE_SHUSHU,
            ];

            $stageKey = "{$idx3}";
            $stageConditions = array_values($condition);
            unset($item3['start']);
            unset($item3['end']);
            oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, 32));
            oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3['data'], 32));

        }

        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $scoreStage = [];
        $sheetIdx = -1;
        $basicArray = $sheetArray[++$sheetIdx] ?? [];
        $stagesMappingSheet = $sheetArray[++$sheetIdx] ?? [];
        $rewardSheet = $sheetArray[++$sheetIdx] ?? [];
        list($rewardsConfig, $idxMapping) = $this->parseShushuStagesMapping($stagesMappingSheet);

        foreach ($rewardsConfig['stages'] as $ssIdx => $stage){
            $scoreStage[$ssIdx-1] = [
                'gid' => $stage['shushu']
            ];
        }
        $rewardsConfig = [];
        $reward = [];
        $gidBeginId = 1809;
        foreach ($rewardSheet as $k => $item){
            if (empty($k) || empty($item)) continue;
            $line = $k + 1;
            list($idx, $stage, $price, $discount) = $item;
            if (empty($idxMapping[$idx])) $this->response(-1, "第{$line}行,唯一id:{$idx} 无对应关系", $item);
            list($ssIdx) = $idxMapping[$idx];
            $ssIdx--;
            if(!in_array($stage, [1, 2]))$this->response(-1, "第{$line}行,层级:{$stage} 异常", $item);
            $sku = $this->getSkuByPrice($price);
            $gid = $gidBeginId + $stage;
            $rewardsConfig[$ssIdx][$gid] = [
                'gprice' => $price,
                'gsku' => $sku,
                'gdiscount' => $discount,
            ];
            $prize = $this->parseLineRewards(array_slice($item, 4), $line);
            $reward[$ssIdx][$gid] = [
                'prize' => urlencode(json_encode($prize)),
            ];
        }
        $basicConfig['reward_conf'] = $rewardsConfig;
        $basicConfig['reward'] = $reward;
        $basicConfig['scoreStage'] = $scoreStage;
    }
}