<?php

class ClubTournamentActModel extends ActBaseModel implements ActInterface
{

    function serializeShowConf(array &$actConfig)
    {

    }

    function formatActData(array &$actConfig)
    {
        $configData = $actConfig['clubTournamentConfig'];
        $configData['preTimes'] = intval($configData['preTimes'] * 3600);
        unset($actConfig['clubTournamentConfig']);
        $actConfig['reward_conf'] = [
            "attack_success"=>intval($actConfig['attack_success']),//普通打
            "attack_break"=>intval($actConfig['attack_break']),//打破
            "steal_success"=>intval($actConfig['steal_success']),//偷
            "steal_break"=>intval($actConfig['steal_break']),//完美偷
            "one_hit"=>intval($actConfig['one_hit']),//一连
            "two_hit"=>intval($actConfig['two_hit']),//二连
            "three_hit"=>intval($actConfig['three_hit']),//三连
            "confType"=>1,//三连
        ];
        $preEnd = null;
        foreach ($configData['list'] as $idx1 => $items){
            $start = intval($items['start']);
            $end = intval($items['end']);
            $clubNum = intval($items['clubNum']);
            if($end < $start)$this->response(-1 * __LINE__, "星星区间配置异常:{$end}<{$start}");
            if(empty($clubNum))$this->response(-1 * __LINE__, "房间最大俱乐部数不能为:".$items['clubNum']);
            if(!is_null($preEnd)){
                if($start != $preEnd+1)
                    $this->response(-1 * __LINE__, "星星区间不连续:{$preEnd}->{$start}");
            }
            $preEnd = $end;

            foreach ($items['userRanks'] as $rankKey => $rankItem){
                $tmpPrize = @json_decode(urldecode($rankItem['prizes']), true) ?? [];
                if(empty($tmpPrize))$this->response(-1 * __LINE__, "排行:".$rankItem['rank'].'奖励为空');
                $configData['list'][$idx1]['userRanks'][$rankKey]['prizes'] = $tmpPrize;
            }

            foreach ($items['clubRanks'] as $rankKey => $rankItem){
                if(empty($rankItem['level']))$this->response(-1 * __LINE__, "排行:{$rankItem['rank']},分档配置为空");

                $stageEnd = null;
                foreach ($rankItem['level'] as $stageIdx => $lvItem){
                    $min = intval($lvItem['min']);
                    $max = intval($lvItem['max']);
                    if((!is_null($stageEnd) &&  $min != $stageEnd + 1) || ($max < $min))
                        $this->response(-1 * __LINE__, "排行:{$rankItem['rank']},分档积分配置异常");
                    $stageEnd = $max;

                    $tmpPrize = @json_decode(urldecode($lvItem['prizes']), true) ?? [];
                    $stageKey = $stageIdx + 1;
                    if(empty($tmpPrize))$this->response(-1 * __LINE__, "排行:{$rankItem['rank']},第{$stageKey}档,奖励配置为空");
                    $configData['list'][$idx1]['clubRanks'][$rankKey]['level'][$stageIdx]['prizes'] = $tmpPrize;
                }


            }
        }
        $actConfig['extraData'] = json_encode($configData,32);
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $rewardInfo = json_decode($actConfig['reward_info'], true) ?? [];
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        foreach ($rewardInfo as $idx3 => $item3) {
            $condition[CONDITION_TYPE_STAR] = [
                'shushu' => [],
                'start' => $item3['start'],
                'end' => $item3['end'],
                'type' => CONDITION_TYPE_STAR,
            ];

            $stageKey = "{$idx3}";
            $stageConditions = array_values($condition);
            unset($item3['start']);
            unset($item3['end']);
            oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, 32));
            oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3['data'], 32));

        }

        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
    }

    function importActData(array &$basicConfig, $sheetArray)
    {

        $basicConfArray = $sheetArray[0] ?? [];
        $basicConfArray2 = $sheetArray[1] ?? [];
        $stagesMappingArray = $sheetArray[2] ?? [];
        $clubRanksArray = $sheetArray[3] ?? [];
        $userRanksArray = $sheetArray[4] ?? [];


        # 收集物品解析
        $clubTournamentConfig = [
            'preTimes' => 0,
            'clubMinNum' => 0,
            'userMinNum' => 0,
            'list' => [],
        ];
        $filterPrefixArr = [
            '打',
            '打到盾',
            '偷',
            '完美偷',
            '提前预告时长(小时)',
        ];
        foreach ($basicConfArray2 as $lineKey => $line){
            $lineNum = $lineKey+1;
            if(in_array($line[0], $filterPrefixArr)){
                switch ($line[0]){
                    case '打':$basicConfig['attack_success'] = intval($line[1]);break;
                    case '打到盾':$basicConfig['attack_break'] = intval($line[1]);break;
                    case '偷':$basicConfig['steal_success'] = intval($line[1]);break;
                    case '完美偷':$basicConfig['steal_break'] = intval($line[1]);break;
                    case '提前预告时长(小时)':$clubTournamentConfig['preTimes'] = intval($line[1]);break;
                }
            }
        }

        $starsStageCnt = 0;
        # 解析映射关系
        foreach ($stagesMappingArray as $k => $item){
            if(empty($k))continue;
            list($idx, $starsMin, $starsMax, $maxClubNum, $clubMinNum, $userMinNum) = $item;
            $starsKey = "{$starsMin}-$starsMax";
            if(empty($starsMapping[$starsKey])){
                $starsMapping[$starsKey] = $starsStageCnt++;
                $clubTournamentConfig['list'][$starsMapping[$starsKey]] = [
                    'start' => $starsMin,
                    'end' => $starsMax,
                    'clubNum' => $maxClubNum,
                    'clubMinNum' => $clubMinNum,
                    'userMinNum' => $userMinNum,
                    'clubRanks' => [],
                    'userRanks' => [],
                ];

            }
            $idxMapping[$idx] = $starsMapping[$starsKey];
        }

        $rankTitleMap = [
            'clubRanksArray' => 'clubRanks',
            'userRanksArray' => 'userRanks',
        ];
        $rankScoreStageMap = []; // 积分奖励分档索引map
        $rankIdxMap = [];       // 分区间排行名次 map
        foreach ($rankTitleMap as $rankTitle => $rank){
            foreach (${$rankTitle} as $k => $item){
                $filterLine = array_filter($item);
                if (empty($filterLine))continue;
                $line = $k + 1;
                if($k == 0)continue;
                $scoreMin = $scoreMax = 0;
                if($rank == 'userRanks'){
                    list($idx,$rankNum) = $item;
                    $lineRewardsArr = array_slice($item, 2);
                }else{
                    list($idx,$rankNum, $scoreMin, $scoreMax) = $item;
                    $rankScoreStageMap[$rankNum] = $rankScoreStageMap[$rankNum] ?? count($rankScoreStageMap);
                    $lineRewardsArr = array_slice($item, 4);
                }

                if(!isset($idxMapping[$idx]))$this->response(-1, "第{$line}行,唯一id:{$idx} 无对应关系",$idxMapping);    #奖励不能为空
                $starsStage = $idxMapping[$idx];

                $rankIdxMap[$starsStage] = $rankIdxMap[$starsStage] ?? 0;
                $rewardsTemp = $this->parseLineRewards($lineRewardsArr, $line);

                if(empty($rewardsTemp))$this->response(-1, "第{$line}行,奖励不能为空");    #奖励不能为空

                if($rank == 'userRanks'){

                    if(count($clubTournamentConfig['list'][$starsStage][$rank]) != $rankNum-1)$this->response(-1, "第{$line}行,排名配置异常",[$item, $idxMapping]);    #奖励不能为空
                    $clubTournamentConfig['list'][$starsStage][$rank][] = [
                        'rank' => $rankNum,
                        'prizes' => urlencode(json_encode($rewardsTemp))
                    ];
                }else{
                    if($rankIdxMap[$starsStage] != $rankNum-1 && $rankIdxMap[$starsStage] != $rankNum)
                        $this->response(-1, "第{$line}行,排名配置不连续{$rankIdxMap[$starsStage]}->{$rankNum}",[$item, $idxMapping, $clubTournamentConfig['list'][$starsStage][$rank]]);    #奖励不能为空
                    $rankIdxMap[$starsStage] = $rankNum;
                    $clubTournamentConfig['list'][$starsStage][$rank][$rankScoreStageMap[$rankNum]] = $clubTournamentConfig['list'][$starsStage][$rank][$rankScoreStageMap[$rankNum]] ?? [
                        'rank' => $rankNum,
                        'level' => [],
                    ];
                    $clubTournamentConfig['list'][$starsStage][$rank][$rankScoreStageMap[$rankNum]]['level'][] = [
                        'min' => $scoreMin,
                        'max' => $scoreMax,
                        'prizes' => urlencode(json_encode($rewardsTemp)),
                    ];
                }
            }
        }

        $basicConfig['clubTournamentConfig'] = $clubTournamentConfig;
    }
}