<?php

class FreeSpinActModel extends ActBaseModel implements ActInterface
{
    static  $taskMapping = [
        1 =>"下注次数",
        2 =>"获得金币",
        3 =>"freespin中获得奖金"
    ];

    public $extraConfigFieldMapping = [
        '开放等级' => 'treasureOpenLv',
        '体力存量系数（整数）' => 'spinsRatio',
        '体力存量系数' => 'spinsRatio',
    ];
    static  $permissionMapping = [
        '通行证专属头像框' => 2 ,
        '赠送N个通行证等级' => 3 ,
    ];
    function serializeShowConf(array &$actConfig)
    {

    }

    function formatActData(array &$actConfig)
    {

        $maxStageCnt = 0;
        if (empty($actConfig['treasure'])) $this->response(1, '保存失败，奖励配置异常');
        foreach ($actConfig['treasure'] as $idx => $item) {
            if (empty($item['stages'])) $this->response(1, "第{$idx}层等级区间未配置Y值层");
            foreach ($item['stages'] as $idx1 => $item1) {

                if (empty($item1['stages'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层Y值区间未配置数数层");
                foreach ($item1['stages'] as $idx2 => $item2) {

                    if (empty($item2['stages'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层Y值区间，第{$idx2}层数数区间未配置关卡");
                    $maxStageCnt = max(count($item2['stages']), $maxStageCnt);
                    foreach ($item2['stages'] as $idx3 => $item3) {
                        foreach ($item3 as $idx4 => $rewardItem) {
                            $tmpPrize = array_values(json_decode(urldecode($rewardItem['prize']), true));
                            $tmpBet = array_values(json_decode(urldecode($rewardItem['bet']), true));
                            if (empty($tmpPrize) || empty($tmpBet)) $this->response(1, "第{$idx}层等级区间，第{$idx1}层Y值区间，第{$idx2}层数数区间，，第{$idx3}层房间，第{$idx4}层任务未配置奖励或倍率");
                            sort($tmpBet);
                            $actConfig['treasure'][$idx]['stages'][$idx1]['stages'][$idx2]['stages'][$idx3][$idx4]['prize'] = $tmpPrize;
                            $actConfig['treasure'][$idx]['stages'][$idx1]['stages'][$idx2]['stages'][$idx3][$idx4]['bet'] = $tmpBet;
                        }
                    }
                }
            }
        }
        if (count($actConfig['prdConf']) < $maxStageCnt) $this->response(1, "prd概率配置任务数:" . count($actConfig['prdConf']) . ",小于最大任务数:{$maxStageCnt}");
        $actConfig['reward_info'] = "{}";
        $actConfig['extra_reward'] = json_encode([
            'fixCo' => $actConfig['common_conf'] ?? [],
            'waterLevelCoefficient' => [],
            'prdConf' => $actConfig['prdConf'],
        ], JSON_NUMERIC_CHECK);

        $actConfig['extraData'] = json_encode([
            'openLv' => $actConfig['treasureOpenLv'],
            'spinsRatio' => intval($actConfig['spinsRatio']),
//                        'difficultyDegree'=> $data['difficultyDegree'],
//                        'taskDegree'=> $data['taskDegree'],
            'yStages' => $actConfig['treasure']
        ], JSON_NUMERIC_CHECK);
        $actConfig['reward_info'] = json_encode($actConfig['treasureWeightGroup'], 32);
        unset($actConfig['treasureWeightGroup'], $actConfig['spinsRatio'], $actConfig['treasureWaterLevelCoefficient'], $actConfig['prdConf'], $actConfig['spins'], $actConfig['spinStage'], $actConfig['treasureShushu'], $actConfig['difficultyDegree'], $actConfig['taskDegree']);
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $stageExtraConfKeys = okeys::activityStageExtraConfigKeys($actConfig['aid']);
        $extraReward = json_decode($actConfig['extraData'], true) ?? [];
        $rewardInfo = json_decode($actConfig['reward_info'], true) ?? [];
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        foreach ($extraReward['yStages'] as $idx1 => $item1) {
            $condition = [
                CONDITION_TYPE_LV => [
                    'shushu' => [],
                    'start' => $item1['start'],
                    'end' => $item1['end'],
                    'type' => CONDITION_TYPE_LV,
                ],
            ];
            foreach ($item1['stages'] as $idx2 => $item2) {
                $condition[CONDITION_TYPE_COIN_Y] = [
                    'shushu' => [],
                    'start' => $item2['start'],
                    'end' => $item2['end'],
                    'type' => CONDITION_TYPE_COIN_Y,
                ];


                foreach ($item2['stages'] as $idx3 => $item3) {
                    $condition[CONDITION_TYPE_SHUSHU] = [
                        'shushu' => $item3['shushu'],
                        'start' => 0,
                        'end' => 0,
                        'type' => CONDITION_TYPE_SHUSHU,
                    ];

                    $stageKey = "{$idx1}_{$idx2}_{$idx3}";
                    $stageConditions = array_values($condition);
                    unset($item3['start']);
                    unset($item3['end']);
                    oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, 32));
                    oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3['stages'], 32));
                    oo::commonOprRedis('games')->hset($stageExtraConfKeys, $stageKey, json_encode(['treasureWeightConfig' => $rewardInfo[$stageKey] ?? []], 32));

                }
            }
        }
        $SpinsRatioKey = okeys::treasureSpinsRatio($actConfig['aid']);
        oo::commonOprRedis('games')->set($SpinsRatioKey, $extraReward['spinsRatio']);
        oo::commonOprRedis('games')->expireAt($SpinsRatioKey, oo::redisRandomExpire($expireTime));

        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageExtraConfKeys, oo::redisRandomExpire($expireTime));
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $sheetIdx = 0;
        $extraConfigSheet = $sheetArray[++$sheetIdx];
        $prdConfigSheet = $sheetArray[++$sheetIdx];
        $stageMappingSheet = $sheetArray[++$sheetIdx];
        $stageRewardsSheet = $sheetArray[++$sheetIdx];
        $roomGWSheet = $sheetArray[++$sheetIdx];

        $extraConfig = self::parseExtraBasicConfig($this->extraConfigFieldMapping, $extraConfigSheet);
        $basicConfig['treasureOpenLv'] = $extraConfig['treasureOpenLv'];
        $basicConfig['spinsRatio'] = $extraConfig['spinsRatio'];

        $this->parsePrdConfig($basicConfig, $prdConfigSheet);
        list($rewardsConfig, $idxMapping) = $this->parseLvCoinYShushuStagesMapping($stageMappingSheet);

        $this->parseRewardsConfig($rewardsConfig, $idxMapping, $stageRewardsSheet);
        $this->parsetreasureUpgradeConfig($basicConfig, $idxMapping, $roomGWSheet);

        $basicConfig['treasure'] = $rewardsConfig;


    }

    private function parsePrdConfig(&$basicConfig, $prdConfigSheet){
        $lineCnt = count($prdConfigSheet);
        $basicConfig['prdConf'] = [];
        for ($i = 1;$i< $lineCnt; $i++){
            $item = $prdConfigSheet[$i];
            list($idx, $ce1, $ce2) = $item;
            $basicConfig['prdConf'][$idx] = [
                $ce1, $ce2
            ];
        }
    }
    private function parseRewardsConfig(&$rewardConf, $idxMapping, $sheet){
        $length = count($sheet);
        $taskFlip = array_flip(self::$taskMapping);
        for ($i=1;$i < $length; $i++){
            $item = $sheet[$i];
            list($idx,$roomId, $stage, $task, $target, $frequency, $freeLimit,$coinBet,  $betStr) = $item;
            if(empty($idxMapping[$idx]))$this->response(-1 * __LINE__, "第{$i}行，映射关系不存在:{$idx}", [$idxMapping, $item]);
            if(empty($taskFlip[$task]))$this->response(-1 * __LINE__, "第{$i}行，任务类型不存在:{$task}", [$idxMapping, $item]);
            $roomIdx = $roomId-1;
            $prizes = $this->parseLineRewards(array_slice($sheet[$i], 9), $i);
            $bets = $this->parseBets($betStr);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardConf[$lvIdx]['stages'][$spinsIdx]['rewardConfig'] = $rewardConf[$lvIdx]['stages'][$spinsIdx]['rewardConfig'] ?? [];
            $curLength = count($rewardConf[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['stages'][$roomIdx]);
            $rewardConf[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['stages'][$roomIdx][$curLength] = [
                "id" => $curLength + 1,
                "taskType" => $taskFlip[$task],
                "target" => $target,
                "frequency" => $frequency,
                "freeLimit" => $freeLimit,
                "coinBet"=>$coinBet,
//                "base" => $treasureBase,
                "prize" => urlencode(json_encode($prizes)),
                "bet" => urlencode(json_encode($bets)),
            ];
        }
    }

    private function parsetreasureUpgradeConfig(&$basicConfig, $idxMapping, $sheet){
        $length = count($sheet);

        for ($i=1;$i < $length; $i++){
            $item = $sheet[$i];
            list($idx, $roomId, $gname) = $item;
            if(empty($idxMapping[$idx]))$this->response(-1 * __LINE__, "第{$i}行，映射关系不存在:{$idx}", [$idxMapping, $item]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $treasureWeightGroup["{$lvIdx}_{$spinsIdx}_{$ssIdx}"][] = [
                'roomId' => $roomId-1,
                'slotWeightGroup' => $this->parseFreeSpinWeightGroups($gname,$i)
            ];
//            $rewardConf[$lvIdx]['stages'][$spinsIdx]['rewardConfig'] = $rewardConf[$lvIdx]['stages'][$spinsIdx]['rewardConfig'] ?? [];
        }
        $basicConfig['treasureWeightGroup'] = $treasureWeightGroup;
    }

    private function parseBets($betStr){
        $betStr = strtr($betStr, ['，' => ',', ' ' => '']);
        $bets = explode(',',$betStr);
        return array_filter($bets);
    }

    function getActBasicConfig(): array
    {
        $this->response(0, '', self::$taskMapping);
        return [];
    }
    # 通过虎机概率分组名，解析 金币老虎机概率分组id
    public function parseFreeSpinWeightGroups(string $slotWeightGroupName,$line = 0):int{
        if(empty($slotWeightGroupName))$this->response(-1, $line.'行，权重分组为空');

        $groupsTbl = otable::freespinGroup();
        $groups = oo::commonOprDb('slavedb')->getOne("select * from {$groupsTbl} where `name`='{$slotWeightGroupName}'");
        if(empty($groups['id']))$this->response(-1, "第{$line}行,权重分组不存在:'{$slotWeightGroupName}'");
        return intval($groups['id']);
    }
}