<?php

class LuckyFoxActModel extends ActBaseModel implements ActInterface
{

    public $colorTypes = [
        0 => '空',
        1 => '颜色1',
        2 => '颜色2',
    ];
    function formatActData(array &$actConfig)
    {
        $luckyFoxConfig = $actConfig['luckyFoxConfig'];
        unset($actConfig['luckyFoxConfig']);
        foreach ($luckyFoxConfig as &$oneLvStage) {
            foreach ($oneLvStage['stages'] as &$oneSpinsStage) {
                foreach ($oneSpinsStage['stages'] as &$oneSsStage) {
                    $formatConf = [];
                    if(empty($oneSsStage['list'] ))self::response(__LINE__, '配置异常');
                    foreach ($oneSsStage['list'] as $oneConf) {
                        if (empty($oneConf['grid']) || empty($oneConf['layer']) || empty($oneConf['weight']) || empty($oneConf['prize'])) {
                            self::response(__LINE__, '配置异常', $oneConf);
                        }
                        $formatConf[$oneConf['grid'] - 1][$oneConf['layer'] - 1] = $oneConf;
                    }
                    $oneSsStage['list'] = $formatConf;


                    foreach ($this->colorTypes as $colorType =>$colorText){
                        if(!empty($colorType) && empty($oneSsStage['progress'][$colorType]))self::response(__LINE__, '配置异常', $oneSsStage['progress']);

                        foreach ($oneSsStage['progress'][$colorType] as $colorProgress) {

                            if ( empty($colorProgress['target']) || empty($colorProgress['prize'])) {
                                self::response(__LINE__, '配置异常', $colorProgress);
                            }
                        }

                    }
                }
            }
        }

        $this->saveTokenGoods($actConfig, 'extraData');
        $actConfig['reward_info'] = json_encode($luckyFoxConfig, JSON_NUMERIC_CHECK);
    }

    function writeActCache(array $actConfig)
    {

        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $stageExtraConfKeys = okeys::activityStageExtraConfigKeys($actConfig['aid']);
        $rewardInfo = json_decode($actConfig['reward_info'], true);
        $extraData = json_decode($actConfig['extraData'], true);
        foreach ($rewardInfo as $idx1 => $item1) {
            foreach ($item1['stages'] as $idx2 => $item2) {
                foreach ($item2['stages'] as $idx3 => $item3) {
                    $stageKey = "{$idx1}_{$idx2}_{$idx3}";

                    $stageConditions = $this->getStageConditionLvSpinsShushu($item1, $item2, $item3);
                    $stageReward = [
                        'reward' => $item3['list'],
                        'progress' => $item3['progress'] ?? []
                    ];

                    oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode(array_values($stageConditions), JSON_NUMERIC_CHECK));
                    oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($stageReward, JSON_NUMERIC_CHECK));
                    oo::commonOprRedis('games')->hset($stageExtraConfKeys, $stageKey, json_encode(['tokenGoods' =>$extraData[$stageKey]], JSON_NUMERIC_CHECK));
                }
            }
        }
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageExtraConfKeys, oo::redisRandomExpire($expireTime));
    }

    function serializeShowConf(array &$actConfig)
    {
        $rewardInfo = $actConfig['reward_info'];
        $luckyFoxConf = json_decode($rewardInfo, true);
        foreach ($luckyFoxConf as &$oneLvStage) {
            foreach ($oneLvStage['stages'] as &$oneSpinsStage) {
                foreach ($oneSpinsStage['stages'] as &$oneSsStage) {
                    $formatConf = [];
                    $count = 0;
                    foreach ($oneSsStage['list'] as $oneGrid) {
                        foreach ($oneGrid as $oneLayer) {
                            $formatConf[++$count] = $oneLayer;
                        }
                    }
                    $oneSsStage['list'] = $formatConf;
                }
            }
        }
        $actConfig['reward_info'] = json_encode($luckyFoxConf, JSON_NUMERIC_CHECK);
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $sheetIdx = 0;
        $stagesMappingArray = $sheetArray[++$sheetIdx] ?? [];
        $stagesRewardsArray = $sheetArray[++$sheetIdx] ?? [];
        $progressSheets = []; // 进度配置sheet
        foreach ($this->colorTypes as $colorType =>$colorText){
            if(empty($colorType))continue;
            $progressSheets[$colorType] = $sheetArray[++$sheetIdx] ?? [];
        }
        $noTokenConfigArray = $sheetArray[++$sheetIdx] ?? [];
        list($rewardsConfig, $idxMapping) = $this->parseLvSpinsShushuStagesMapping($stagesMappingArray);

        $colorFlips = array_flip($this->colorTypes);
        foreach ($stagesRewardsArray as $k => $item){
            if (empty($k)) continue;
            if (empty(array_filter($item))) continue;
            $line = $k + 1;
            @list($idx, $grid, $layer, $weight, $colorText) = $item;
            if (empty($idxMapping[$idx])) self::response(-1, "第{$line}行,唯一id:{$idx} 无对应关系");    #奖励不能为空

            if(empty($colorText))$colorText = '空';
            if (!in_array($colorText, $this->colorTypes)) self::response(-1, "第{$line}行,颜色配置异常:{$colorText} ");    #奖励不能为空
            list($lvStage, $spinsStage, $ssStage) = $idxMapping[$idx];

            $rewardStage = count($rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['list']) + 1;
            $rewardsTemp = $this->parseLineRewards( array_slice($item, 5), $line);
            $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['list'][$rewardStage] = [
                'grid' => $grid,
                'layer' => $layer,
                'weight' => $weight,
                'prize' => $rewardsTemp,
                'color' => $colorFlips[$colorText] ?? 0,
            ];
        }


        foreach ($progressSheets as $colorType => $stagesProgresRewardArray){
            foreach ($stagesProgresRewardArray as $k => $item){
                if (empty($k)) continue;
                if (empty(array_filter($item))) continue;
                $line = $k + 1;
                list($idx, $id, $stepNum) = $item;
                if (empty($idxMapping[$idx])) self::response(-1, "第{$line}行,唯一id:{$idx} 无对应关系");    #奖励不能为空
                list($lvStage, $spinsStage, $ssStage) = $idxMapping[$idx];

                $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['progress'][$colorType] = $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['progress'][$colorType] ?? [];
                $rewardStage = count($rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['progress'][$colorType]);
                $rewardsTemp = $this->parseLineRewards( array_slice($item, 3), $line);
                $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['progress'][$colorType][$rewardStage] = [
                    'stage' => $rewardStage + 1,
                    'target' => $stepNum,
                    'prize' => $rewardsTemp,
                ];
            }
        }

        $this->formatTokenGoodsSheet($basicConfig, $noTokenConfigArray, $idxMapping);
        $basicConfig['luckyFoxConfig'] = $rewardsConfig;
    }

    function getActBasicConfig(): array
    {
        return [
            'colors' => $this->colorTypes
        ];
    }
}