<?php

class MysteryMineActModel extends ActBaseModel implements ActInterface
{
    static $prizeTypeCollect1 = 1;
    static $prizeTypeCollect2 = 2;
    static $prizeTypeHighStage = 3;
    static $prizeTypeToken = 4;
    static $prizeTypeGhost = 5;
    static $prizeTypes = [
        1=>'收集物1',
        2=>'收集物2',
        3=>'高级场象征物',
        4=>'本活动代币',
        5=>'幽灵',
    ];
    public $extraConfigFieldMapping = [
        '积分基础值' => 'getScore',
    ];
    function formatActData(array &$actConfig)
    {

        if(empty($actConfig['mysteryMineConf']['baseConf']['getScore']))$this->response(1, '操作失败，积分基础值为空', $actConfig);
        if(empty($actConfig['mysteryMineConf']['stageConf']))$this->response(1, '操作失败，配置为空', $actConfig);

        $noEmtypFieldsMap = [
            'betConf' => '概率',
            'giveToken' => '入场赠送代币',
            'joinStageConf' => '入场门槛积分',
        ];
        $stageFields = [
            'lowStageConf' => '普通场',
            'highStageConf' => '高级场',
        ];
        $progressFields = [
            'collectConfA' => '进度条1',
            'collectConfB' => '进度条2',
        ];
        $progressMax = 6;
        foreach ($actConfig['mysteryMineConf']['stageConf'] as $lvIdx => &$itemLv) {
            if (empty($itemLv['stages']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，配置为空");

            foreach ($itemLv['stages'] as $spinsIdx => &$itemSpins) {
                if (empty($itemSpins['stages']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，配置为空");

                foreach ($itemSpins['stages'] as $ssIdx => &$itemSs) {
                    foreach ($noEmtypFieldsMap as $field => $text){
                        if (empty($itemSs[$field]))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text} 配置为空");
                    }

                    foreach ($stageFields as $field => $text){
                        if (empty($itemSs[$field]['stages']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}配置为空");
                        if($field == 'lowStageConf'){
                            foreach ($progressFields as $progressField => $progressText){
                                if (empty($itemSs[$field][$progressField]))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$progressText}配置为空");

                                foreach ($itemSs[$field][$progressField] as &$progressItem){
                                    if(empty($progressItem['dst']) || $progressItem['dst'] > $progressMax)
                                        $this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$progressText} 第{$progressItem['stageId']}阶段，阶段值异常");

                                    $prize = @json_decode(urldecode($progressItem['prize']), true) ?? [];
                                    if(empty($prize))
                                        $this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$progressText} 第{$progressItem['stageId']}阶段，奖励为空", $progressItem);
                                    $progressItem['prize'] = $prize;
                                }
                            }
                        }
                        $hasGold = false;
                        $itemSs[$field]['stages'] = array_values($itemSs[$field]['stages']);
                        foreach ($itemSs[$field]['stages'] as  &$stageItem){
                            if (empty($stageItem['grids']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}{$stageItem['stageId']},格子配置为空");

                            foreach ($stageItem['grids'] as  &$gridItem){
                                if($field == 'lowStageConf'){
                                    if(!in_array($gridItem['prizeType'], array_keys(self::$prizeTypes)))
                                        $this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}{$stageItem['stageId']},格子{$gridItem['gridId']}奖励类型异常", $gridItem);

                                    if(empty($gridItem['prizeNum']))
                                        $this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}{$stageItem['stageId']},格子{$gridItem['gridId']}奖励数为空", $gridItem);

                                    $hasGold = $hasGold || ($gridItem['prizeType'] == self::$prizeTypeHighStage);
                                }else{
                                    $prize = @json_decode(urldecode($gridItem['prize']), true) ?? [];
                                    $hasGold = $hasGold || boolval($gridItem['isGoldPrize']);
                                    if(empty($gridItem['prize']))
                                        $this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}{$stageItem['stageId']},格子{$gridItem['gridId']}奖励为空", $gridItem);
                                    $gridItem['prize'] = $prize;
                                }
                            }
                            if(!$hasGold){
                                switch ($field){
                                    case 'lowStageConf':
                                        $this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}{$stageItem['stageId']},未配置高级场象征物");
                                        break;
                                    default:$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层，{$text}{$stageItem['stageId']},未配置大奖");break;
                                }
                            }
                        }
                    }
                }
            }
        }
        $actConfig['reward_conf'] = $actConfig['mysteryMineConf'];
        $actConfig['extraData'] = $actConfig['mysteryMineConf']['baseConf'];
        unset($actConfig['mysteryMineConf']);
        $this->saveTokenGoods($actConfig, 'pro');
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $stageExtraConfKeys = okeys::activityStageExtraConfigKeys($actConfig['aid']);
        $rewardConf = json_decode($actConfig['reward_conf'], true);
        $extraReward = json_decode($actConfig['reward_pro'], true);

        foreach ($rewardConf['stageConf'] as $idx1 => $item1) {
            foreach ($item1['stages'] as $idx2 => $item2) {
                foreach ($item2['stages'] as $idx3 => $item3) {
                    $idx = "{$idx1}_{$idx2}_{$idx3}";
                    $condition = $this->getStageConditionLvSpinsShushu($item1, $item2, $item3);
                    oo::commonOprRedis('games')->hset($stageRewardKeys, $idx, json_encode($item3, 32));
                    oo::commonOprRedis('games')->hset($conditionKeys, $idx, json_encode($condition, 32));
                    oo::commonOprRedis('games')->hset($stageExtraConfKeys, $idx, json_encode(['tokenGoods' =>$extraReward[$idx] ?? []], 32));
                }
            }
        }
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageExtraConfKeys, oo::redisRandomExpire($expireTime));
        return true;
    }

    function serializeShowConf(array &$actConfig)
    {
        // TODO: Implement serializeShowConf() method.
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $sheetIdx = -1;
        $basicArray = $sheetArray[++$sheetIdx] ?? [];
        $extraCfgSheet = $sheetArray[++$sheetIdx] ?? [];    // 额外配置
        $stagesMappingSheet = $sheetArray[++$sheetIdx] ?? [];   // 分层关系配置
        $giveTokenSheet = $sheetArray[++$sheetIdx] ?? [];        // 入场代币赠送配置
        $probSheet = $sheetArray[++$sheetIdx] ?? [];      //概率配置
        $joinScoreSheet = $sheetArray[++$sheetIdx] ?? [];      //入场积分配置
        $lowSheet = $sheetArray[++$sheetIdx] ?? [];      //普通配置
        $highSheet = $sheetArray[++$sheetIdx] ?? [];      //高级配置
        $progress1Sheet = $sheetArray[++$sheetIdx] ?? [];      //进度条1配置
        $progress2Sheet = $sheetArray[++$sheetIdx] ?? [];      //进度条2配置
        $noTokenSheet = $sheetArray[++$sheetIdx] ?? [];      //代币不足配置

        list($rewardsConfig, $idxMapping) = $this->parseLvSpinsShushuStagesMapping($stagesMappingSheet);

        $this->parseFreeToken($rewardsConfig, $idxMapping, $giveTokenSheet);

        $this->parseProbSheet($rewardsConfig, $idxMapping, $probSheet);

        $this->parseJoinScoreSheet($rewardsConfig, $idxMapping, $joinScoreSheet);

        $this->parseLowSheet($rewardsConfig, $idxMapping, $lowSheet);

        $this->parseHighSheet($rewardsConfig, $idxMapping, $highSheet);

        $this->parseProgressSheet($rewardsConfig, $idxMapping, $progress1Sheet, 'A');

        $this->parseProgressSheet($rewardsConfig, $idxMapping, $progress2Sheet, 'B');

        $this->formatTokenGoodsSheet($basicConfig, $noTokenSheet, $idxMapping);

        $basicConfig['mysteryMineConf'] = [
            'stageConf' => $rewardsConfig,
            'baseConf' => self::parseExtraBasicConfig($this->extraConfigFieldMapping, $extraCfgSheet)
        ];
    }

    // 入场赠送代币配置
    public function parseFreeToken(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $tokens) = $sheetData[$i];
            $lineNum = $i+1;
            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", [$sheetData[$i], $idxMapping]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['giveToken'] = $tokens;
        }
    }

    // 概率配置
    public function parseProbSheet(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $bet, $spins, $prob) = $sheetData[$i];
            $lineNum = $i+1;
            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $sheetData[$i]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['betConf'] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['betConf'] ?? [];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['betConf'][] = [
                'bet' => $bet,
                'costSpin' => $spins,
                'prob' => $prob,
            ];
        }
    }

    // 入场积分配置
    public function parseJoinScoreSheet(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $score) = $sheetData[$i];
            $lineNum = $i+1;
            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $sheetData[$i]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['joinStageConf'] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['joinStageConf'] ?? [];
            $stageCnt = count($rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['joinStageConf']);
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['joinStageConf'][] = [
                'stageId' => $stageCnt + 1 ,
                'dst' => $score,
            ];
        }
    }

    // 普通场
    public function parseLowSheet(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        $prizeTypeFlip = array_flip(self::$prizeTypes);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $stageId, $prizeType, $prizeNum, $weight, $costToken) = $sheetData[$i];
            $lineNum = $i+1;
            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $sheetData[$i]);
            if(!in_array($prizeType, self::$prizeTypes))$this->response(__LINE__, "第{$lineNum}行,奖励类型:{$prizeType} 不存在", $sheetData[$i]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf'] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf'] ?? [
                'stages' => [],
                'collectConfA' => [],
                'collectConfB' => [],
            ];

            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf']['stages'][$stageId] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf']['stages'][$stageId] ?? [
                'stageId' => $stageId,
                'grids' => [],
            ];

            $prizeType = $prizeTypeFlip[$prizeType];

            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf']['stages'][$stageId]['grids'][] = [
                "gridId" => count($rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf']['stages'][$stageId]['grids']) + 1, //格子id
                "prizeType" => $prizeType, //奖励种类 1:收集物1 2:收集物2 3:高级场象征物 4:本活动代币 5:幽灵
                "prizeNum" => $prizeNum, //奖励数量
                "weight" => $weight, //权重
                "needCost" => $costToken //需要消耗代币数量
            ];
        }
    }

    // 高级场
    public function parseHighSheet(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $stageId, $isBonus, $weight, $costToken) = $sheetData[$i];
            $lineNum = $i+1;
            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $sheetData[$i]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['highStageConf'] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['highStageConf'] ?? [
                'stages' => [],
            ];

            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['highStageConf']['stages'][$stageId] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['highStageConf']['stages'][$stageId] ?? [
                'stageId' => $stageId,
                'grids' => [],
            ];

            $isBonus = $this->parseYesOrNo($isBonus);

            $prizes = $this->parseLineRewards( array_slice($sheetData[$i], 5), $lineNum);

            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['highStageConf']['stages'][$stageId]['grids'][] = [
                "gridId"=> count($rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['highStageConf']['stages'][$stageId]['grids']) + 1, //格子id
                "isGoldPrize"=> $isBonus, // 是否黄金大奖 1=>是 0=>否
                "weight"=> $weight, //权重
                "needCost"=> $costToken ,//需要消耗代币数量
                'prize' => urlencode(json_encode($prizes))
            ];
        }
    }

    // 进度条
    public function parseProgressSheet(&$rewardsConfig, $idxMapping, $sheetData,$progressType){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $dst) = $sheetData[$i];
            $lineNum = $i+1;
            if (!in_array($progressType, ['A', 'B'])) $this->response(__LINE__, "操作异常，请联系开发人员", $sheetData[$i]);
            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $sheetData[$i]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf'] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf'] ?? [
                'stages' => [],
                'collectConfA' => [],
                'collectConfB' => [],
            ];

            $prizes = $this->parseLineRewards( array_slice($sheetData[$i], 2), $lineNum);

            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf']["collectConf{$progressType}"][] = [
                "stageId" => 1 + count($rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['lowStageConf']["collectConf{$progressType}"]),
                "dst" => $dst,
                'prize' => urlencode(json_encode($prizes))
            ];
        }
    }


    public function getActBasicConfig(): array
    {
        return self::$prizeTypes;
    }
}