<?php

class OnePlusMoreActModel extends ActBaseModel implements ActInterface
{
    static $gtype = 131;

    function formatActData(array &$actConfig)
    {

        $config = $actConfig['onePlusMoreConfig'];
        unset($actConfig['onePlusMoreConfig']);
        foreach ($config as $lvIdx => &$item1) {
            if(empty($item1['stages']))$this->response(-1,  "第{$lvIdx}层体力层，未配置数数层");
            foreach ($item1['stages'] as $ssIdx => &$itemSs) {
                if(empty($itemSs['stages']))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，未配置商品数据");
                if(empty($itemSs['progress']))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，未配置阶段奖励");
                foreach ($itemSs['stages'] as $stageIdx =>&$stage){
                    $goodsStageIdx =  $stageIdx+1;
                    if(empty($stage['goods']))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$goodsStageIdx}阶段商品，未配置数据");
                    $idx = 0;
                    $hasPrice = false;
                    $type = intval($stage['type']);
                    if(!in_array($type, [1,2,3]))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$goodsStageIdx}阶段商品，1+n类型异常：{$type}");
                    foreach ($stage['goods'] as  &$item){
                        $hasPrice = $hasPrice || !empty($item['gprice']);
                        $idx++;
                        $item['prizes'] = json_decode(urldecode($item['prizes'])) ?? [];
                        $item['gtype'] = self::$gtype;
                        if(empty($item['prizes']))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$goodsStageIdx}阶段商品，第{$idx}个商品，未配置奖励");
                    }
                    if(!$hasPrice)$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$goodsStageIdx}阶段商品，未配置付费商品");
                    $stage['goods'] = array_values($stage['goods']);
                    $goodsCnt = count($stage['goods']);
                    if($type == 1){
                        if(!in_array($goodsCnt, [2,3]))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$goodsStageIdx}阶段商品，1+{$type}商品数：{$goodsCnt}异常", $itemSs);
                    }else{
                        if($goodsCnt != ($type + 1))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$goodsStageIdx}阶段商品，1+{$type}商品数：{$goodsCnt}异常", $itemSs);
                    }
                }
                $itemSs['stages'] = array_values($itemSs['stages'] );

                foreach ($itemSs['progress'] as $idx =>&$progressItem){
                    $progressItem['prizes'] = json_decode(urldecode($progressItem['prizes'])) ?? [];
                    if(empty($progressItem['target']))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$idx}阶段奖励，阶段值为空");
                    if(empty($progressItem['prizes']))$this->response(-1,  "第{$lvIdx}层体力层，第{$ssIdx}层数数层，第{$idx}阶段奖励，奖励为空");

                }
                $itemSs['progress'] = array_values($itemSs['progress'] );
            }
        }
        $actConfig['reward_info'] = $config;
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $rewardInfo = json_decode($actConfig['reward_info'], true);
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟

        foreach ($rewardInfo as $idx1 => $item1) {
            foreach ($item1['stages'] as $idx2 => $item2) {
                $idx = "{$idx1}_{$idx2}";
                $condition = $this->getStageConditionLvShushu($item1, $item2);
                oo::commonOprRedis('games')->hset($conditionKeys, $idx, json_encode($condition, 32));
                oo::commonOprRedis('games')->hset($stageRewardKeys, $idx, json_encode($item2, 32));
            }
        }
        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        return true;
    }

    function serializeShowConf(array &$actConfig)
    {
        // TODO: Implement serializeShowConf() method.
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $sheetIdx = 0;
        $stagesMappingArray = $sheetArray[++$sheetIdx] ?? [];
        $stagesRewardsSheet = $sheetArray[++$sheetIdx] ?? [];
        $progressRewardSheet = $sheetArray[++$sheetIdx] ?? [];


        list($rewardsConfig, $idxMapping) = $this->parseLvShushuStagesMapping($stagesMappingArray);

        $this->parseStagesRewards($rewardsConfig, $idxMapping, $stagesRewardsSheet);

        $this->parseProgressRewards($rewardsConfig, $idxMapping, $progressRewardSheet);

        $basicConfig['onePlusMoreConfig'] = $rewardsConfig;
    }
    private function parseStagesRewards(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        $goodsCnt = [];
        $gidBegin = 1310000;
        for($i = 1;$i < $sheetCnt;$i++){
            $lineNum = $i+1;
            $item = $sheetData[$i];
            list($idx, $stageIdx, $type, $price, $num) = $item;
            $stageIdx--;
            $type = intval($type);
            if (empty($idxMapping[$idx])) $this->response(-1, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $item);
            list($lvIdx, $ssIdx) = $idxMapping[$idx];
            $goodsKey = "{$lvIdx}_{$ssIdx}";
            $sku = $this->getSkuByPrice($price);
            $rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'] = $rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'] ?? [];
            $rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'][$stageIdx] = $rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'][$stageIdx] ?? [
                'type' => $type,
                'goods' => []
            ];
            if(empty($rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'][$stageIdx]['type']) &&!empty($type))
                $rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'][$stageIdx]['type'] = $type;

            if(empty($goodsCnt[$goodsKey]))
                $goodsCnt[$goodsKey] = 1;
            else
                $goodsCnt[$goodsKey]++;
            $goodsCnt[$goodsKey] = $goodsCnt[$goodsKey] ?? 0;
            $gid = $gidBegin + $goodsCnt["{$lvIdx}_{$ssIdx}"];
            $prizes = $this->parseLineRewards( array_slice($item, 5), $lineNum);
            if (empty($prizes))$this->response(-1, "第{$lineNum}行, 商品奖励为空", $item);
            $rewardsConfig[$lvIdx]['stages'][$ssIdx]['stages'][$stageIdx]['goods'][] = [
                'gprice' => $price,
                'gsku' => $sku,
                'num' => $num,
                'prizes' => urlencode(json_encode($prizes, 32)),
                'gdiscount' => 0,
                'gid' => $gid,
            ];
        }
    }

    private function parseProgressRewards(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            $lineNum = $i+1;
            $item = $sheetData[$i];
            list($idx, $target) = $item;
            if (empty($idxMapping[$idx])) $this->response(-1, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $item);
            list($lvIdx, $ssIdx) = $idxMapping[$idx];

            $prizes = $this->parseLineRewards( array_slice($item, 2), $lineNum);
            if (empty($prizes))$this->response(-1, "第{$lineNum}行, 阶段奖励为空", $item);
            $rewardsConfig[$lvIdx]['stages'][$ssIdx]['progress'] = $rewardsConfig[$lvIdx]['stages'][$ssIdx]['progress'] ?? [];
            $rewardsConfig[$lvIdx]['stages'][$ssIdx]['progress'][] = [
                'id' => count($rewardsConfig[$lvIdx]['stages'][$ssIdx]['progress']) + 1,
                'target' => $target,
                'prizes' => urlencode(json_encode($prizes, 32)),
            ];
        }
    }
}