<?php

class SpinPiggyRewardActModel extends ActBaseModel implements ActInterface
{

    function serializeShowConf(array &$actConfig)
    {
    }

    function formatActData(array &$actConfig)
    {
        if(empty($actConfig['spinPiggyRewardReward']))$this->response(__LINE__, '奖励不能为空', $actConfig['spinPiggyRewardReward']);
        $tmp = $actConfig['spinPiggyRewardReward'];
        unset($actConfig['spinPiggyRewardReward']);

        foreach ($tmp as $lvIdx => &$lvItem) {
            if (empty($lvItem['stages'])) {
                $lvItem['stages'] = [];
                continue;
                $this->response(__LINE__, "第{$lvIdx}个等级区间未配置为空", $tmp);
            }

            foreach ($lvItem['stages'] as &$timeRange) {
                if (empty($timeRange['timeRange'])) $this->response(__LINE__, "第{$lvIdx}个等级区间,第{$timeRange['id']}个时间段, 未配置时间段", $timeRange);
                if (empty($timeRange['prizes'])) $this->response(__LINE__, "第{$lvIdx}个等级区间,第{$timeRange['id']}个时间段, 奖励为空", $timeRange);
                list($start, $end) = explode('~', $timeRange['timeRange']);
                $timeRange['start'] = strtotime(trim($start));
                $timeRange['end'] = strtotime(trim($end));
            }
        }
        $actConfig['reward_info'] = json_encode($tmp, JSON_NUMERIC_CHECK);
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $rewardInfo = json_decode($actConfig['reward_info'], true) ?? [];
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        foreach ($rewardInfo as $idx3 => $item3) {
            $condition = $this->getStageConditionLv($item3);

            $stageKey = "{$idx3}";
            $stageConditions = array_values($condition);
            oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, 32));
            oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3['stages'], 32));
        }

        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $scoreStage = [];
        $sheetIdx = -1;
        $basicArray = $sheetArray[++$sheetIdx] ?? [];
        $stagesMappingSheet = $sheetArray[++$sheetIdx] ?? [];
        $rewardSheet = $sheetArray[++$sheetIdx] ?? [];

        $lvRanges = $this->getActBasicConfig();
        list($rewardsConfig, $idxMapping) = $this->parseLvStagesMapping($stagesMappingSheet);
        foreach ($rewardsConfig as $item){
            $lvKey = "{$item['start']}-{$item['end']}";
            if(empty($lvRanges['lvRanges'][$lvKey]))
                $this->response(-1, "等级区间异常：$lvKey", $item);

            unset($lvRanges['lvRanges'][$lvKey]);
        }
        foreach ($lvRanges['lvRanges'] as $lvKey => $v){
            $this->response(-1, "等级区间：$lvKey  配置为空", $item);
        }


        foreach ($rewardSheet as $k => $item){
            if (empty($k) || empty($item)) continue;
            $line = $k + 1;
            list($idx, $start, $end) = $item;
            if (empty($idxMapping[$idx])) $this->response(-1, "第{$line}行,唯一id:{$idx} 无对应关系", $item);
            list($lvIdx) = $idxMapping[$idx];

            $start = date('Y-m-d H:i', strtotime($start));
            $end = date('Y-m-d H:i', strtotime($end));
            $rewardsConfig[$lvIdx]['stages'] = $rewardsConfig[$lvIdx]['stages'] ?? [];
            $prize = $this->parseLineRewards(array_slice($item, 3), $line);
            $rewardsConfig[$lvIdx]['stages'][] = [
                'id' => count($rewardsConfig[$lvIdx]['stages'])+1,
                'timeRange' => "{$start}~{$end}",
                'prizes' => $prize,
            ];
        }
        $basicConfig['spinPiggyRewardReward'] = $rewardsConfig;
    }

    function getActBasicConfig(): array
    {
        $tb = otable::spinsPotGift();
        $sql = "SELECT * FROM {$tb} group by startlv,endlv";
        $giftPackList = oo::commonOprDb('slavedb')->getAll($sql, 1);
        $list = [];
        foreach ($giftPackList as $item){
            $list["{$item['startlv']}-{$item['endlv']}"] = [
                'start' => $item['startlv'],
                'end' => $item['endlv']
            ];
        }
        return [
            'lvRanges' => $list
        ];
    }
}