<?php

class SuperBingoActModel extends ActBaseModel implements ActInterface
{
    static $rewardPositionMap = [
            '行1奖励' =>'row1',
            '行2奖励' =>'row2',
            '行3奖励' =>'row3',
            '列1奖励' =>'column1',
            '列2奖励' =>'column2',
            '列3奖励' =>'column3',
            '左上角奖励' =>'corner1',
            '左下角奖励' =>'corner2',
            '最终大奖' =>'final',
    ];


    public $extraConfigFieldMapping = [
        '积分基础值' => 'getScore',
    ];
    function formatActData(array &$actConfig)
    {

        if(empty($actConfig['superBingoConf']['stageConf']))$this->response(1, '操作失败，配置为空', $actConfig);
        $rewardsCfg = $actConfig['superBingoConf']['stageConf'];
        unset($actConfig['superBingoConf']);
        foreach ($rewardsCfg as $lvIdx => &$itemLv){
            if (empty($itemLv['stages']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，配置为空");

            foreach ($itemLv['stages'] as $spinsIdx => &$itemSpins){
                if (empty($itemSpins['stages']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，配置为空");

                foreach ($itemSpins['stages'] as $ssIdx => &$itemSs){
                    if (empty($itemSs['rewards']))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层， 奖励配置为空", $itemSs);

                    foreach (self::$rewardPositionMap as $text => $field){
                        $prize = @json_decode(urldecode($itemSs['rewards'][$field]), true);
                        if (empty($prize))$this->response(__LINE__, "保存失败，第{$lvIdx}层等级层，第{$spinsIdx}层体力层，第{$ssIdx}层数数层， {$text}配置为空", $itemSs);
                        $itemSs['rewards'][$field] = $prize;
                    }
                }
            }
        }
        $actConfig['reward_conf'] = $rewardsCfg;
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $rewardConf = json_decode($actConfig['reward_conf'], true);

        foreach ($rewardConf as $idx1 => $item1) {
            foreach ($item1['stages'] as $idx2 => $item2) {
                foreach ($item2['stages'] as $idx3 => $item3) {
                    $idx = "{$idx1}_{$idx2}_{$idx3}";
                    $condition = $this->getStageConditionLvSpinsShushu($item1, $item2, $item3);
                    oo::commonOprRedis('games')->hset($stageRewardKeys, $idx, json_encode($item3, 32));
                    oo::commonOprRedis('games')->hset($conditionKeys, $idx, json_encode($condition, 32));
                }
            }
        }
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        return true;
    }

    function serializeShowConf(array &$actConfig)
    {
        // TODO: Implement serializeShowConf() method.
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        $sheetIdx = 0;
        $stagesMappingSheet = $sheetArray[++$sheetIdx] ?? [];   // 分层关系配置
        $rewardsSheet = $sheetArray[++$sheetIdx] ?? [];   // 分层关系配置

        list($rewardsConfig, $idxMapping) = $this->parseLvSpinsShushuStagesMapping($stagesMappingSheet);
        $this->parseRewardsSheet($rewardsConfig, $idxMapping, $rewardsSheet);

        $basicConfig['superBingoConf'] = [
            'stageConf' => $rewardsConfig
        ];

    }


    // 进度条
    public function parseRewardsSheet(&$rewardsConfig, $idxMapping, $sheetData){
        $sheetCnt = count($sheetData);
        for($i = 1;$i < $sheetCnt;$i++){
            list($idx, $position) = $sheetData[$i];
            $lineNum = $i+1;
            if (empty(self::$rewardPositionMap[$position])) $this->response(__LINE__, "位置配置不存在：{$position}", $sheetData[$i]);
            $position = self::$rewardPositionMap[$position];

            if (empty($idxMapping[$idx])) $this->response(__LINE__, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $sheetData[$i]);
            list($lvIdx, $spinsIdx, $ssIdx) = $idxMapping[$idx];

            $prizes = $this->parseLineRewards( array_slice($sheetData[$i], 2), $lineNum);

            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['rewards'] = $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['rewards'] ?? [];
            $rewardsConfig[$lvIdx]['stages'][$spinsIdx]['stages'][$ssIdx]['rewards'][$position] = urlencode(json_encode($prizes));

        }
    }


    public function getActBasicConfig(): array
    {
        return self::$rewardPositionMap;
    }
}