<?php

class TimeLimitedIslandModel extends ActBaseModel implements ActInterface
{
    static $islands = [];
    static $islandThemes = [];
    function serializeShowConf(array &$actConfig)
    {

    }

    function formatActData(array &$actConfig)
    {
        $config = $actConfig['timeLimitedIslandConfig'];
        $basicConfig = $actConfig['timeLimitedIslandBasicConfig'];
        if(empty($basicConfig['theme']))$this->response(1, '保存失败，开放主题不能为空');
        if(empty($basicConfig['stars']))$this->response(1, '保存失败，每个建筑的星星数不能为空');
        unset($actConfig['timeLimitedIslandConfig'], $actConfig['timeLimitedIslandBasicConfig']);
        if (empty($config)) $this->response(1, '保存失败，奖励配置异常');
        $allIslandsId = [];
        foreach ($config as $idx => $item) {
            if (empty($item['stages'])) $this->response(1, "第{$idx}层等级区间未配置体力层");
            foreach ($item['stages'] as $idx1 => $item1) {

                if (empty($item1['stages'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间未配置数数层");
                foreach ($item1['stages'] as $idx2 => $item2) {
                    $finalPrize = array_values(json_decode(urldecode($item2['finalPrize']), true));
                    if (empty($finalPrize)) $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间，第{$idx2}层数数区间,未配置最终奖励");
                    $config[$idx]['stages'][$idx1]['stages'][$idx2]['finalPrize'] = $finalPrize;

                    if (empty($item2['islands'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间，第{$idx2}层数数区间未配置岛屿");

                    $config[$idx]['stages'][$idx1]['stages'][$idx2]['islands'] = $item2['islands'] = array_values($item2['islands']);
                    $existIsland = [];
                    foreach ($item2['islands'] as $idx3 => $item3) {
                        $islandIdx = $idx3 + 1;
                        if (empty($item3['island'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间，第{$idx2}层数数区间,第{$islandIdx}个岛屿  未配置岛屿id");
                        if(in_array($item3['island'], $existIsland)){
                            $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间，第{$idx2}层数数区间,第{$islandIdx}个岛屿已存在");
                        }
                        $existIsland[] = $item3['island'];
                        $allIslandsId[] = $item3['island'];

                        $completePrize = array_values(json_decode(urldecode($item3['completePrize']), true));
                        if (empty($completePrize)) $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间，第{$idx2}层数数区间,第{$islandIdx}个岛屿 未配置关卡奖励");
                        $config[$idx]['stages'][$idx1]['stages'][$idx2]['islands'][$idx3]['completePrize'] = $completePrize;
                        foreach ($item3['buildings'] as $idx4 => $build) {
                            $prize = array_values(json_decode(urldecode($build['prize']), true));
                            if (empty($prize)) $this->response(1, "第{$idx}层等级区间，第{$idx1}层体力区间，第{$idx2}层数数区间,第{$islandIdx}个岛屿,第{$idx4}个建筑 未配置奖励");
                            $config[$idx]['stages'][$idx1]['stages'][$idx2]['islands'][$idx3]['buildings'][$idx4]['prize'] = $prize;
                        }
//                        $this->response(1, '7777777', $item3['stages'] );
                    }
                }
            }
        }
        $actConfig['extraData'] = json_encode($config, JSON_NUMERIC_CHECK);
        $actConfig['reward_info'] = json_encode($basicConfig, JSON_NUMERIC_CHECK);

        // 更新岛屿数据
        $updateData = [
            'last_opentime' => $actConfig['start_time'],
            'themeId' => $basicConfig['theme'],
        ];
        $ids = implode(',', $allIslandsId);
        $sql = funs::db_updateSQL(otable::timeLimitedIsland(),$updateData, " iid in ({$ids})" );
        $res = oo::commonOprDb('games')->query($sql);
        if(!$res) $this->response(1, "更新岛屿开放时间失败！");

        // 更新主题数据
        $updateData = [
            'last_opentime' => $actConfig['start_time'],
        ];
        if (!empty($actConfig['imgName'])){
            $updateData['theme_res'] = $actConfig['imgName'];
        }
        $sql = funs::db_updateSQL(otable::timeLimitedIslandThemes(),$updateData, " iid={$basicConfig['theme']}" );
        $res = oo::commonOprDb('games')->query($sql);
        if(!$res) $this->response(1, "更新岛屿主题开放时间失败！");

        self::updateTimeLimitedIslandThemesJson();


    }

    function writeActCache(array $actConfig)
    {
        $this->writeActCacheCommonLvSpinsShushu($actConfig, 'extraData');
    }

    function importActData(array &$basicConfig,  $sheetArray): array
    {
        $sheetIdx = 1;
        $basicSheet2 = $sheetArray[$sheetIdx++];
        $stagesMappingArray = $sheetArray[$sheetIdx++];
        $stageRewardsSheet = $sheetArray[$sheetIdx++];
        $finalRewardsSheet = $sheetArray[$sheetIdx++];
        $basicConfig['timeLimitedIslandBasicConfig'] = $this->parseBasicConfig2(TIME_LIMITED_ISLAND, $basicSheet2);
        $themeName = $basicConfig['timeLimitedIslandBasicConfig']['theme'];
        $basicConfig['timeLimitedIslandBasicConfig']['theme'] = $this->parseThemeId($themeName);
        if (empty($basicConfig['timeLimitedIslandBasicConfig']['theme']))$this->response(-1, "主题:{$themeName} 不存在");

        list($rewardsConfig, $idxMapping) = $this->parseLvSpinsShushuStagesMapping($stagesMappingArray);

        foreach ($stageRewardsSheet as $k => $item){
            if (empty($k) || empty($item)) continue;
            $lineNum = $k + 1;
            list($idx, $islandRemark, $buildIdx) = $item;
            list($lvStage, $spinsStage, $ssStage) = $idxMapping[$idx];
            if (empty($idxMapping[$idx])) $this->response(-1, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $item);
            $prizes = $this->parseLineRewards( array_slice($item, 3), $lineNum);

            $islandId = $this->parseIslandId($islandRemark);
            if (empty($islandId))$this->response(-1, "第{$lineNum}行,岛屿:{$islandRemark} 不存在", $item);
            $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'] = $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'] ?? [];
            $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'][$islandId] = $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'][$islandId] ??[
                'island' => $islandId,
                'buildings' => [],
                'completePrize' => [],
            ];
            if($buildIdx != count($rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'][$islandId]['buildings'])+1)
                $this->response(-1, "第{$lineNum}行,建筑索引异常", $item);
            if($buildIdx == 6){
                $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'][$islandId]['completePrize'] = urlencode(json_encode($prizes));
            }else{
                $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['islands'][$islandId]['buildings'][$buildIdx] = [
                    'prize' => urlencode(json_encode($prizes))
                ];
            }

        }

        foreach ($finalRewardsSheet as $k => $item){
            if (empty($k) || empty($item)) continue;
            $lineNum = $k + 1;
            list($idx) = $item;
            list($lvStage, $spinsStage, $ssStage) = $idxMapping[$idx];
            if (empty($idxMapping[$idx])) $this->response(-1, "第{$lineNum}行,唯一id:{$idx} 无对应关系", $item);
            $prizes = $this->parseLineRewards( array_slice($item, 1), $lineNum);
            $rewardsConfig[$lvStage]['stages'][$spinsStage]['stages'][$ssStage]['finalPrize'] = urlencode(json_encode($prizes));

        }
//        $this->response(-1, "88888", $rewardsConfig);
        $basicConfig['timeLimitedIslandConfig'] = $rewardsConfig;
        return [];
    }

    static function parseIslandId(string $remark):int{
        if (empty(self::$islands))
            self::$islands = self::getIslands();
        foreach (self::$islands as $island){
            if($island['remark'] == $remark)return $island['iid'];
        }
        return 0;
    }

    static function parseThemeId(string $remark):int{
        if (empty(self::$islandThemes))
            self::$islandThemes = self::getIslandThemes();
        foreach (self::$islandThemes as $theme){
            if($theme['remark'] == $remark)return $theme['iid'];
        }
        return 0;
    }

    static function getIslands():array{
        $tb = otable::timeLimitedIsland();
        $sql = "select * from {$tb} ";
        return oo::commonOprDb('slavedb')->getAll($sql);
    }

    static function getIslandThemes():array{
        $tb = otable::timeLimitedIslandThemes();
        $sql = "select * from {$tb} ";
        return oo::commonOprDb('slavedb')->getAll($sql);
    }

    public function getActBasicConfig(): array
    {
        $islands = self::getIslands();
        $islandThemes = self::getIslandThemes();
        return [
            'islands' => $islands,
            'islandThemes' => $islandThemes,
        ];
    }


    static function updateTimeLimitedIslandThemesJson(){
        $json = self::getIslandThemes();
        foreach ($json as &$item){
            $item['title'] = json_decode($item['title'], true);
        }
        $filename = 'TimeLimitedIslandsThemes' . time() . '.json';
        oo::commonOprModel("json")->SaveJson($json, $filename);
        oo::commonOprModel("json")->setStaticConfig("TimeLimitedIslandsThemes", $filename);
    }

    static function updateTimeLimitedIslandsJson(){
        $json = self::getIslands();
        foreach ($json as &$item){
            $item['name'] = json_decode($item['name'], true);
        }
        $filename = 'TimeLimitedIslands' . time() . '.json';
        oo::commonOprModel("json")->SaveJson($json, $filename);
        oo::commonOprModel("json")->setStaticConfig("TimeLimitedIslands", $filename);
    }

}