<?php

class TreasureActModel extends ActBaseModel implements ActInterface
{

    function serializeShowConf(array &$actConfig)
    {
        foreach ($actConfig['stages'] as $idx1 => &$items1) {
            foreach ($items1['stages'] as $idx2 => &$items2) {
                if (isset($items2['stages'][0]['id'])) {
                    $items2['stages'] = [$items2['stages']];
                }
            }
        }
    }

    function formatActData(array &$actConfig)
    {
        $maxStageCnt = 0;
        if (empty($actConfig['treasure'])) $this->response(1, '保存失败，奖励配置异常');
        foreach ($actConfig['treasure'] as $idx => $item) {
            if (empty($item['stages'])) $this->response(1, "第{$idx}层等级区间未配置Y值层");
            foreach ($item['stages'] as $idx1 => $item1) {

                if (empty($item1['stages'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层Y值区间未配置数数层");
                foreach ($item1['stages'] as $idx2 => $item2) {

                    if (empty($item2['stages'])) $this->response(1, "第{$idx}层等级区间，第{$idx1}层Y值区间，第{$idx2}层数数区间未配置关卡");
                    $maxStageCnt = max(count($item2['stages']), $maxStageCnt);
                    foreach ($item2['stages'] as $idx3 => $item3) {
                        foreach ($item3 as $idx4 => $rewardItem) {
                            $tmpPrize = array_values(json_decode(urldecode($rewardItem['prize']), true));
                            $tmpBet = array_values(json_decode(urldecode($rewardItem['bet']), true));
                            if (empty($tmpPrize) || empty($tmpBet)) $this->response(1, "第{$idx}层等级区间，第{$idx1}层Y值区间，第{$idx2}层数数区间，，第{$idx3}层房间，第{$idx4}层任务未配置奖励或倍率");
                            sort($tmpBet);
                            $actConfig['treasure'][$idx]['stages'][$idx1]['stages'][$idx2]['stages'][$idx3][$idx4]['prize'] = $tmpPrize;
                            $actConfig['treasure'][$idx]['stages'][$idx1]['stages'][$idx2]['stages'][$idx3][$idx4]['bet'] = $tmpBet;
                        }
                    }
                }
            }
        }
        if (count($actConfig['prdConf']) < $maxStageCnt) $this->response(1, "prd概率配置任务数:" . count($actConfig['prdConf']) . ",小于最大任务数:{$maxStageCnt}");
        $actConfig['reward_info'] = "{}";
        $actConfig['extra_reward'] = json_encode([
            'fixCo' => $actConfig['common_conf'] ?? [],
            'waterLevelCoefficient' => [],
            'prdConf' => $actConfig['prdConf'],
        ], JSON_NUMERIC_CHECK);

        $actConfig['extraData'] = json_encode([
            'openLv' => $actConfig['treasureOpenLv'],
            'spinsRatio' => intval($actConfig['spinsRatio']),
//                        'difficultyDegree'=> $data['difficultyDegree'],
//                        'taskDegree'=> $data['taskDegree'],
            'yStages' => $actConfig['treasure']
        ], JSON_NUMERIC_CHECK);
        $actConfig['reward_info'] = json_encode($actConfig['treasureWeightGroup'], 32);
        unset($actConfig['treasureWeightGroup'], $actConfig['spinsRatio'], $actConfig['treasureWaterLevelCoefficient'], $actConfig['prdConf'], $actConfig['spins'], $actConfig['spinStage'], $actConfig['treasureShushu'], $actConfig['difficultyDegree'], $actConfig['taskDegree']);
    }

    function writeActCache(array $actConfig)
    {
        $conditionKeys = okeys::activityConditionKeys($actConfig['aid']);
        $stageRewardKeys = okeys::activityRewardsStageKeys($actConfig['aid']);
        $stageExtraConfKeys = okeys::activityStageExtraConfigKeys($actConfig['aid']);
        $extraReward = json_decode($actConfig['extraData'], true) ?? [];
        $rewardInfo = json_decode($actConfig['reward_info'], true) ?? [];
        $expireTime = ActBaseModel::getActCacheExpireTime($actConfig['end_time']);#redis最少一分钟
        foreach ($extraReward['yStages'] as $idx1 => $item1) {
            $condition = [
                CONDITION_TYPE_LV => [
                    'shushu' => [],
                    'start' => $item1['start'],
                    'end' => $item1['end'],
                    'type' => CONDITION_TYPE_LV,
                ],
            ];
            foreach ($item1['stages'] as $idx2 => $item2) {
                $condition[CONDITION_TYPE_COIN_Y] = [
                    'shushu' => [],
                    'start' => $item2['start'],
                    'end' => $item2['end'],
                    'type' => CONDITION_TYPE_COIN_Y,
                ];


                foreach ($item2['stages'] as $idx3 => $item3) {
                    $condition[CONDITION_TYPE_SHUSHU] = [
                        'shushu' => $item3['shushu'],
                        'start' => 0,
                        'end' => 0,
                        'type' => CONDITION_TYPE_SHUSHU,
                    ];

                    $stageKey = "{$idx1}_{$idx2}_{$idx3}";
                    $stageConditions = array_values($condition);
                    unset($item3['start']);
                    unset($item3['end']);
                    oo::commonOprRedis('games')->hset($conditionKeys, $stageKey, json_encode($stageConditions, 32));
                    oo::commonOprRedis('games')->hset($stageRewardKeys, $stageKey, json_encode($item3['stages'], 32));
                    oo::commonOprRedis('games')->hset($stageExtraConfKeys, $stageKey, json_encode(['treasureWeightConfig' => $rewardInfo[$stageKey] ?? []], 32));

                }
            }
        }
        $SpinsRatioKey = okeys::treasureSpinsRatio($actConfig['aid']);
        oo::commonOprRedis('games')->set($SpinsRatioKey, $extraReward['spinsRatio']);
        oo::commonOprRedis('games')->expireAt($SpinsRatioKey, oo::redisRandomExpire($expireTime));

        oo::commonOprRedis('games')->expireAt($conditionKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageRewardKeys, oo::redisRandomExpire($expireTime));
        oo::commonOprRedis('games')->expireAt($stageExtraConfKeys, oo::redisRandomExpire($expireTime));
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
    }
}