<?php

class WarmupNoticeActModel extends ActBaseModel implements ActInterface
{
    function formatActData(array &$actConfig)
    {
        $actConfig['extraData'] = json_encode($actConfig['warmupNoticeConf'], JSON_NUMERIC_CHECK);
        $actConfig['extraData'] = str_replace(array('\r\n', '\r'), '\n', $actConfig['extraData']);

        unset($actConfig['warmupNoticeConf']);
    }

    function writeActCache(array $actConfig)
    {
    }

    function serializeShowConf(array &$actConfig)
    {
        $actConfig['reward_info'] = json_encode(oo::commonOprModel('config')->getCurLangs());
    }

    function importActData(array &$basicConfig, $sheetArray)
    {
        if (count($sheetArray) < 2) {
            $this->response(-1 * __LINE__, "工作表数量不匹配");
        }

        $sheet2 = $sheetArray[1] ?? [];

        $noticeConf = ['device' => 'all'];
        $contentConf = $this->parseContentSheet($sheet2);
        $basicConfig['warmupNoticeConf'] = $this->packageConf($noticeConf, $contentConf);
    }

    private function parseContentSheet(array $sheet): array
    {
        $contentConf = [];
        $titleArr = $sheet[0];
        for ($i = 1; $i < count($titleArr); $i++) {
            $title = trim($titleArr[$i]);

            $contentConf[$title] = [];
        }

        for ($i = 1; $i < count($sheet); $i++) {
            $row = $sheet[$i];
            if (empty(array_filter($row))) {
                continue;
            }

            $idx = 1;
            foreach ($contentConf as &$content) {
                $content["contents"][] = $row[$idx] ?? "";
                $idx++;
            }
        }

        return $contentConf;
    }

    private function packageConf(array $noticeConf, array $contentConf): array
    {
        $noticeConf["conf"] = $contentConf;


        return $noticeConf;
    }

}