<?php
class JsonModel extends CI_Model
{
    public $staticPath = "./public/game/config/";
    public function __construct(){
        parent::__construct();
        $this->load->model('oo');
    }

    static $postData = array('frombg' => 1, 'lid' => 1, 'sid' => 1);
    public function SaveJson($data,$filename){
        $dir = $this->staticPath;
        if (!is_dir($dir))
        {
            $old = umask(0);
            //mkdir($dir, PRODUCTION_SERVER ? 0775 : 0777, true);
            mkdir($dir,0775 , true);
            umask($old);
        }
        $filepath = "{$dir}{$filename}";
        $data = json_decode(json_encode($data,JSON_NUMERIC_CHECK), true);
        $ret = file_put_contents($filepath, json_encode($data,JSON_UNESCAPED_UNICODE));

        $dir = str_replace("./","",$dir);
        $file_path = str_replace("\\","/",FCPATH . $dir.$filename);
        oo::commonOprModel('common')->upToOss($dir.$filename,$file_path);

        return $ret;
    }

    /**
     * 获取静态配置文件内容
     * @param $configName string
     * @return string
     */
    public function getStaticConfig($configName){
        $dir = $this->staticPath;
        $filename = oo::commonOprRedis('games')->hGet(okeys::StaticConfig(), $configName);
        if(empty($filename)){
            $tb = otable::StaticConfig();
            $sql = "SELECT path FROM {$tb} WHERE config='{$configName}'";
            $ret = oo::commonOprDb('slavedb')->getOne($sql, 1);
            if(empty($ret['path'])){
                return '';
            }
            $filename = $ret['path'];
            oo::commonOprRedis('games')->hSet(okeys::StaticConfig(), $configName, $filename);
        }
        $filepath = "{$dir}{$filename}";
        $ret = file_get_contents("{$filepath}");
        return $ret ? (array)json_decode($ret, true) : '';
    }

    /**
     * 設置静态配置文件
     * @param $configName
     * @param $filename
     * @return mixed
     * Created by: Owen
     * Created on: 2020/4/29 19:56
     */
    public function setStaticConfig($configName,$filename){
        $tb  = otable::StaticConfig();
        $sql1 = "SELECT * FROM {$tb} where config='{$configName}'";
        $res = oo::commonOprDb('games')->getOne($sql1,1);
        if(!empty($res)){
            $sql = "UPDATE {$tb} SET path='{$filename}' WHERE config='{$configName}'";
            $ret = oo::commonOprDb('games')->query($sql);
        }else{
            $sql = funs::db_insertSQL($tb,["config"=>$configName,"path"=>$filename]);
            $ret = oo::commonOprDb('games')->query($sql);
        }
        $cache = oo::commonOprRedis('games')->hSet(okeys::StaticConfig(),$configName,$filename);
        return min($ret,$cache);
    }

    /**
     * 礼包配置
     * Created by: Owen
     * Created on: 2020/7/6 19:12
     */
    public function giftWeightsJson(){
        $tb = otable::GiftTrigger();
        $ret= oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb}",MYSQLI_ASSOC);
        $json['condition'] = $ret;
        $tb = otable::goodsCrazy();
        $ret= oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb} WHERE gtype=16",MYSQLI_ASSOC);
        $good = [];
        foreach ($ret as $row){
            $reward = json_decode($row['gbaseReward'],true);
            $propsTemp = $reward['props'];
            foreach ($propsTemp as $key=>$p){
                $pConfig = oo::commonOprModel('config')->getChestData($p['propsId']);
                if($pConfig){
                    $propsTemp[$key]['value'] = $pConfig;
                }
            }
            $temp = [
                'gid'        => $row['gid'],
                'pid'        => $row['gpid'],
                'coins'      => [
                    'gid'  => oo::commonOprModel('config')->coinsToGid($reward['coins']['coins']),
                    'bet'  => $reward['coins']['bet']
                ],
                'spins'      => $reward['spins'],
                'props'      => $propsTemp,
                'price'      => "$".$row['gprice'] ,
                'priceNum'   => (string)$row['gprice'],
                'sku'        => $row['gsku'],
                'isoSku'     => str_replace('gworld.cc','astak.crazyspin',$row['gsku']),
                'ggameid'    => $row['ggameid'],
                'gdiscount'  => $row['gdiscount'],
                'priceDollar'=> '$',
                'addRatio'   => $row['gaddRatio'],
                'expire'     => $row['gExpire'],
                'max'        => $row['gMax'],
            ];
            if(!empty($row['gShowCountry'])){
                $temp['countryCode'] = explode(',',$row['gShowCountry']);
            }
            if(!empty($row['gShowGroup'])){
                $temp['gShowGroup'] = explode(',',$row['gShowGroup']);
            }
            if(!empty($row['gShowGroupSS'])){
                $temp['gShowGroupSS'] = explode(',',$row['gShowGroupSS']);
            }
            $good[] = $temp;
        }
        $json['goods'] = $good;
        $tb = otable::GiftWeights();
        $ret= oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb}",MYSQLI_ASSOC);
        foreach ($ret as $key=>$row){
            $ret[$key]['data'] = json_decode($row['data'],true);
        }
        $json['weights'] = $ret;
        $json['openGiftPack'] = oo::commonOprModel('config')->getSysCon("giftPack","openGiftPack");
        $configName = "GiftPackageConfig";
        $filename   = "GiftPackageConfig".time().".json";
        self::SaveJson($json,$filename) && self::setStaticConfig($configName,$filename);
    }

    /**
     * 建筑价格
     * Created by: Owen
     * Created on: 2020/7/6 19:13
     */
    public function levelCoinConfig(){
        $tb   = otable::coinConfig();
        $ret  = oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb}",MYSQLI_ASSOC);
        $json = [];
        foreach ($ret as $row){
            $json[] = [
                'level' => $row['levelId'],
                'data' => json_decode($row['coinConfig'],true),
            ];
        }
        $filename   = "levelConfig".time().".json";
        self::SaveJson($json,$filename) && self::setStaticConfig("Level",$filename);
    }

    public static function saveShareConfigJson(){
        $tb  = otable::shareConfig();
        $baseTb  = otable::shareBaseConfig();
        $ret  = oo::commonOprDb('slavedb')->getAll("SELECT * FROM {$tb}",MYSQLI_ASSOC);
        $ret  = array_column($ret,NULL,"key");
        $ret2  = oo::commonOprDb('slavedb')->getOne("SELECT * FROM {$baseTb}",MYSQLI_ASSOC);
        $tbConf2 = otable::shareConfig2();
        $retInvite  = oo::commonOprDb('slavedb')->getOne("SELECT * FROM {$tbConf2} WHERE `type`='invite'",MYSQLI_ASSOC);

        //$inviteConf = oo::commonOprDb('slavedb')->getOne("SELECT * FROM ");

        foreach ($ret as $key=>$row){
            $reward = json_decode($row['reward'],true);
            $track  = json_decode($row['track'],true);
            $abTest = json_decode($row['abTest'],true);
            $actImg = $row['actImg'] ? (array)json_decode($row['actImg'],true) : [];
            $json[$key] = [
                //'maxTimes'     => $row['maxTimes'],
                //'reward'       => $reward,
                //'intervalTime' => $row['intervalTime'],
                //'show'         => $row['show'],
                'shareType'    => $row['shareType'],
                'abTest'       => $abTest,
                'track'        => $track,
                'actImg'       => $actImg,
                'intervalTime' => $row['intervalTime'],
            ];
            if($row['key'] == 'INVITE_FRIEND'){
                $json[$key]['reward'] = (array)json_decode($retInvite['reward'], true);
                $json[$key]['intervalTime'] = $retInvite['intervalTime'];
                $json[$key]['maxTimes'] = $retInvite['maxTimes'];
                $json[$key]['show'] = $retInvite['show'];
            }
        }
        $json['maxTimes'] = (int)$ret2['maxTimes'];
        $json['reward'] = [["propsId"=>15,"num" => (int)$ret2['reward']]];
        $json['show'] = (int)$ret2['show'];
        $json['intervalTime'] = (int)$ret2['intervalTime'];

        //删除公共配置
        oo::commonOprRedis('games')->delete(okeys::shareBaseConfig());
        //删除
        oo::commonOprRedis('games')->delete(okeys::shareConfig(3));

        $filename = "ShareConfig".time().".json";
        oo::commonOprModel("json")->SaveJson($json,$filename) && oo::commonOprModel("json")->setStaticConfig("Share",$filename);
        oo::commonOprModel("language")->setLangJson();
    }

    public static function saveExchangeBlessingJson(){
        $config = ConfigModel::getExchangeBlessingWeights();
        $json = [];
        foreach ($config as $item){
            $json[$item['iid']] = json_decode($item['config'], true);
        }

        $jsonPrefix = 'BuildExchangeBlessingJson';
        $filename = $jsonPrefix . time() . ".json";
        oo::commonOprModel("json")->SaveJson($json,$filename) && oo::commonOprModel("json")->setStaticConfig($jsonPrefix,$filename);
    }

    public static function levelNameJson(){
        $tb = otable::coinConfig();
        $sql = "SELECT * from {$tb}";
        $levelCfg = oo::commonOprDb('slavedb')->getAll($sql,1);
        $levelLangs = oo::cfg('lang')['lang_level'];
        foreach ($levelLangs as $lang => $langCn){
            $json = [];

            foreach ($levelCfg as $item){
                $json[$item['levelId']] = $item[$lang];
            }
            switch ($lang){
                case 'name':$suffixLang = 'name_zh';break;
                case 'name_rou':$suffixLang = 'name_ro';break;
                default:$suffixLang = $lang;break;
            }
            $suffixLang = strtoupper(substr($suffixLang, 5));
            if($suffixLang == 'VN')$suffixLang = 'VI';
            $jsonPrefix = "levelName{$suffixLang}";
            $filename = $jsonPrefix . time() . ".json";
            oo::commonOprModel("json")->SaveJson($json,$filename) && oo::commonOprModel("json")->setStaticConfig($jsonPrefix,$filename);
        }
    }

    public static function cardJson($incrementIds = []){

        $posts = self::$postData;
        $posts['mod'] = 'card';
        $posts['act'] = 'makeCardJson';
        $posts['incrementIds'] = json_encode($incrementIds);

        $retData = oo::httpPost($posts);
        if ($retData['code'] != 1) {
            return;
        }

        $langs = array_keys(oo::cfg('lang')['lang_upper2']);
        $data = $retData['data'];
        $incrementData = $data['incrementData'];
        unset($data['incrementData']);

        // 旧json数据
        $configName = "CardCollect";
        $filename = $configName . time() . '.json';
        oo::commonOprModel("json")->SaveJson($data, $filename);
        oo::commonOprModel("json")->setStaticConfig($configName, $filename);


        // 卡组信息去掉多语言名称
        foreach ($data['cardGroupTable']['basic'] as &$item){
            unset($item['name']);
        }
        $filePrefix = 'CardGroup';
        $filename = $filePrefix . time() . '.json';
        oo::commonOprModel("json")->SaveJson($data['cardGroupTable'], $filename);
        oo::commonOprModel("json")->setStaticConfig($filePrefix, $filename);


        // 卡片信息去掉多语言名称
        foreach ($data['cardInfoTable'] as &$item){
            unset($item['name']);
        }
        $filePrefix = 'CardInfo';
        $filename = $filePrefix . time() . '.json';
        oo::commonOprModel("json")->SaveJson($data['cardInfoTable'], $filename);
        oo::commonOprModel("json")->setStaticConfig($filePrefix, $filename);


        $tb = otable::cardgroup_config();
        $cardGroupData = oo::commonOprDb('slavedb')->getAll("SELECT * from {$tb} WHERE 1", 1);

        $tb = otable::cardinfo_config();
        $cardData = oo::commonOprDb('slavedb')->getAll("SELECT * from {$tb} WHERE 1", 1);


        foreach ($langs as $lang){
            $langData = [
                'cardGroup' => [],
                'card' => [],
            ];
            $filePrefix = 'CardName'.$lang;
            $filename = $filePrefix . time() . '.json';

            $lang = strtolower($lang);
            if($lang == 'vi')$lang = 'vn';
            if($lang == 'ro')$lang = 'rou';
            if($lang == 'en')$lang = '';
            else $lang = '_'.$lang;

            foreach ($cardGroupData as $cardGroupDatum){
                $langData['cardGroup'][$cardGroupDatum['cgid']] = $cardGroupDatum["cg_name{$lang}"];
            }

            foreach ($cardData as $cardDatum){
                $langData['card'][$cardDatum['ciid']] = $cardDatum["ci_name{$lang}"];
            }

            oo::commonOprModel("json")->SaveJson($langData, $filename);
            oo::commonOprModel("json")->setStaticConfig($filePrefix, $filename);
        }

        if(!empty($incrementIds)){
            $filePrefix = "CardCollectIncrement";
            $filename = $filePrefix . time() . '.json';

            oo::commonOprModel("json")->SaveJson($incrementData, $filename);
            oo::commonOprModel("json")->setStaticConfig($filePrefix, $filename);

            // 发送nsq
            $posts = self::$postData;
            $posts['mod'] = 'card';
            $posts['act'] = 'pushIncrementCardJson';
            $posts['filename'] = $filename;

            oo::httpPost($posts);
        }

    }
}
