<?php

class OptionalChestModel extends CI_Model
{
    public static function updateConfig(array $data): array
    {
        $tb = otable::optionalChestConfig();

        // 校验
        foreach ($data as $item) {
            if (empty($item['id'])) {
                $prefix = "新增宝箱";
            } else {
                $prefix = "宝箱ID:{$item['id']}";
            }
            if (empty($item['title'])) {
                return array(1, "$prefix 名称为空");
            }

            $item['skin'] = intval($item['skin']);
            if ($item['skin'] == 0) {
                return array(1, "$prefix 皮肤只能配置为整数且不为0");
            }

            $item['reward'] = json_decode($item['reward'], true);
            if (empty($item['reward'])) {
                return array(1, "$prefix 奖励为空");
            }
            foreach ($item['reward'] as $one) {
                if ($one['propsId'] == 70) {
                    return array(1, "$prefix 奖励不能配置为自选宝箱");
                }
            }

            $item['reward'] = json_encode($item['reward'], JSON_NUMERIC_CHECK);
            $sql = funs::db_upsertSQL($tb, $item);
            $ret = oo::commonOprDb('games')->query($sql);
            if (!$ret) {
                return array(1, "操作失败");
            }
        }

        $list = oo::commonOprDb('games')->getAll("SELECT * from {$tb} WHERE 1");

        $jsonData = [];
        foreach ($list as $item) {
            $item['reward'] = json_decode($item['reward'], true);
            $jsonData[$item['id']] = $item;
        }

        self::updateCache($jsonData);

        $filename = 'OptionalChestConf' . time() . '.json';

        oo::commonOprModel("json")->SaveJson($jsonData, $filename);
        oo::commonOprModel("json")->setStaticConfig("OptionalChestConf", $filename);

        return array(0, "操作成功");
    }

    private static function updateCache(array $jsonData)
    {
        $cacheMap = [];
        foreach ($jsonData as $id => $item) {
            $cacheMap[$id] = json_encode($item, JSON_NUMERIC_CHECK);
        }

        oo::commonOprRedis('games')->hMset(okeys::optionalChest(), $cacheMap);

    }
}