<?php

use Clouding\Presto\Presto;
class SSdataModel extends CI_Model
{
    public $token="B30rBC3RjPks0spLCOX4ybYWUS9UTVIIA55vJnJ3BpwUxzqNRMeO7QBeAZNPfqjF";
    public $groupListUrl ="http://172.22.107.114:8992/open/user-cluster-list";
    public $projectId = 3;
    public $groupListInfo =[];
    public $shushuHost = 'http://172.22.107.114:8992';

    public $sqlUrl = "172.22.107.113:8082";
    public $catalog = 'hive';
    public $schema ="ta";
    function __construct()
    {
//        $this->token =   $this->config->item('ss_token');
//        $this->projectId=   $this->config->item('ss_group_projectId');
//        $this->groupListUrl = $this->config->item('ss_group_list_url');
//        $this->sqlUrl = $this->config->item('ss_db_data_url');
        # code...
    }
    function sendJosnPost($url,$dataArr){
        $data_string = json_encode($dataArr);
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS,$data_string);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($data_string))
        );

        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }
    //拉取分组名称列表
    function getGroupList(){
        $dataArr = [
            "clusterCatalog"=>"catalog_cluster",
            "clusterTypes"=>["cluster_by_dynamic_condition","cluster_by_static_condition","cluster_by_result","cluster_by_static_sql","cluster_by_dynamic_sql"],
            "pagerHeader"=>["pageNum"=>1,"pageSize"=>1000],
            "projectId"=>$this->projectId,
        ];
        $url = $this->groupListUrl."?token={$this->token}";
        oo::logs()->commlog($dataArr, 'ssGroupList.log');
        $ret = $this->sendJosnPost($url,$dataArr);
        $retData = json_decode($ret,true);
        if(!empty($retData)&&is_array($retData)){
            $this->groupListInfo = $retData['data']['userClusters'];
        }
        return $this->groupListInfo;
    }
    //根据分组名称拉取分组用户列表
    function getUidListByGroupName($cluster_name){
        $presto = new Presto();

        $presto->addConnection([
            'host' => $this->sqlUrl,
            'catalog' => $this->catalog,
            'schema' => $this->schema,
        ]);
        $presto->setAsGlobal();
        $sql = 'select "#account_id" from v_user_'.$this->projectId.' where "#user_id" in (SELECT "#user_id" from user_result_cluster_'.$this->projectId.' where cluster_name=\''.$cluster_name.'\') ';
        $posts = $presto->connection()->query($sql)->get();
        if(!empty($posts)&&is_array($posts)){
            foreach ($posts as $key => $value) {
                if($value[0]){
                    $ret[] = $value[0];
                }
            }
        }
        return $ret;
    }
    /**
     * Notes:定时根据数数分组列表,更新各分组的用户列表并缓存
     * User: wsc
     * Time: 2023/2/23 18:02
     */
    public function updataSSUserListFromSS(){
        //获取需要更新的分组列表
        $config = oo::commonOprModel('config')->getUserGroupConfigByCid(5);
        //通过分组名称，到数数拉取分组内用户
        foreach ($config as $v){
            if($v['groupId'] == 0 || $v['name'] == '数数-默认分组'){
                continue;
            }

            $key = okeys::userListSSGroup($v['groupId']);
            oo::commonOprRedis('statistics')->delete($key);

            $uidList = $this->getUidListByGroupName($v['name']);
            if(!empty($uidList)){
                foreach ($uidList as $uid){
                    oo::commonOprRedis('statistics')->zAdd($key,1,$uid);
                }
            }
        }
    }

    //更新每日首次用户数数分组
    public function updataUserFirstLoginShuShuGroup(){
        $lSize = oo::commonOprRedis('games')->lSize(okeys::UserGroupAction(2));
        $userGroupConfig = oo::commonOprModel('config')->getUserGroupConfig2();
        array_multisort(array_column($userGroupConfig,'sort'),SORT_DESC,$userGroupConfig);
        for($i=0;$i<$lSize;$i++) {
            $uid = oo::commonOprRedis('games')->lPop(okeys::UserGroupAction(2));
            if(!$uid||$uid==1){
                continue;
            }
            $this->updateSGroup($uid);//数数分组
        }
    }

    function checkRefreshStatusByGroupName($cluster_name){
        $url = "{$this->shushuHost}/open/user-cluster-refresh-progress-by-name?token={$this->token}&projectId={$this->projectId}&clusterName={$cluster_name}";
        $response = file_get_contents($url);
        return $response;
    }

    //根据uid给用户分配分组
    public function updateSGroup($uid){
        if(empty($uid)){
            return false;
        }
        $uGroupArr = [];
        $config = oo::commonOprModel('config')->getUserGroupConfigByCid(5);
        foreach ($config as $v){

            $key = okeys::userListSSGroup($v['groupId']);
            $res = oo::commonOprRedis('statistics')->zScore($key,$uid);

            if($res!==false){
                array_push($uGroupArr,$v['id']);
            }
        }
        $regSSgroup = oo::commonOprModel('member')->regSSgroup($uid);
        if($regSSgroup){
            $uGroupArr = array_merge($uGroupArr,$regSSgroup);
            $uGroupArr = array_filter($uGroupArr);
            $uGroupArr = array_unique($uGroupArr);
        }
        if($uGroupArr){
            $group = implode(',',$uGroupArr);
            oo::commonOprModel('member')->updateUserDynamicsData($uid,["groupId3"=>$group]);
        }else{
            oo::commonOprModel('member')->updateUserDynamicsData($uid,["groupId3"=>"0"]);
        }
        $file =  'deBUG/userShushuGroups/'.date('Ymd') . '.log';//存储文件夹
        self::createDir($file);
        file_put_contents($file, "{$uid}:$group" . PHP_EOL, FILE_APPEND);
    }

    public static function createDir($file){
        $dir = dirname($file);
        if(!is_dir($dir)){
            mkdir($dir, 0777, true);
        }
    }


}