<?php

class SceneTriggerModel extends CI_Model
{
    public static function updateConfig(array $formData): array
    {
        $ids = array_column(self::getAllId(), 'id');
        $tb = otable::sceneTriggerConfig();

        if (!self::validateConf($formData)) {
            return array(-1, '同一个触发行为,触发有效期不能重叠');
        }

        $formData['reward'] = json_encode($formData['reward'], JSON_NUMERIC_CHECK);

        // 新增配置
        if (empty($formData['id']) || !in_array($formData['id'], $ids)) {
            $sql = funs::db_insertSQL($tb, $formData);
        } else {
            // 修改配置
            $sql = funs::db_updateSQL($tb, $formData, "id = " . $formData['id']);
        }
        $ret = oo::commonOprDb('games')->query($sql);

        if (!$ret) {
            return array(-1, '操作失败');
        }

        return array(0, '操作成功');
    }

    public static function delConfig(array $existIds)
    {
        $ids = array_column(self::getAllId(), 'id');
        foreach ($ids as $id) {
            if (!in_array($id, $existIds)) {
                self::delById($id);
            }
        }
    }

    public static function getAllId(): array
    {
        $tb = otable::sceneTriggerConfig();
        return oo::commonOprDb('slavedb')->getAll("SELECT id from $tb WHERE 1");
    }

    public static function delById(int $id)
    {
        $tb = otable::sceneTriggerConfig();
        return oo::commonOprDb('games')->query("Delete from $tb where id={$id}");
    }

    public static function validateConf($formData): bool
    {
        $tb = otable::sceneTriggerConfig();
        $triggerConf = oo::commonOprDb('slavedb')->getAll("SELECT id,date_start,date_end from {$tb} WHERE scene = {$formData['scene']}");
        foreach ($triggerConf as $item) {
            if ($item['id'] == $formData['id']) {
                continue;
            }
            if ($formData['date_start'] <= $item['date_end'] && $formData['date_end'] >= $item['date_start']) {
                return false;
            }
        }

        return true;
    }


}