<?php

class SvenModel extends CI_Model
{
    public $wheelRewards = [
        0   => [ 'propsId' => 18,    'num' => 1,        'pro' => 10,    'cnt' => 10, 'skin' => 0   ],
        1   => [ 'propsId' => 19,    'num' => 1,        'pro' => 100,   'cnt' => 0,  'skin' => 342 ],
        2   => [ 'propsId' => 15,    'num' => 500,      'pro' => 120,   'cnt' => 0 , 'skin' => 0   ],
        3   => [ 'propsId' => 61,    'num' => 1,        'pro' => 40,    'cnt' => 6,  'skin' => 0   ],
        4   => [ 'propsId' => 19,    'num' => 1,        'pro' => 40,    'cnt' => 8,  'skin' => 338 ],
        5   => [ 'propsId' => 9,     'num' => 1,        'pro' => 150,   'cnt' => 0,  'skin' => 0   ],
        6   => [ 'propsId' => 15,    'num' => 1500,     'pro' => 60,    'cnt' => 4,  'skin' => 0   ],
        7   => [ 'propsId' => 19,    'num' => 1,        'pro' => 80,    'cnt' => 3,  'skin' => 336 ],
        8   => [ 'propsId' => 15,    'num' => 1000,     'pro' => 80,    'cnt' => 2,  'skin' => 0   ],
        9   => [ 'propsId' => 23,    'num' => 1,        'pro' => 70,    'cnt' => 4,  'skin' => 60  ],
        10  => [ 'propsId' => 19,    'num' => 1,        'pro' => 100,   'cnt' => 0,  'skin' => 339 ],
        11  => [ 'propsId' => 8,     'num' => 100000,   'pro' => 150,   'cnt' => 0,  'skin' => 0   ],
    ];
    public $taskRewards = [
        1   => [ 'propsId' => 15,    'num' => 10,    'finishedCnt' => 10,], // 分享
        2   => [ 'propsId' => 15,    'num' => 50,    'finishedCnt' => 1,],  // 登录
        3   => [ 'propsId' => 15,    'num' => 500,   'finishedCnt' => 5,],  // 邀请注册
        4   => [ 'propsId' => 15,    'num' => 500,   'finishedCnt' => 5,],  // 完成支付
    ];

    static function sendRewardToEmail($msgId, $uid, array $rewards, $days = 7){
        $tb = otable::userSysMail($uid);
        $key = okeys::sysMsgGet($uid);
        $rewardNew = [];
        foreach ($rewards as $v){
            $v['skin'] = $v['skin'] ?? 0;
            $v['propsId'] = $v['propsId'] ?? 0;
            $v['num'] = $v['num'] ?? 0;
            //go fox 结构体
            $one = [
                "propsId"=>$v['propsId'],
                "num"=>$v['num'],
                "jokerCardExpireTime"=>0,
                "cards"=>null,
                "chestProps"=>null,
                "skinResourceId"=>0,
                "skin"=>intval($v['skin']),
            ];
            if($v["propsId"]==19){
                $one["skin"] = $v['skin'];
                $one["skinResourceId"] = $one["skin"];
            }
            array_push($rewardNew,$one);
        }
        $data = [
            "uid"=>$uid,
            "msgid"=>$msgId,
            "got"=>0,
            "rewards"=>json_encode($rewardNew),
            "expire" => time() + 86400 * $days,
            "create_time"=>time(),
        ];
        $sql = funs::db_insertSQL($tb,$data);
        $ret = oo::commonOprDb('games')->query($sql,1);
        if($ret){
            $eid = oo::commonOprDb('games')->insertID();
            $data['id'] = $eid;
            $data['rewards'] = json_decode($data['rewards'],true);
            $field = "{$msgId}_{$eid}";
            if (oo::commonOprRedis('games')->exists($key)){
                oo::commonOprRedis('games')->hSet($key,$field,json_encode($data));
                oo::commonOprRedis('games')->expireAt($key,time()+86400*16);
            }
        }else{
            return false;
        }
        return true;
    }
    static function isSubmitPaint($uid){
        $voteTbl = otable::paintVotes();
        $sql = "select * from {$voteTbl} where uid='{$uid}' ";
        $voteRecord = oo::commonOprDb('report')->getOne($sql,1);
        return $voteRecord ? true : false;
    }
    static function savePaint($file, $post){
        $voteTbl = otable::paintVotes();
        $insertData = [
            'uid' => $post['uid'],
            'img' => $file['url'],
        ];
        $sql = funs::db_intsertArrSQL($voteTbl, [$insertData]);
        $res = oo::commonOprDb('report')->query($sql);
        $rewards = [
            [
                'propsId' => 15,
                'num' => 100,
            ]
        ];
        self::sendRewardToEmail(632, $post['uid'], $rewards);
        return $res;
    }

    static function voteList($offset = 0, $uid = '', $pageLimit = 12){
        $pageLimit = $pageLimit - ($offset % 3);
        $voteTbl = otable::paintVotes();
        $where = ' where  1 ';
        if(!empty($uid))$where .= " and uid like '%{$uid}%'";
        $limit = " limit {$offset}, {$pageLimit}";
        $sql = "select * from  {$voteTbl} {$where} order by votes desc {$limit}  ";
        $list = oo::commonOprDb('report')->getAll($sql, 1);
        foreach ($list as $k => $v){
            $list[$k]['rank'] = ++$offset;
        }
        return $list ;
    }
    static function vote($uid, $touid){
        $sharedVotes = 1;
        $sharedMax = 10;
        $normalVoteMax = 5;
        $time = time();
        $date = date('Y-m-d', $time);
        $voteNumkey = okeys::paintVoteUidNums($uid, $date);
        $sharedNumkey = okeys::paintVoteUidSharedNum($uid, $date);
        $voteRecordKey = okeys::paintVoteUserRecord($uid, $date);
        $sharedNum = intval(oo::commonOprRedis('statistics')->get($sharedNumkey));
        $sharedNum = min($sharedNum , $sharedMax);
        $voteMax = $sharedNum * $sharedVotes + $normalVoteMax;
        $voteNum = intval(oo::commonOprRedis('statistics')->get($voteNumkey));
        if($voteNum >= $voteMax)return '投票次数已用完';
        $voteNum = oo::commonOprRedis('statistics')->incr($voteNumkey);
        $voteRecord = [
            'time' => $time,
            'touid' => $touid,
        ];
        oo::commonOprRedis('statistics')->hSet($voteRecordKey, $voteNum, json_encode($voteRecord));

        $voteTbl = otable::paintVotes();
        $sql = "update {$voteTbl} set votes=votes+1 where uid='{$touid}' ";
        $res = oo::commonOprDb('report')->query($sql, 1);
        return $res ? true : '投票失败';
    }
    static function getVoteData($uid, $date){
        $sharedVotes = 1;
        $normalVoteMax = 5;
        $sharedMax = 10;
        $voteNumkey = okeys::paintVoteUidNums($uid, $date);
        $sharedNumkey = okeys::paintVoteUidSharedNum($uid, $date);

        $sharedNum = intval(oo::commonOprRedis('statistics')->get($sharedNumkey));
        $voteMax = min($sharedNum , $sharedMax) * $sharedVotes + $normalVoteMax;
        $voteNum = intval(oo::commonOprRedis('statistics')->get($voteNumkey));
        return [
            'voteNum' => $voteNum,
            'voteMax' => $voteMax,
            'sharedNum' => $sharedNum,
            'sharedMax' => $sharedMax,
        ];
    }

    static function christmasCardDetail($cardId){
        $table = otable::christmasCards();
        $where = " where id = {$cardId}";
        $sql = "select * from  {$table} {$where}    ";
        $list = oo::commonOprDb('report')->getOne($sql, 1);
        return $list ;
    }
    static function christmasCards($uid = ''){
        $voteTbl = otable::christmasCards();
        $where = "where uid = '{$uid}'";
        $sql = "select * from  {$voteTbl} {$where}  ";
        $list = oo::commonOprDb('report')->getAll($sql, 1);
        return $list ;
    }
    static function christmasInviteNum($uid = ''){
        $inviteTbl = otable::inviteSuc();
        $timebegin = strtotime('2023-05-12');
        $where = "where is_senduid = '{$uid}' and is_time > $timebegin";
        $sql = "select * from  {$inviteTbl} {$where}  ";
        $list = oo::commonOprDb('report')->getAll($sql, 1);
        return count($list) ;
    }
    static function getInviteReward($uid , $inviteNum){
        $inviteRewards = [
            1  => 200,
            2  => 400,
            3  => 600,
            4  => 800,
            5  => 1000,
            10 => 2000,
        ];
        if(empty($inviteRewards[$inviteNum]))return -3;// 非法操作
        $sucInviteNum = self::christmasInviteNum($uid);
        if($sucInviteNum < $inviteNum){
            return -1;// 邀请人数不够
        }
        $key = okeys::christmasInviteReward($uid);
        $inviteStatus = oo::commonOprRedis('statistics')->sContains($key, $inviteNum);
        if($inviteStatus){
            return -2;  // 已领奖
        }
        oo::commonOprRedis('statistics')->sadd($key, $inviteNum);
        oo::commonOprRedis('statistics')->expireAt($key, strtotime('2023-07-07'));
        $rewards = [
            [
                'propsId' => 15,
                'num' => $inviteRewards[$inviteNum],
            ]
        ];
        self::sendRewardToEmail(684, $uid, $rewards);
        return 0 ;
    }
    static function saveCard($cardData){
        $cardData = [
            'uid' => $cardData['uid'],
            'to' => $cardData['to'],
            'from' => $cardData['from'],
            'content' => $cardData['content'],
            'bgid' => $cardData['bgid'],
        ];
        $table = otable::christmasCards();
        $sql = funs::db_intsertArrSQL($table, [$cardData]);
        $res = oo::commonOprDb('report')->query($sql);
        return $res ? oo::commonOprDb('report')->insertID() : 0;
    }
    static function sharePage($uid){
        $date = date('Ymd');
        $shareTimesKey = okeys::christmasShareTimes();
        $shareTimes = intval(oo::commonOprRedis('statistics')->hIncrBy($shareTimesKey, "{$uid}_{$date}" , 1));
        if($shareTimes == 1){   //第一次分享 获得体力奖励
            $rewards = [
                [
                    'propsId' => 15,
                    'num' => 50,
                ],
            ];
            self::sendRewardToEmail(683, $uid, $rewards);
        }
        return $shareTimes;
    }

    static function getUserAnnualReport($uid){
        $annualReportTable = otable::annual_report();
        $userinfoTable = otable::userinfo();
        $userinfo = oo::commonOprDb('slavedb')->getOne("select * from {$userinfoTable} where uid='{$uid}'");
        $userinfo = [
            'uid' => $userinfo['uid'],
            'nick' => $userinfo['nick'],
            'createtime' => $userinfo['createtime'],
            'avatar' => $userinfo['s_picture'],
        ];
        $report = oo::commonOprDb('report')->getOne("select * from {$annualReportTable} where uid='{$uid}'");
        $report = array_merge($userinfo, (array)$report);
        return $report;
    }

    static function init214($uid){
        $data = [];
        $userTable = otable::userinfo();
        if(!empty($uid)){
            $sql = "select * from {$userTable} where uid='{$uid}' limit 1";
            $row = oo::commonOprDb('slavedb')->getOne($sql,1);
            $data['userinfo'] = $row;
        }
        $data['rankList'] = self::load214rank(0);

        return $data;
    }
    static function load214rank($offset){
        $data = [];
        $userTable = otable::userinfo();
        $scoreTable = otable::loverScores();
        $ranksUsers = oo::commonOprDb('report')->getAll("select uid, total_score from {$scoreTable} where uid > 0 order by total_score desc,updated_at asc limit {$offset}, 10",1);
        if(!empty($ranksUsers)){
            $ranksUids = array_column($ranksUsers, 'uid');
            $ranksUidsStr = implode(',', $ranksUids);
            $userList = oo::commonOprDb('slavedb')->getAll("select * from {$userTable} where uid in ({$ranksUidsStr})",1);
            $userList = array_column($userList, null,'uid');
            foreach ($ranksUsers as $k => $rankItem){
                $rank = $k + 1 + $offset;
                $rewardIdx = 6;
                if($rank <= 10)$rewardIdx = 5;
                if($rank <=  7)$rewardIdx = 4;
                if($rank <=  3)$rewardIdx = 3;
                if($rank <=  2)$rewardIdx = 2;
                if($rank <=  1)$rewardIdx = 1;
                $ranksUsers[$k] = [
                    'rank' => $rank,
                    'avatar' => $userList[$rankItem['uid']]['s_picture'] ?? '',//'/214/images/排行榜.png',
                    'nickname' => $userList[$rankItem['uid']]['nick'] ?? '',
                    'score' => intval($rankItem['total_score']),
                    'reward' => "/214/images/reward{$rewardIdx}.png",
                ];
            }
            $data = $ranksUsers;
        }

        return $data;
    }

    static function share($uid){
        $dailyShareTimes = 10;
        $date = date('Ymd', CURRENT_TIMESTAMP);
        $key = okeys::config214($uid, $date);
        $sharedNum = oo::commonOprRedis('games')->hIncrBy($key, 'share', 1);
        oo::commonOprRedis('games')->expireAt($key,CURRENT_TIMESTAMP + 86400);
        if($sharedNum <=$dailyShareTimes){  //当前分享次数小于最大次数 增加积分
            $score = 1;
            $scoreTable = otable::loverScores();
            $sql = "select * from {$scoreTable} where uid='{$uid}' limit 1";
            $row = oo::commonOprDb('report')->getOne($sql,1);
            self::checkRewardScore($uid,$row, $score);
            if(empty($row)){
                $sql = "insert into {$scoreTable} (`uid`, `share_score`, `total_score`) values ({$uid}, {$score}, {$score})";
            }else{
                $sql = "update {$scoreTable} set share_score=`share_score`+{$score}, total_score=`total_score`+{$score} where uid={$uid}";
            }
        oo::commonOprDb('report')->query($sql);
        }
        if($sharedNum == $dailyShareTimes){   // 分享到最大次数时，发奖  50 体力
            $rewards = [
                [
                    'propsId' => 15,
                    'num' => 50,
                ]
            ];
            self::sendRewardToEmail(654, $uid, $rewards);
        }
        return true;
    }
    static function updateUser214Score($uid, $score){
        $userGameInfo = self::user214Info($uid);
        if($userGameInfo['currentTimes'] < 0)return;
        $date = date('Ymd', CURRENT_TIMESTAMP);
        $key = okeys::config214($uid, $date);
        oo::commonOprRedis('games')->hIncrBy($key, 'usedTimes', 1); //增加一次使用的游戏次数
        oo::commonOprRedis('games')->expireAt($key,CURRENT_TIMESTAMP + 86400);
        $scoreTable = otable::loverScores();
        $sql = "select * from {$scoreTable} where uid='{$uid}' limit 1";
        $row = oo::commonOprDb('report')->getOne($sql,1);
        self::checkRewardScore($uid,$row, $score);
        if(empty($row)){
            $sql = "insert into {$scoreTable} (`uid`, `score`, `total_score`) values ({$uid}, {$score}, {$score})";
        }else{
            $sql = "update {$scoreTable} set score=`score`+{$score}, total_score=`total_score`+{$score} where uid={$uid}";
        }
        oo::commonOprDb('report')->query($sql);
    }

    //积分超过50 奖励100 体力 一个头像框
    static function checkRewardScore($uid, $row, $score){
        $oldScore = intval($row['total_score']);
        $newScore = $oldScore + $score;
        if($oldScore < 50 && $newScore >= 50){
            $rewards = [
                [
                    'propsId' => 15,
                    'num' => 100,
                ],
                [
                    "num" =>1,
                    "propsId" =>23,
                    "skin" =>21
                ]
            ];
            self::sendRewardToEmail(653, $uid, $rewards);
        }
    }
    static function user214Info($uid): array
    {
        $dailyGameTimes = 5;
        $dailyShareTimes = 10;
        $share2gameRate = 2;

        //游戏次数
        $date = date('Ymd', CURRENT_TIMESTAMP);
        $key = okeys::config214($uid, $date);
        $info = oo::commonOprRedis('games')->hGetAll($key);
        $shareTimes = min(intval($info['share']), $dailyShareTimes);          //计算分享游戏次数不能超过10次
        $info['currentShareTimes'] = intval($info['share']);    //分享获得的游戏次数
        $info['shareGameTimes'] = floor($shareTimes/$share2gameRate);    //分享获得的游戏次数
        $info['totalTimes'] = $dailyGameTimes + $info['shareGameTimes'];      //今天总的游戏次数
        $info['currentTimes'] = max( $info['totalTimes'] - $info['usedTimes'],  0);      //今天剩余游戏次数

        // 积分信息
        $scoreTable = otable::loverScores();
        $sql = "select * from {$scoreTable} where uid='{$uid}' and uid > 0 limit 1";
        $info['scoreInfo'] = oo::commonOprDb('report')->getOne($sql,1);

        return $info;
    }

    static function userEasterInfo($uid){
        $maxShareTimes = 3;
        $date = date('Ymd',CURRENT_TIMESTAMP);
        $userDataKey = okeys::fansActKey("USER_DATA:{$uid}:{$date}");
        $userData = oo::commonOprRedis('games')->hGetAll($userDataKey);
        $userData = [
            'errorTimes' => $userData['errorTimes'] ?? 0, // 错误次数
            'rightTimes' => $userData['rightTimes'] ?? 0, // 正确次数
            'shareTimes'  => $userData['shareTimes'] ?? 0,  // 分享次数
        ];
        $userData['answerTimes'] = $userData['errorTimes'] + $userData['rightTimes'];
        $userData['shareTimes'] = min($maxShareTimes, $userData['shareTimes']);
        $userData['answerTimesMax'] = 1 + $userData['shareTimes'] ;
        $userData['restartTimesMax'] = max($userData['shareTimes']-$userData['answerTimes'], 0) ;
        return $userData;
    }

    static function setInviterRecord($uid, $inviterUid){
        $table = otable::easterInviterRecord();
        $rewardTable = otable::easterRewards();
        $inviteRecord = [
            'uid' => $uid,
            'inviter' => $inviterUid,
        ];

        // 新增邀请记录
        $sql = funs::db_insertSQL($table, $inviteRecord);
        oo::commonOprDb('report')->query($sql,1);
        $inviter_relation_id = oo::commonOprDb('report')->insertID();

        // 查新邀请人的 是否有未解锁建了个i
        $lastUnlockReward = oo::commonOprDb('report')->getOne("select * from {$rewardTable} where uid='{$inviterUid}' and status=0  limit 1 ",1);
        if(!empty($lastUnlockReward)){// 解锁
            $update = [
                'status' => 1,
                'inviter_relation_id' => $inviter_relation_id,
            ];
            $sql = funs::db_updateSQL($rewardTable, $update, ' id='.$lastUnlockReward['id']);
            oo::commonOprDb('report')->query($sql,1);

            $update = [
                'rewardId' => $lastUnlockReward['id'],
            ];
            $sql = funs::db_updateSQL($table, $update, ' id='.$inviter_relation_id);
            oo::commonOprDb('report')->query($sql,1);
        }
        return true;
    }

    // 选择奖励
    static function chooseEasterReward($uid, $rewardType){
        $rewardTable = otable::easterRewards();
        $reward = [
            'uid' => $uid,
        ];
        if($rewardType == 1){   // 普通奖励
            $reward['reward'] = 50;
            $reward['status'] = 1;
        }else{                  // 邀请奖励
            $reward['reward'] = 500;
            $reward['status'] = 0;
        }

        // 新增奖励记录
        $sql = funs::db_insertSQL($rewardTable, $reward);
        oo::commonOprDb('report')->query($sql,1);

        return true;
    }

    // 奖励记录
    static function rewardsRecord($uid):array{
        $rewardTable = otable::easterRewards();

        $sql = "select * from {$rewardTable} where uid='{$uid}' ";
        return oo::commonOprDb('report')->getAll($sql,1);
    }
    static function collectReward($uid, $id):bool{
        $msgId = 0;
        $rewardTable = otable::easterRewards();

        $sql = "select * from {$rewardTable} where uid='{$uid}' and id={$id} and status=1";
        $record = oo::commonOprDb('report')->getOne($sql,1);
        if(empty($record)){
            return false;
        }
        switch ($record['reward']){
            case 50:$msgId = 677;break;//50
            case 500:$msgId = 678;break;//500
            default:return false;
        }
        $rewards = [
            [
                "propsId" => 15,
                "num" => $record['reward'],
                "skin" => 0
            ]
        ];
        self::sendRewardToEmail($msgId, $uid, $rewards);
        oo::commonOprDb('report')->getOne("update {$rewardTable} set status=2 where  id={$id}",1);
        return true;
    }

    // 用户邀请数据 更新活动数据
    static function updateUserInviteInfo($inviteInfo){
        // 情人节活动积分
        $scoreTable = otable::loverScores();
        foreach ($inviteInfo as $uid => $inviteNum){
            $score = $inviteNum * 10;
            $sql = "select * from {$scoreTable} where uid='{$uid}' limit 1";
            $row = oo::commonOprDb('report')->getOne($sql,1);
            if(empty($row)){
                oo::commonOprDb('report')->query("insert into {$scoreTable} (`uid`, `score`, `total_score`) values ({$uid}, {$score})");
            }else{
                oo::commonOprDb('report')->query("update {$scoreTable} set invite_score=`invite_score`+{$score}, total_score=`total_score`+{$score} where uid={$uid}");
            }
        }
    }

    // 设置最早登陆时间
    static function setFirstLogin($uid){
        $key = okeys::fansActKey('FIRST_LOGIN');
        $loginTime = oo::commonOprRedis('games')->hGet($key, $uid);
        if(!$loginTime)oo::commonOprRedis('games')->hSet($key, $uid, CURRENT_TIMESTAMP);

    }

    // 用户每日体力消耗
    public static function getUserDailySpinsUsed($uid){
        $date = date('Ymd',CURRENT_TIMESTAMP);
        $rkey = okeys::userDayData($date, $uid);
        $hkey = 'cost_spin';
        return oo::commonOprRedis('statistics')->hGet($rkey, $hkey);
    }

    // 用户支付数据[cnt => 0, money=>0] 订单数，总金额
    public static function getUserPayments($uid, $begin, $end){
        $begin = date('Y-m-d', $begin);
        $end   = date('Y-m-d', $end);
        $orderTable = otable::gameOrder();
        $sql = "select * from {$orderTable} where uid={$uid} and created_at >= '{$begin}' and created_at < '{$end}' and status = 4";
        $payments = oo::commonOprDb('slavedb')->getAll($sql);
        $paymentMoneys = array_map(function($v){return $v['price'];}, $payments);
        return [
            'cnt' => count($payments),
            'money' =>  array_sum($paymentMoneys)
        ];
    }

    // 用户邀请数
    public static function getUserInvite($uid, $begin, $end){
        $inviteTable = otable::inviteSuc();
        $sql = "select count(1) as cnt from {$inviteTable} where is_senduid={$uid} and is_time >= {$begin} and is_time < {$end}";
        $inviteTotal = oo::commonOprDb('slavedb')->getOne($sql);
        return empty($inviteTotal['cnt']) ? 0 : intval($inviteTotal['cnt']);
    }

    // 最后登陆时间
    public static function lastLoginTime($uid){
        return oo::commonOprRedis('games')->get(okeys::lastLoginTime($uid));
    }

    // 转盘数据
    public function initWheelData($params){
        $uid = intval($params['uid']);
        if(!$uid)throw new Exception('Wrong operation！',__LINE__);
        $wheelMax = 2;
        $maxShareTimes = 10;
        $preWheelSpins = 10000;
        $date = date('Ymd',CURRENT_TIMESTAMP);

        // 最后登陆时间
        $todayBegin = strtotime($date);
        $lastLoginTime = oo::commonOprRedis('games')->get(okeys::lastLoginTime($uid));
        $todayLogin = $lastLoginTime >= $todayBegin;

        // 查询邀请注册人数
        $inviteNum = $this->getUserInvite($uid, $todayBegin, $todayBegin + 86400);

        // 支付次数
        $paymentTotal = $this->getUserPayments($uid, $todayBegin, $todayBegin + 86400);

        // 每日体力消耗
        $spinsUsed = $this->getUserDailySpinsUsed($uid);

        // 组装返回数据
        $userDataKey = okeys::fansActKey("USER_DATA:{$uid}:{$date}");   // 每日数据
        $userRecordsKey = okeys::fansActKey("USER_RECORDS:{$uid}");     // 已转到的奖励
        $userData = oo::commonOprRedis('games')->hGetAll($userDataKey);
        $userData['wheelRewards'] = oo::commonOprRedis('games')->get($userRecordsKey);
        $userData['shareTimes']   =  $userData['shareTimes'] ?? 0;
        $userData['wheelTimes']   =  $userData['wheelTimes'] ?? 0;
        $userData['wheelRewards'] =  $userData['wheelRewards'] ? explode(',', $userData['wheelRewards']) : [] ?? 0;
        foreach ($this->taskRewards as $idx => $reward){
            $userData["taskRewarded{$idx}"] = $userData["taskRewarded{$idx}"] ?? 0 ;  // 任务领奖次数
        }

        $userData["taskFinished1"] = min($userData['shareTimes'], $maxShareTimes) ;  // 分享完成次数
        $userData["taskFinished2"] = $todayLogin ? 1 : 0 ;  // 登录完成
        $userData["taskFinished3"] = $inviteNum ;  // 邀请注册完成
        $userData["taskFinished4"] = intval($paymentTotal['cnt']) ; // 支付完成
        $userData["spinsUsed"] = intval($spinsUsed) ; // 每日体力消耗
        $userData["wheelTotal"] = min($wheelMax, intval(floor($spinsUsed/$preWheelSpins))) ; // 转盘总次数
        $userData["wheelLeft"] = max($userData["wheelTotal"]-$userData["wheelTimes"], 0) ; // 转盘剩余次数
        $userData["dataKey"] = $userDataKey ; // 转盘剩余次数

        return $userData;
    }

    // 转动转盘
    public function doWheel($params){
        $uid = intval($params['uid']);
        if(!$uid)throw new Exception('Wrong operation！',__LINE__);
        $date = date('Ymd',CURRENT_TIMESTAMP);
        $preWheelSpins = 10000;
        $spinsUsed = $this->getUserDailySpinsUsed($uid);
        $userDataKey = okeys::fansActKey("USER_DATA:{$uid}:{$date}");
        $userData = oo::commonOprRedis('games')->hGetAll($userDataKey);
        $wheelTimes = intval($userData['wheelTimes']);


        $userRecordsKey = okeys::fansActKey("USER_RECORDS:{$uid}");
        $wheelRewards = oo::commonOprRedis('games')->get($userRecordsKey);
        $wheelRewards = $wheelRewards ? explode(',', $wheelRewards) : []; // 已转到的奖励
        $wheelTotal = min(floor($spinsUsed/$preWheelSpins), 2);
        if($wheelTotal <= $wheelTimes)throw new Exception('Wrong operation！',__LINE__);
        oo::commonOprRedis('games')->hIncrBy($userDataKey, 'wheelTimes', 1);// 旋转次数+1
        $rewards = [];
        $totalProb = 0;
        $wheelTimesTotal = count($wheelRewards);
        foreach ($this->wheelRewards as $idx => $reward){
            if ($reward['cnt'] <= $wheelTimesTotal && !in_array($idx, $wheelRewards)){ // 达到旋转次数且未转到过
                $reward['idx'] = $idx;
                $rewards[] = $reward;
                $totalProb += $reward['pro'];
            }
        }
        $rand = rand(0, $totalProb);
        $prizeIdx = -1;
        foreach ($rewards as $reward){
            $prizeIdx = $reward['idx'];
            $pro = $reward['pro'];
            if($rand <= $pro){
                break;
            }
            $rand-=$pro;
        }
        if(empty($this->wheelRewards[$prizeIdx])){
            oo::commonOprRedis('games')->hIncrBy($userDataKey, 'wheelTimes', -1);// 旋转次数+1
            throw new Exception('Wrong operation！'.$prizeIdx,__LINE__);
        }
        $wheelRewards[] = $prizeIdx;

        oo::commonOprRedis('games')->set($userRecordsKey, implode(',', $wheelRewards));
        oo::commonOprRedis('games')->expire($userDataKey, 86400 * 15);
        oo::commonOprRedis('games')->expire($userRecordsKey, 86400 * 15);
        $rewards = [
            [
                'propsId' => $this->wheelRewards[$prizeIdx]['propsId'],
                'num' =>     $this->wheelRewards[$prizeIdx]['num'],
                'skin' =>    $this->wheelRewards[$prizeIdx]['skin'],
            ]
        ];
        self::sendRewardToEmail(691, $uid, $rewards, 7);
        return ['idx' => $prizeIdx];
    }

    // 日常任务领奖
    public function getDailyTaskReward($params){
        $uid = intval($params['uid']);
        $taskId = intval($params['taskId']);
        if(!$uid)throw new Exception('Wrong operation！',__LINE__);
        if(empty($this->taskRewards[$taskId]))throw new Exception('Wrong operation！',__LINE__);

        $date = date('Ymd',CURRENT_TIMESTAMP);
        $userDataKey = okeys::fansActKey("USER_DATA:{$uid}:{$date}");
        $userData = $this->initWheelData($params);
        if($userData["taskFinished{$taskId}"] <= $userData["taskRewarded{$taskId}"])throw new Exception('Wrong operation！',__LINE__);
        oo::commonOprRedis('games')->hIncrBy($userDataKey, "taskRewarded{$taskId}", 1); // 领奖数+1
        $rewards = [
            [
                'propsId' => $this->taskRewards[$taskId]['propsId'],
                'num' =>     $this->taskRewards[$taskId]['num'],
            ]
        ];
        self::sendRewardToEmail(690, $uid, $rewards, 7);
        return [];
    }

    // 分享页面
    public function shareWheel($params){
        $uid = intval($params['uid']);
        if(!$uid)throw new Exception('Wrong operation！',__LINE__);

        $date = date('Ymd',CURRENT_TIMESTAMP);
        $userDataKey = okeys::fansActKey("USER_DATA:{$uid}:{$date}");
        oo::commonOprRedis('games')->hIncrBy($userDataKey, "shareTimes", 1); // 分享数+1
        return [];
    }


    private static function getActMod($mod):InviteActMod{
        if(!class_exists($mod))throw new Exception('Wrong operation！',__LINE__);
        return new $mod;
    }

    public static function runInviteAction($mod, $act, $params){
        return self::getActMod($mod)->run($act, $params);
    }

}
interface InviteActMod{
    static function run($act, $params);
}

Class HalloweenPuzzle implements InviteActMod {
    public static $actKey = 'HalloweenPuzzle';
    static $puzzleRewards = [
        1 => [
            'target' =>  9,
            'reward' =>  [
                [ 'propsId' => 19, 'num' => 1, 'skin' => 470 ],
            ],
        ],
        2 => [
            'target' =>  9,
            'reward' =>  [
               [ 'propsId' => 13, 'num' => 1, 'skin' => 0   ],
            ],
        ],
        3 => [
            'target' =>  9,
            'reward' =>  [
               [ 'propsId' => 18, 'num' => 1, 'skin' => 0   ],
            ],
        ],
    ];
    public static $tasks = [
        1 => [
            'type' => 'costSpins',
            'target' =>  1000,
            'reward' =>  [
                [
                    'propsId' => 15,
                    'num' =>     100,
                ]
            ],
        ],
        2 => [
            'type' => 'costSpins',
            'target' =>  5000,
            'reward' =>  [
                [
                    'propsId' => 15,
                    'num' =>     200,
                ]
            ],
        ],
        3 => [
            'type' => 'costSpins',
            'target' =>  10000,
            'reward' =>  [
                [
                    'propsId' => 15,
                    'num' =>     500,
                ]
            ],
        ],
        4 => [
            'type' => 'sharePage',
            'target' =>  5,
            'reward' =>  [
                [
                    'propsId' => 15,
                    'num' =>     50,
                ]
            ],
        ],
        5 => [
            'type' => 'invite',
            'target' =>  1,
            'reward' =>  [
                [
                    'propsId' => 15,
                    'num' =>     200,
                ]
            ],
        ],
    ];
    static $totalField = [
        'puzzleStage',  // 拼图阶段
        'puzzleNum',    // 拼图数量
    ];

    static $dailyField = [
        'shareNum',
        'taskRewardStatus',
    ];

    // 用户活动数据
    public static function index($uid): array
    {
        $date = date('Ymd',CURRENT_TIMESTAMP);
        $todayBegin = strtotime($date);

        $spinUsed = intval(SvenModel::getUserDailySpinsUsed($uid));

        $inviteNum = SvenModel::getUserInvite($uid, $todayBegin, $todayBegin + 86400);

        $userDailyData = oo::commonOprRedis('games')->hGetAll(okeys::fansActKey(self::$actKey)."_{$uid}_{$date}");

        $userTotalData = oo::commonOprRedis('games')->hGetAll(okeys::fansActKey(self::$actKey)."_{$uid}");

        // 每日任务状态
        foreach (self::$tasks as $k => $task){
            $validNum = 0;
            switch ($task['type']){
                case 'costSpins': $validNum = $spinUsed;break;
                case 'sharePage': $validNum = intval($userDailyData['shareNum']);break;
                case 'invite':    $validNum = $inviteNum;break;
            }
            if($validNum >= $task['target'])$status = 1;
            else    $status = 0;
            $userDailyData["taskNum_{$k}"] = min($validNum, $task['target']);
            if( empty($userDailyData["taskStatus_{$k}"]) )$userDailyData["taskStatus_{$k}"] = $status;
        }
        foreach (self::$totalField as $field){
            if(empty($userTotalData[$field]))
                $userTotalData[$field] = 0;
        }

        // 拼图状态
        $needPuzzleNum = 0;
        $leftPuzzleNum = $userTotalData['puzzleNum'];
        foreach (self::$puzzleRewards as $k => $puzzleItem){
            $needPuzzleNum += $puzzleItem['target'];
            if($userTotalData['puzzleNum'] >= $needPuzzleNum) $status = 1;
            else $status = 0;
            if( empty($userTotalData["puzzleStatus_{$k}"]) )$userTotalData["puzzleStatus_{$k}"] = $status;

            $userTotalData['puzzleStage'] = $k;
            $userTotalData['openPieces'] = min($leftPuzzleNum, $puzzleItem['target']);
            // 未领奖
            if($userTotalData["puzzleStatus_{$k}"] < 2){
                break;
            }else{
                $leftPuzzleNum -= $puzzleItem['target'];
            }

        }

        return [
            'dailyData' => $userDailyData,
            'totalData' => $userTotalData,
        ];
    }

    public static function sharePage($uid): array
    {
        $date = date('Ymd',CURRENT_TIMESTAMP);
        oo::commonOprRedis('games')->hIncrBy(okeys::fansActKey(self::$actKey)."_{$uid}_{$date}", 'shareNum', 1);
        return self::index($uid);
    }

    /**
     * @throws Exception
     */
    public static function getDailyReward($uid, $taskId): array
    {
        if( empty(self::$tasks[$taskId]['reward']) )throw new Exception('Wrong operation！',__LINE__ );
        $date = date('Ymd',CURRENT_TIMESTAMP);
        $userData = self::index($uid);

        // 任务状态不是可领奖 抛出异常
        if($userData['dailyData']["taskStatus_{$taskId}"] != 1)throw new Exception('Wrong operation！',__LINE__ );

        // 领奖, 设置已领奖
        oo::commonOprRedis('games')->hSet(okeys::fansActKey(self::$actKey)."_{$uid}_{$date}", "taskStatus_{$taskId}", 2);

        // 发奖 拼图碎片+1
        oo::commonOprRedis('games')->hIncrBy(okeys::fansActKey(self::$actKey)."_{$uid}", 'puzzleNum', 1);

        // 游戏内奖励发邮件
        SvenModel::sendRewardToEmail(701, $uid, self::$tasks[$taskId]['reward']);

        oo::commonOprRedis('games')->hIncrBy(okeys::fansActKey(self::$actKey), "taskReward_{$taskId}", 1);

        return self::index($uid);
    }

    /**
     * @throws Exception
     */
    public static function getPuzzleReward($uid, $puzzleId): array
    {
        if( empty(self::$puzzleRewards[$puzzleId]['reward']) )throw new Exception('Wrong operation！',__LINE__ );
        $date = date('Ymd',CURRENT_TIMESTAMP);
        $userData = self::index($uid);

        // 任务状态不是可领奖 抛出异常
        if($userData['totalData']["puzzleStatus_{$puzzleId}"] != 1)throw new Exception('Wrong operation！',__LINE__ );

        // 领奖, 设置已领奖
        oo::commonOprRedis('games')->hSet(okeys::fansActKey(self::$actKey)."_{$uid}", "puzzleStatus_{$puzzleId}", 2);

        SvenModel::sendRewardToEmail(702, $uid, self::$puzzleRewards[$puzzleId]['reward']);

        // 领奖数+1
        oo::commonOprRedis('games')->hIncrBy(okeys::fansActKey(self::$actKey), "puzzleReward_{$puzzleId}", 1);

        return self::index($uid);
    }

    // 入口
    public static function run($act, $params){
        $uid = intval($params['uid']);
        switch ($act){
            case 'index':
                $data = self::index($uid);break;
            case 'sharePage':
                $data = self::sharePage($uid);break;
            case 'getDailyReward':
                $data = self::getDailyReward($uid, intval($params['taskId']));break;
            case 'getPuzzleReward':
                $data = self::getPuzzleReward($uid, intval($params['puzzleId']));break;
            default:
                throw new Exception('Wrong operation！',__LINE__ );

        }
        return $data;
    }
}