<script type="text/javascript" src="<?php echo base_url(); ?>public/js/highcharts/highcharts.js"></script>
<script type="text/javascript" src="<?php echo base_url(); ?>public/js/highcharts/modules/exporting.js"></script>
<script type="text/javascript" src="<?php echo base_url(); ?>public/js/highcharts/modules/export-data.js"></script>

<div class="content_wrapper">
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>公会表情使用情况</header>
                    <section>
                        <div class="container-fluid">
                            <div class="row">
                                <button style="float: right;margin-right: 20px" type="submit" class="btn btn-danger" onclick="resetEmoUseStat()">重置公会表情使用统计</button>
                            </div>
                            <hr>
                            <div id="container" style="min-width:400px;height:400px"></div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>


<script>
    //设置图表导出格式选项
    Highcharts.setOptions({
        lang: {
            printChart: '打印图表',
            downloadJPEG: '下载 JPEG 文件',
            downloadPDF: '下载 PDF   文件',
            downloadPNG: '下载 PNG  文件',
            downloadSVG: '下载 SVG  文件',
            downloadCSV: '下载 CSV  文件',
            downloadXLS: '下载 XLS   文件',
            viewData: '查看数据表格'
        },
        navigation: {
            menuItemStyle: {
                padding: '6px 14px'
            }
        },
        exporting: {
            url: ''
        },
        credits: {
            text: '',
            url: ''
        }
    });

    var chart = Highcharts.chart('container', {
        chart: {
            type: 'column'
        },
        title: {
            text: '公会表情使用情况'
        },
        subtitle: {
            text: '累积统计数据, 重新统计需重置数据'
        },
        xAxis: {
            categories: <?php echo $emoList;?>,
            crosshair: true
        },
        yAxis: {
            min: 0,
            title: {
                text: '次数'
            }
        },
        tooltip: {
            // head + 每个 point + footer 拼接成完整的 table
            headerFormat: '<span style="font-size:10px">{point.key}</span><table>',
            pointFormat: '<tr><td style="color:{series.color};padding:0">{series.name}: </td>' +
                '<td style="padding:0"><b>{point.y} 次</b></td></tr>',
            footerFormat: '</table>',
            shared: true,
            useHTML: true
        },
        plotOptions: {
            column: {
                borderWidth: 0
            }
        },
        series: [{
            name: '表情使用次数',
            data: <?php echo $useInfo;?>
        }]
    });

    function resetEmoUseStat() {

        if (!confirm('确认要清空已累积的表情使用数据吗?')) return;
        $.ajax({
            type: "POST", // 数据提交类型
            url: "club/resetEmoUseNumSta", // 发送地址
            data: {}, //发送数据
            async: true, // 是否异步
            processData: false, //processData 默认为false，当设置为true的时候,jquery ajax 提交的时候不会序列化 data，而是直接使用data
            contentType: false, //
            success: function (data) { // 成功回调
                data = JSON.parse(data);
                alert(data.msg);

                if (Number(data.ret) === 0) {
                    window.location.reload();
                }
            }
        });
    }
</script>
