<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>用户邀请</title>
    <!-- 最新版本的 Bootstrap 核心 CSS 文件 -->
    <link rel="stylesheet" href="<?php echo base_url(); ?>public/js/bootstrap/bootstrap.min.css">

</head>

<body>
<div class="content_wrapper">
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>邀请信息查询</header>
                    <section>
                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-12">
                                    <div style="margin-bottom:20px;">
                                        <div class="form-inline" role="form">
                                            <div class="form-group">
                                                <label>被邀请人UID：</label>
                                                <input type="text" class="form-control"
                                                       value="<?php if (isset($invitee)) echo $invitee; ?>"
                                                       placeholder="被邀请人UID"
                                                       name="invitee" id="invitee"/>
                                            </div>
                                            <button onclick="searchInviteInfo('invitee')" class="btn btn-primary">查询
                                            </button>
                                        </div>
                                    </div>
                                    <div style="margin-bottom:20px;">
                                        <div class="form-inline" role="form">
                                            <div class="form-group">
                                                <label>邀请人UID：</label>
                                                <input type="text" class="form-control"
                                                       value="<?php if (isset($inviter)) echo $inviter; ?>"
                                                       placeholder="邀请人UID"
                                                       name="inviter" id="inviter"/>
                                            </div>
                                            <button onclick="searchInviteInfo('inviter')" class="btn btn-primary">查询
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                    <section>
                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="table-responsive">
                                        <table id="exchangeTable" class="table table-striped table-bordered table-hover"
                                               cellspacing="0" width="100%">
                                            <thead>
                                            <tr>
                                                <th>序号</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <tr>
                                                <td colspan="14">暂无数据</td>
                                            </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
    <div class="content_wrapper">
        <div class="container-fluid">
            <div class="row">
                <div class="col-sm-12">
                    <aside>
                        <header><i class="fa fa-fw fa-file"></i>激活邀请</header>
                        <section>
                            <div class="row">
                                <div class="col-sm-12">
                                    <form class="form-inline" id="activateInvite">
                                        <div class="form-group">
                                            <label class="col-sm-4 control-label">用户发起者UID</label>
                                            <div class="col-sm-1">
                                                <input type="text" class="form-control" placeholder="uid" name="uid" id="addUid">
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label class="col-sm-5 control-label">被邀请者UID</label>
                                            <div class="col-sm-1">
                                                <input type="text" class="form-control" placeholder="toUid" name="toUid">
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <div class=" col-sm-12">
                                                <button type="button" class="btn btn-primary" id="SubmitBtn2">确定</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </section>
                    </aside>
                </div>
            </div>
        </div>
    </div>
</div>
</body>


<script type="text/javascript">
    //当点击search按钮时按条件重新加载数据
    function searchInviteInfo(type) {
        const invitee = $('#invitee').val();
        const inviter = $('#inviter').val();

        if ((type === 'invitee' && invitee === '') || (type === 'inviter' && inviter === '')) {
            alert('请输入用户UID，再查询！');
        }

        var formData = new FormData();
        formData.append("type", type);
        formData.append("invitee", invitee);
        formData.append("inviter", inviter);

        $.ajax({
            url: rootPath + 'Customer/searchInviteData',
            type: 'POST',
            data: formData,
            dataType: 'json',
            contentType: false, //必须
            processData: false, //必须
            success: function (response) {
                var tipContent = "";
                if (type === 'invitee') {
                    tipContent += '<thead><tr><th>Index</th><th>首次安装时间</th><th>邀请人id</th><th>渠道</th><th>渠道id</th><th>操作</th></tr></thead>'
                    tipContent += '<tbody>'
                    response.data.forEach((item, index) => {
                        tipContent += '<tr>';
                        tipContent += '<td>' + (parseInt(index) + 1) + '</td><td>' + item.created_at + '</td><td>' + item.label + '</td><td>' + item.tracker_name + '</td><td>' + item.tracker_token + '</td>'
                        tipContent += '<td><button type="button" class="btn btn-success activateInvite" date-uid="' + item.label + '" date-toUid="' + invitee + '" onclick="activateInvite('+item.label+','+invitee+')">激活并发奖</button></td>'
                        tipContent += '</tr>';
                    });
                    tipContent += '</tbody>'
                } else if (type === 'inviter') {
                    tipContent += '<thead><tr><th>Index</th><th>被邀请人id</th><th>领奖时间</th><th>是否领奖</th></tr></thead>'
                    tipContent += '<tbody>'
                    response.data.forEach((item, index) => {
                        tipContent += '<tr><td>' + (parseInt(index) + 1) + '</td><td>' + item.is_backuid + '</td><td>' + item.is_time + '</td><td>' + (item.is_reward == 1 ? '是' : '否') + '</td></tr>'
                    });
                    tipContent += '</tbody>'
                }

                $("#exchangeTable").html(tipContent);
            },
            error: function (data) {
                alert(data.msg);
            }
        });

    }

    $('#SubmitBtn2').click(function(){
            var datas = $('#activateInvite').serializeArray();
            console.log(datas);
            $.post('/customer/activateInvite', datas, function(res){
                if(typeof res == 'string')res = JSON.parse(res)
                console.log(res);
                if(res.ret == 0){
                    alert("激活成功成功");
                    // var url = rootPath+"#customer/souchFriend/"+res.data.uid;
                    // window.location.href = url
                    // history.go(0)
                }else{
                    alert(res.msg);
                }
            })
        });
    function activateInvite(uid,toUid){
        // console.log("==uid:",uid,toUid)
        $.post('/customer/activateInvite', {uid:uid,toUid:toUid}, function(res){
            if(typeof res == 'string')res = JSON.parse(res)
            console.log(res);
            if(res.ret == 0){
                alert("激活成功成功");
                // var url = rootPath+"#customer/souchFriend/"+res.data.uid;
                // window.location.href = url
                // history.go(0)
            }else{
                alert(res.msg);
            }
        })
    }
</script>
