<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>修改活动</title>

    <style type="text/css">
        table {
            table-layout: fixed !important;
        }

        th {
            background: rgb(146, 208, 80);
        }

        td, th {
            max-width: 400px;
            word-wrap: break-word;
        }

        .table-hover > tbody > tr:hover {
            background-color: #c8bd6d;
        }

        #roleTable tr:nth-child(5n) {
            background: rgb(198, 239, 206);
        }

        /**隔五行*/

        .fixed-table-toolbar {
            display: none;
        }

        .fileinput-button {
            position: relative;
            top: -5px;
        }

        .fileinput-button input {
            position: absolute;
            right: 0px;
            top: 0px;
            opacity: 0;
            -ms-filter: 'alpha(opacity=0)';
        }
    </style>
</head>

<body>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>自选宝箱配置</header>
                    <section>
                        <div class="container-fluid">
                            <div class="row" style="padding-left: 15px;">
                                <button type="button" style="margin-bottom: 10px;margin-right: 10px;width: 80px;" class="btn btn-primary" id="confSubmitBtn">提交</button>
                                <span id="filespanprd" class="btn btn-success fileinput-button">
                                    <span>导入配置</span>
                                    <input style="width: 80px" type="file" id="upfileprd">
                                </span>
                                <input type="button" style="display: none;margin-bottom: 10px;width: 80px;" class="btn btn-success" value="上传" id="btnprd"/>
                                <a type="button" href="/Export/optionalChestConf" style="margin-bottom: 10px;width: 100px;" class="btn btn-success">导出配置</a>
                            </div>
                            <div class="row" style="margin-top: 10px">
                                <div class="col-sm-12">
                                    <form id="confData">
                                        <table class="table table-bordered" id="confData">
                                            <thead>
                                            <tr>
                                                <th width="120">宝箱ID</th>
                                                <th width="220">宝箱名称</th>
                                                <th width="220">宝箱皮肤</th>
                                                <th>宝箱奖励</th>
                                                <th width="100">奖励配置</th>
                                            </tr>
                                            </thead>
                                            <tbody id="ConfBody"></tbody>
                                            <tr>
                                                <td colspan="4">
                                                    <div class="text-center" style="margin-top: 20px">
                                                        <botton class="btn btn-primary addConfTrBtn" onclick="addConfTr(this)">添加</botton>
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>
</body>


<script>

    let CurTrCount = 0;

    const List =  <?php echo(json_encode($list) ?: []);?>;

    let selectOptions = ''
    $.each(<?php echo json_encode($skinList);?>, function (i, o) {
        selectOptions += `<option value="${o}">${i}</option>`
    });

    initConf()

    function initConf() {
        $("#ConfBody").empty();

        // 奖励回写
        console.log('List:', List)

        List && $.each(List, function (idx, item) {
            console.log(item.reward)
            $('.addConfTrBtn').click()
            $(`input[name="conf[${idx}][id]"]`).val(item.id)
            $(`input[name="conf[${idx}][title]"]`).val(item.title)
            $(`select[name="conf[${idx}][skin]"]`).val(item.skin)
            $('.propsRewardsTag:last').data("value", JSON.parse(item.reward))

            //
            $(`#selectpicker_${idx}`).selectpicker('val', item.skin);
        })

        propsJs.initTag('propsRewardsTag')
    }

    function addConfTr() {
        const rIdx = CurTrCount++
        const html = `
        <tr id="ConfTr_${rIdx}" data-idx="${rIdx}">
            <td width="120"><input type="text" class="form-control" name="conf[${rIdx}][id]" value="" placeholder="自动递增" readonly ></td>
            <td width="220"><input type="text" class="form-control" name="conf[${rIdx}][title]" value="" ></td>
            <td><select class="form-control" id="selectpicker_${rIdx}" name="conf[${rIdx}][skin]">
                ${selectOptions}
            </select></td>
            <td class="propsRewardsTag" data-value='[]' data-name="conf[${rIdx}][reward]"></td>
            <td>
                <button type="button"
                        class="btn btn-outline btn-success"
                        onclick="propsJs.initEdit(this, 'propsRewardsTag')">
                    奖励配置
                </button>
            </td>
        </tr>
    `;
        $('#ConfBody').append(html)
    }

    $(function () {
        // 集合间隔配置
        $('#confSubmitBtn').click(() => {
            const data = $('#confData').toObject();
            $.ajax({
                type: 'POST',
                dataType: 'json',
                data: data,
                url: 'optionalChest/updateConfig',
                success: function (data) {
                    alert(data.msg);
                    if (Number(data.ret) === 0) {
                        window.location.reload()
                    }
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

        $("#filespanprd").on("change", "input[type='file']", function() {
            var filePath = $(this).val();
            //如果仅上传图片 if(filePath.indexOf("jpg") != -1 || filePath.indexOf("png") != -1) {
            if (filePath) {
                $("#btnprd").click()
            } else {
                return false
            }
        });

        $("#btnprd").click(function(){
            var formData = new FormData();
            formData.append("file",document.getElementById("upfileprd").files[0]);
            showLoading()
            $.ajax({
                type: "POST", // 数据提交类型
                url: "Import/optionalChestConf", // 发送地址
                data: formData, //发送数据
                async: true, // 是否异步
                processData: false, //processData 默认为false，当设置为true的时候,jquery ajax 提交的时候不会序列化 data，而是直接使用data
                contentType: false, //
                success: function(data) { // 成功回调
                    hideLoading();
                    data = JSON.parse(data);
                    if(data.ret == 0){
                        window.location.reload();
                    }else {
                        alert(data.msg)
                        window.location.reload();
                    }
                },
                error:function(){
                    hideLoading();
                }
            });
        });
    });

</script>
