<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>修改活动</title>

    <style type="text/css">
        table {
            table-layout: fixed !important;
        }

        th {
            background: rgb(146, 208, 80);
        }

        td, th {
            max-width: 400px;
            word-wrap: break-word;
        }

        .table-hover > tbody > tr:hover {
            background-color: #c8bd6d;
        }

        #roleTable tr:nth-child(5n) {
            background: rgb(198, 239, 206);
        }

        /**隔五行*/

        .fixed-table-toolbar {
            display: none;
        }

        .fileinput-button {
            position: relative;
            top: -5px;
        }

        .fileinput-button input {
            position: absolute;
            right: 0px;
            top: 0px;
            opacity: 0;
            -ms-filter: 'alpha(opacity=0)';
        }
    </style>
</head>

<body>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>触发奖励配置</header>
                    <section>
                        <div class="container-fluid">
                            <div class="ibox-title" style="margin-bottom: 20px">
                                <h5 style="font-weight: bold">通用配置：</h5>
                            </div>
                        </div>

                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-12">
                                    <button type="button" class="btn btn-primary" id="commonConfSubmitBtn">提交</button>
                                </div>
                            </div>
                            <div class="row" style="margin-top: 10px">
                                <div class="col-sm-12">
                                    <form class="form-horizontal" method="post" id="commonConfForm" action="">
                                        <div class="form-group">
                                            <label class="col-sm-1 control-label m-b">活动总开关:</label>
                                            <div class="col-sm-2 input-group">
                                                <label class="checkbox-inline">
                                                    <input type="radio" name="switch" <?php if ($switch == 0) echo "checked"; ?> value="0"> 下线
                                                </label>
                                                <label class="checkbox-inline">
                                                    <input type="radio" name="switch" <?php if ($switch == 1) echo "checked"; ?> value="1"> 上线
                                                </label>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </section>
                    <section>
                        <div class="container-fluid">
                            <div class="ibox-title" style="margin-bottom: 20px">
                                <h5 style="font-weight: bold">触发集合间隔配置：</h5>
                            </div>
                        </div>

                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-12">
                                    <button type="button" class="btn btn-primary" id="setIntervalSubmitBtn">提交</button>
                                </div>
                            </div>
                            <div class="row" style="margin-top: 10px">
                                <div class="col-sm-12">
                                    <form id="setIntervalData">
                                        <table class="table table-bordered" id="setIntervalData">
                                            <thead>
                                            <tr>
                                                <th width="120">集合ID</th>
                                                <th>触发集合</th>
                                                <th width="200">触发间隔天数</th>
                                                <th width="100">操作</th>
                                            </tr>
                                            </thead>
                                            <tbody id="SetIntervalConf"></tbody>
                                            <tr>
                                                <td colspan="4">
                                                    <div class="text-center" style="margin-top: 20px">
                                                        <botton class="btn btn-primary addSetIntervalConfTrBtn" onclick="addSetIntervalConfTr(this)">添加</botton>
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </section>
                    <section>
                        <div class="container-fluid">
                            <div class="ibox-title" style="margin-bottom: 20px">
                                <h5 style="font-weight: bold">触发奖励条件配置：</h5>
                            </div>
                        </div>
                        <div class="container-fluid">
                            <div class="row">
                                <div class="col-sm-12">
                                    <button type="button" class="btn btn-success" onclick="openAddEdit(this)"
                                            data-toggle="modal"
                                            data-target="#triggerEditBtn"
                                            data-value='<?php echo json_encode(['id' => '', 'scene' => '', 'switch' => 0, 'reward' => '[]', 'condition' => '[]']); ?>'>
                                        新增触发奖励条件
                                    </button>
                                </div>
                            </div>
                            <div class="row" style="margin-top: 10px">
                                <div class="col-sm-12">
                                    <div class="table-responsive ">
                                        <table id="roleTable" class="table table-bordered table-hover"
                                               data-toggle="table"
                                               data-classes="table table-hover"
                                               data-show-columns="true"
                                               data-striped="true"

                                               data-height="700">
                                            <thead>
                                            <tr>
                                                <th style="width: 100px">触发奖励ID</th>
                                                <th>条件描述</th>
                                                <th style="width: 100px">上下线</th>
                                                <th style="width: 100px">触发场景</th>
                                                <th>触发条件</th>
                                                <th>触发奖励</th>
                                                <th style="width: 100px">操作</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <?php
                                            if (is_array($list) && !empty($list)) {
                                                foreach ($list as $key => $vl) { ?>
                                                    <tr>
                                                        <td><?php echo $vl['id']; ?></td>
                                                        <td><?php echo $vl['desc']; ?></td>
                                                        <td><?php echo $vl['switchHtml']; ?></td>
                                                        <td><?php echo $vl['sceneHtml']; ?></td>
                                                        <td><?php echo $vl['conditionHtml'];
                                                            unset($vl['switchHtml'], $vl['sceneHtml'], $vl['conditionHtml']) ?></td>
                                                        <td class="tablePropsRewardsTag" data-value='<?php echo $vl['reward'] ?? []; ?>'></td>
                                                        <td>
                                                            <button type="button" class="btn btn-primary active"
                                                                    onclick="openEdit(this)"
                                                                    data-toggle="modal"
                                                                    data-target="#triggerEditBtn"
                                                                    data-value='<?php echo json_encode($vl); ?>'>编辑
                                                            </button>
                                                        </td>
                                                    </tr>
                                                <?php }
                                            } else { ?>
                                                <tr>
                                                    <td colspan="6">暂无数据</td>
                                                </tr>
                                            <?php } ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>
</body>

<!--活动编辑弹窗-->
<div class="modal" id="triggerEditBtn" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog" style="width: 60%">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span
                            class="sr-only">Close</span></button>
                <h4 class="modal-title" id="myModalLabel">修改触发奖励配置</h4>
            </div>
            <form class="form-horizontal" method="post" id="triggerForm" action="">
                <div class="modal-body">
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发奖励ID:</label>
                        <div class="col-sm-2">
                            <input placeholder="新增时自动递增" type="number" readonly class="form-control" name="id">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">条件描述:</label>
                        <div class="col-sm-3">
                            <input placeholder="条件描述" type="text" class="form-control" name="desc">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">上下线:</label>
                        <div class="col-sm-3">
                            <label class="select-inline">
                                <select class="form-control" name="switch">
                                    <option value="0">下线</option>
                                    <option value="1">上线</option>
                                </select>
                            </label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发场景:</label>
                        <div class="col-sm-3">
                            <label class="select-inline">
                                <select class="form-control" name="scene">
                                    <?php foreach ($sceneList as $k1 => $v1) { ?>
                                        <option value="<?php echo $k1; ?>"><?php echo $v1; ?></option>
                                    <?php } ?>
                                </select>
                            </label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发条件:</label>
                        <div class="col-sm-7">

                            <table id="roleTable_1" class="table table-bordered table-hover roleTable">
                                <thead>
                                <tr>
                                    <td>条件</td>
                                    <td>关系运算符</td>
                                    <td>数值</td>
                                    <td>逻辑运算符</td>
                                </tr>
                                </thead>
                                <tbody id="conditionConf">
                                </tbody>
                                <tr>
                                    <td colspan="4">
                                        <div class="text-center" style="margin-top: 20px">
                                            <botton class="btn btn-primary addConfTr" onclick="addConfTr()">添加
                                            </botton>
                                            <botton class="btn btn-danger del-tr" onclick="delConfTr(this)">删除</botton>
                                        </div>
                                    </td>
                                </tr>
                            </table>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发奖励:</label>
                        <div class="col-sm-7">
                            <label class="select-inline">
                                <table class="col-sm-12">
                                    <tr>
                                        <td class="formPropsRewardsTag" data-value=''></td>
                                        <td class="text-right">
                                            <button type="button"
                                                    class="btn btn-outline btn-success"
                                                    onclick="propsJs.initEdit(this, 'formPropsRewardsTag')">
                                                奖励配置
                                            </button>
                                        </td>
                                    </tr>
                                </table>
                            </label>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">关闭</button>
                    <button type="button" class="btn btn-primary" id="confSubmitBtn">提交</button>
                </div>
            </form>
        </div>
    </div>
</div>

<script>
    propsJs.initTag('tablePropsRewardsTag')

    let SetIntervalTrCount = 0;

    const conditionList = <?php echo json_encode($conditionList);?>;
    const relationalList = <?php echo json_encode($relationalList);?>;
    const logicalList =  <?php echo json_encode($logicalList);?>;
    const setInterval =  <?php echo($setInterval ?: []);?>;

    let selectOptions = ''
    $.each(<?php echo json_encode($list);?>, function (i, o) {
        selectOptions += `<option value="${o.id}">${o.desc}</option>`
    });

    initSetInterval()

    function initSetInterval() {
        $("#SetIntervalConf").empty();


        // 奖励回写
        console.log('setInterval:', setInterval)
        console.log('selectOptions:', selectOptions)
        if (!setInterval) {
            return
        }

        $.each(setInterval, function (idx, item) {
            $('.addSetIntervalConfTrBtn').click()
            $(`select[name="conf[${idx}][set][]"]`).val(item.set)
            $(`input[name="conf[${idx}][interval]"]`).val(item.interval)

            $(`#selectpicker_${idx}`).selectpicker('val', item.set);
        })
    }

    function openAddEdit(even) {
        openEdit(even)
    }

    function openEdit(even) {

        let formData = $(even).data('value')
        console.log(formData)
        for (let key in formData) {
            if (formData.hasOwnProperty(key)) {
                if (key === 'condition') {
                    const condition = JSON.parse(formData[key])
                    const node = $('#conditionConf')
                    node.empty()
                    let conditionHtml = ''
                    for (let idx = 0; idx < condition.length; idx++) {
                        let item = condition[idx]
                        conditionHtml += buildConditionTr(idx, item)
                    }

                    node.append(conditionHtml)
                } else if (key === 'reward') {
                    $('.formPropsRewardsTag').data("value", JSON.parse(formData[key]))
                } else {
                    $("[name=" + key + "]").val(formData[key]);
                }
            }
        }

        propsJs.initTag('formPropsRewardsTag')
    }

    function buildConditionTr(idx, item) {

        let conditionOptionsHtml = '';
        for (const key in conditionList) {
            let val = conditionList[key]
            let sel = item['cid'] === Number(key) ? 'selected' : '';
            conditionOptionsHtml += `<option value="${key}" ${sel}>${val}</option>`;
        }

        let relationalOptionsHtml = '';
        for (const key in relationalList) {
            let val = relationalList[key]
            let sel = item['relationalOp'] === key ? 'selected' : '';
            relationalOptionsHtml += `<option value="${key}" ${sel}>${val}</option>`;
        }

        let logicalOptionsHtml = '';
        for (const key in logicalList) {
            let val = logicalList[key]
            let sel = item['logicalOp'] === key ? 'selected' : '';
            logicalOptionsHtml += `<option value="${key}" ${sel}>${val}</option>`;
        }

        return `<tr id="conditionTr_${idx}" data-idx="${idx}">
                    <td><select class="form-control" name="condition[${idx}][cid]">${conditionOptionsHtml}</select></td>
                    <td><select class="form-control" name="condition[${idx}][relationalOp]">${relationalOptionsHtml}</select></td>
                    <td><input type="number" class="form-control" name="condition[${idx}][num]" value="${item['num']}"></td>
                    <td><select class="form-control" name="condition[${idx}][logicalOp]">${logicalOptionsHtml}</select></td>
                </tr>`
    }

    function addConfTr() {
        const node = $('#conditionConf')
        let lastIdx = node.find('tr:last').data('idx')
        lastIdx = lastIdx === undefined ? 0 : parseInt(lastIdx) + 1

        const item = {cid: 0, relationalOp: '', num: 0, logicalOp: ''};

        const html = buildConditionTr(lastIdx, item)

        node.append(html)
    }

    function delConfTr() {
        const lvIdx = $('#conditionConf').find('tr:last').data('idx')
        $('#conditionTr_' + lvIdx).remove()
    }

    function addSetIntervalConfTr() {
        const rIdx = SetIntervalTrCount++
        const html = `
        <tr id="SetIntervalTr_${rIdx}" data-idx="${rIdx}">
            <td width="120"><input type="text" class="form-control" value="${rIdx + 1}" readonly ></td>
            <td><select class="form-control" id="selectpicker_${rIdx}" multiple name="conf[${rIdx}][set][]">
                ${selectOptions}
            </select></td>
            <td><input type="number" class="form-control" name="conf[${rIdx}][interval]" value="0" ></td>
            <td width="100">
                <button type="button" class="btn btn-outline btn-danger" onclick="delSetIntervalConfTr(${rIdx})">删除</button>
            </td>
        </tr>
    `;
        $('#SetIntervalConf').append(html)
        $(`#selectpicker_${rIdx}`).selectpicker();
    }

    function delSetIntervalConfTr(idx) {
        $("#SetIntervalTr_" + idx).remove();
    }

    $(function () {
        $('#confSubmitBtn').click(() => {
            const data = $('#triggerForm').toObject()
            data['reward'] = $('.formPropsRewardsTag').data('value')
            $.ajax({
                url: 'rewardTrigger/updateConfig',
                type: 'POST',
                data: data,
                dataType: 'json',
                success: function (data) {
                    window.location.reload();
                    alert(data.msg);
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

        // 通用配置
        $('#commonConfSubmitBtn').click(() => {
            const data = $('#commonConfForm').toObject()
            $.ajax({
                url: rootPath + 'rewardTrigger/updateSwitch',
                type: 'POST',
                data: data,
                dataType: 'json',
                success: function (data) {
                    window.location.reload();
                    alert(data.msg);
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

        // 集合间隔配置
        $('#setIntervalSubmitBtn').click(() => {
            const data = $('#setIntervalData').toObject();
            $.ajax({
                type: 'POST',
                dataType: 'json',
                data: data,
                url: 'rewardTrigger/updateSetInterval',
                success: function (data) {
                    alert(data.msg);
                    if (Number(data.ret) === 0) {
                        window.location.reload()
                    }
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

    });

</script>
