<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>修改活动</title>

    <style type="text/css">
        table {
            table-layout: fixed !important;
        }

        th {
            background: rgb(146, 208, 80);
        }

        td, th {
            max-width: 400px;
            word-wrap: break-word;
        }

        .table-hover > tbody > tr:hover {
            background-color: #c8bd6d;
        }

        #roleTable tr:nth-child(5n) {
            background: rgb(198, 239, 206);
        }

        /**隔五行*/

        .fixed-table-toolbar {
            display: none;
        }

        .fileinput-button {
            position: relative;
            top: -5px;
        }

        .fileinput-button input {
            position: absolute;
            right: 0px;
            top: 0px;
            opacity: 0;
            -ms-filter: 'alpha(opacity=0)';
        }
    </style>
</head>

<body>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>场景触发后台</header>
                    <section>
                        <div class="container-fluid">
                            <div class="ibox-title" style="margin-bottom: 20px">
                                <h5 style="font-weight: bold">通用配置：</h5>
                            </div>

                            <div class="container-fluid">
                                <div class="row">
                                    <div class="col-sm-12">
                                        <button type="button" class="btn btn-primary" id="commonConfSubmitBtn">提交</button>
                                    </div>
                                </div>
                            </div>

                            <div class="ibox-content" style="padding:25px 0;">
                                <div class="col-sm-12">
                                    <form class="form-horizontal" method="post" id="commonConfForm" action="">
                                        <div class="form-group">
                                            <label class="col-sm-2 control-label">触发冷却时间(h):</label>
                                            <div class="col-sm-2">
                                                <input type="number" class="form-control" name="coolTime" value="<?php echo $coolTime; ?>">
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </section>
                    <section>
                        <div class="container-fluid">
                            <div class="ibox-title" style="margin-bottom: 20px">
                                <h5 style="font-weight: bold">场景触发配置：</h5>
                            </div>
                        </div>
                        <div class="container-fluid">
                            <span id="filespanXml" class="btn btn-success fileinput-button">
                                <span>导入</span>
                                <input type="file" id="uploadXml">
                            </span>
                            <input type="button" style="display: none;margin-bottom: 10px;width: 80px;"
                                   class="btn btn-success" value="上传" id="uploadConfigFileBtn"/>
                            <a type="button" href="/Export/sceneTrigger" style="margin-bottom: 10px;width: 80px;"
                               class="btn btn-success">导出</a>

                            <div class="row" style="margin-top: 10px">
                                <div class="col-sm-12">
                                    <div class="table-responsive ">
                                        <table id="roleTable" class="table table-bordered table-hover"
                                               data-toggle="table"
                                               data-classes="table table-hover"
                                               data-show-columns="true"
                                               data-striped="true"
                                               data-height="700">
                                            <thead>
                                            <tr>
                                                <th style="width: 100px">触发ID</th>
                                                <th style="width: 180px">触发行为</th>
                                                <th style="width: 180px">行为有效期</th>
                                                <th style="width: 100px">状态</th>
                                                <th style="width: 80px">再次触发冷却时间(h)</th>
                                                <th style="width: 80px">优先级</th>
                                                <th style="width: 180px">触发备注</th>
                                                <th style="width: 300px">触发奖励</th>
                                                <th style="width: 300px">操作</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <?php
                                            if (is_array($list) && !empty($list)) {
                                                foreach ($list as $key => $vl) { ?>
                                                    <tr>
                                                        <td><?php echo $vl['id']; ?></td>
                                                        <td><?php echo $vl['sceneHtml']; ?></td>
                                                        <td><?php echo $vl['date_start'] . " 至 " . $vl['date_end'];
                                                            unset($vl['sceneHtml']) ?></td>
                                                        <td>   <?php if ($vl['status'] == 0) {
                                                                echo "<button type='button' class='btn btn-primary'>未开始</button>";
                                                            } else if ($vl['status'] == 1) {
                                                            if ($vl['switch']){
                                                                echo "<button type='button' class='btn btn-success'>进行中</button>";
                                                            }else{
                                                                echo "<button type='button' class='btn btn-danger'>已下线</button>";
                                                            }
                                                            } else if ($vl['status'] == 2) {
                                                                echo "<button type='button' class='btn btn-white'>已过期</button>";
                                                            } ?></td>
                                                        <td><?php echo $vl['coolTime']; ?></td>
                                                        <td><?php echo $vl['priority']; ?></td>
                                                        <td><?php echo $vl['desc']; ?></td>
                                                        <td class="tablePropsRewardsTag" data-value='<?php echo $vl['reward'] ?? []; ?>'></td>
                                                        <td>
                                                            <?php if ($vl['status'] == 2) {
                                                                echo "<button type='button' class='btn btn-white'>已过期</button>";
                                                            } else {
                                                                if ($vl['switch']) {
                                                                    echo "<button type='button' class='btn btn-danger' onclick='handleOnline({$vl['id']},0)'>下线</button>";
                                                                } else {
                                                                    echo "<button type='button' class='btn btn-success' onclick='handleOnline({$vl['id']},1)'>上线</button>";
                                                                }
                                                            } ?>
                                                            <button type="button" class="btn btn-warning"
                                                                    onclick="openEdit(this,'new')"
                                                                    data-toggle="modal"
                                                                    data-target="#triggerEditBtn"
                                                                    data-value='<?php echo json_encode($vl); ?>'>复制新建
                                                            </button>
                                                            <button type="button" class="btn btn-primary active"
                                                                    onclick="openEdit(this,'edit')"
                                                                    data-toggle="modal"
                                                                    data-target="#triggerEditBtn"
                                                                    data-value='<?php echo json_encode($vl); ?>'>编辑
                                                            </button>
                                                            <button type="button" class="btn btn-danger active" onclick="handleDel(<?php echo $vl['id']; ?>)">删除</button>
                                                        </td>
                                                    </tr>
                                                <?php }
                                            } else { ?>
                                                <tr>
                                                    <td colspan="8">暂无数据</td>
                                                </tr>
                                            <?php } ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>
</body>

<!--活动编辑弹窗-->
<div class="modal" id="triggerEditBtn" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog" style="width: 60%">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span
                            class="sr-only">Close</span></button>
                <h4 class="modal-title" id="myModalLabel">修改触发奖励配置</h4>
            </div>
            <form class="form-horizontal" method="post" id="triggerForm" action="">
                <div class="modal-body">
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发ID:</label>
                        <div class="col-sm-2">
                            <input placeholder="新增时自动递增" type="number" readonly class="form-control" name="id">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发行为:</label>
                        <div class="col-sm-3">
                            <label class="select-inline">
                                <select class="form-control" name="scene">
                                    <?php foreach ($sceneList as $k1 => $v1) { ?>
                                        <option value="<?php echo $k1; ?>"><?php echo $v1; ?></option>
                                    <?php } ?>
                                </select>
                            </label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">上下线:</label>
                        <div class="col-sm-3">
                            <label class="select-inline">
                                <select class="form-control" name="switch">
                                    <option value="0">下线</option>
                                    <option value="1">上线</option>
                                </select>
                            </label>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">行为有效期:</label>
                        <div class="col-sm-4">
                            <input id="sn_date" type="text" class="form-control" name="sn_date">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">再次触发冷却时间(h):</label>
                        <div class="col-sm-3">
                            <input placeholder="再次触发冷却时间" type="text" class="form-control" name="coolTime">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">优先级:</label>
                        <div class="col-sm-3">
                            <input placeholder="优先级" type="text" class="form-control" name="priority">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发备注:</label>
                        <div class="col-sm-3">
                            <input placeholder="条件描述" type="text" class="form-control" name="desc">
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="col-sm-3 control-label">触发奖励:</label>
                        <div class="col-sm-7">
                            <label class="select-inline">
                                <table class="col-sm-12">
                                    <tr>
                                        <td class="formPropsRewardsTag" data-value=''></td>
                                        <td class="text-right">
                                            <button type="button"
                                                    class="btn btn-outline btn-success"
                                                    onclick="propsJs.initEdit(this, 'formPropsRewardsTag')">
                                                奖励配置
                                            </button>
                                        </td>
                                    </tr>
                                </table>
                            </label>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">关闭</button>
                    <button type="button" class="btn btn-primary" id="confSubmitBtn">提交</button>
                </div>
            </form>
        </div>
    </div>
</div>

<script>
    propsJs.initTag('tablePropsRewardsTag')

    function handleOnline(id, status) {
        const data = {}
        data['id'] = id
        data['switch'] = status
        console.log(data)
        $.ajax({
            url: 'sceneTrigger/updateSwitch',
            type: 'POST',
            data: data,
            dataType: 'json',
            success: function (data) {
                window.location.reload();
                alert(data.msg);
            },
            error: function (data) {
                alert(data.msg);
            }
        });
    }

    function handleDel(id) {
        const data = {}
        data['id'] = id
        $.ajax({
            url: 'sceneTrigger/delScene',
            type: 'POST',
            data: data,
            dataType: 'json',
            success: function (data) {
                window.location.reload();
                alert(data.msg);
            },
            error: function (data) {
                alert(data.msg);
            }
        });
    }

    let formData = {}

    function openEdit(even, type) {

        formData = $(even).data('value')
        if (type === 'new') {
            formData['id'] = ""
        }
        console.log(formData)
        for (let key in formData) {
            if (formData.hasOwnProperty(key)) {
                if (key === 'reward') {
                    $('.formPropsRewardsTag').data("value", JSON.parse(formData[key]))
                } else {
                    $("[name=" + key + "]").val(formData[key]);
                }
            }
        }

        propsJs.initTag('formPropsRewardsTag')

        laydate.render({
            elem: '#sn_date',
            type: 'datetime',
            range: "-"
        });
    }

    $(function () {
        $('#confSubmitBtn').click(() => {
            const data = $('#triggerForm').toObject()
            data['reward'] = $('.formPropsRewardsTag').data('value')
            $.ajax({
                url: 'sceneTrigger/updateConfig',
                type: 'POST',
                data: data,
                dataType: 'json',
                success: function (data) {
                    alert(data.msg);
                    if (data.ret === 0) {
                        window.location.reload();
                    }
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

        //通用配置
        $('#commonConfSubmitBtn').click(() => {
            const data = $('#commonConfForm').toObject()
            $.ajax({
                url: rootPath + 'sceneTrigger/updateCommon',
                type: 'POST',
                data: data,
                dataType: 'json',
                success: function (data) {
                    window.location.reload();
                    alert(data.msg);
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });

        $("#filespanXml").on("change", "input[type='file']", function () {
            var filePath = $(this).val();
            //如果仅上传图片 if(filePath.indexOf("jpg") != -1 || filePath.indexOf("png") != -1) {
            if (filePath) {
                $('#filespanXml').hide();
                $('#uploadConfigFileBtn').show();
            } else {
                return false
            }
        });

        //导入金币配置
        $("#uploadConfigFileBtn").click(function () {
            var formData = new FormData();
            formData.append("file", document.getElementById("uploadXml").files[0]);

            $.ajax({
                type: "POST", // 数据提交类型
                url: "Import/sceneTrigger", // 发送地址
                data: formData, //发送数据
                async: true, // 是否异步
                processData: false, //processData 默认为false，当设置为true的时候,jquery ajax 提交的时候不会序列化 data，而是直接使用data
                contentType: false, //
                success: function (data) { // 成功回调
                    data = JSON.parse(data);
                    if (data.ret === 0) {
                        // console.log(data)
                        alert(data.msg);
                        window.location.reload();
                    } else {
                        // msgTip = $('#msg-tip');
                        alert(data.msg);
                        // window.location.reload();
                    }
                }
            });
        });
    });

</script>
