<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>修改活动</title>

    <style type="text/css">
        table {
            table-layout: fixed !important;
        }

        th {
            background: rgb(146, 208, 80);
        }

        td, th {
            max-width: 400px;
            word-wrap: break-word;
        }

        .table-hover > tbody > tr:hover {
            background-color: #c8bd6d;
        }

        input {
            width: 60px;
        }

    </style>
</head>

<body>
<div class="content_wrapper">
    <div id="msg-tip"></div>
    <div class="container-fluid ">
        <div class="row">
            <div class="col-sm-12">
                <aside>
                    <header><i class="fa fa-fw fa-file"></i>概率干预修正区间</header>
                    <section>
                        <div class="container-fluid">
                            <div class="row" style="margin:5px;0">
                                <button type="button" class="btn btn-primary" id="goodsSubmitBtn">提交</button>
                            </div>
                            <hr>
                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="table-responsive ">
                                        <table id="roleTable" class="table table-bordered table-hover"
                                               data-toggle="table"
                                               data-classes="table table-hover"
                                               data-show-columns="true"
                                               data-striped="true"
                                               data-height="700">
                                            <thead>
                                            <tr>
                                                <th>概率干预等级</th>
                                                <th>收集物1</th>
                                                <th>收集物2</th>
                                                <th>收集物3</th>
                                                <th>一个金币</th>
                                            </tr>
                                            </thead>
                                            <tbody>
                                            <?php
                                            if (is_array($conf) && !empty($conf)) {
                                                foreach ($conf as $key => $vl) { ?>
                                                    <tr>
                                                        <td><?php echo $vl['ce']; ?></td>
                                                        <td><?php echo $vl['conf']['one']; ?></td>
                                                        <td><?php echo $vl['conf']['two']; ?></td>
                                                        <td><?php echo $vl['conf']['three']; ?></td>
                                                        <td><?php echo $vl['conf']['oneCoin'] ?? 0; ?></td>
                                                    </tr>
                                                <?php }
                                            } else { ?>
                                                <tr>
                                                    <td colspan="5">暂无数据</td>
                                                </tr>
                                            <?php } ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </section>
                </aside>
            </div>
        </div>
    </div>
</div>
</body>

<script>
    $(function () {
        $('#roleTable').on('dblclick', 'td', function () {
            var _this = $(this),//保存td
                tdText = _this.text();
            const cellIndex = _this[0].cellIndex;
            if ([0].includes(cellIndex)) {
                return false;
            } //点击操作列不可编辑
            if (!_this.is('.input')) {
                _this.addClass('input').html('<input type="text" value="' + tdText + '" />').find('input').focus().blur(function () {
                    var _input = $(this); //保存input对象
                    var thisvalue = $(this).val();
                    _input.parent().removeClass('input').html(thisvalue || '');
                    if ($('#commitBtn').prop('disabled')) {
                        $('#commitBtn').attr('disabled', false);
                    }
                });
            }

        });
        $('#goodsSubmitBtn').click(function () {

            const tr = $('#roleTable tr');
            let td
            let arr = [];
            for (var i = 1; i < tr.length; i++) {
                td = $(tr[i]).find('td');
                arr.push({
                    "ce": $(td[0]).html(),
                    "conf": {
                        "one": $(td[1]).html(),
                        "two": $(td[2]).html(),
                        "three": $(td[3]).html(),
                        "oneCoin": $(td[4]).html()
                    }
                })
            }
            console.log(arr)
            $.ajax({
                url: rootPath + 'slot/lsConfUpdate',
                type: 'POST',
                data: {
                    conf: arr
                },
                dataType: 'json',
                success: function (data) {
                    alert(data.msg);

                    if (data.ret == 0) {
                        window.location.reload();
                    }
                },
                error: function (data) {
                    alert(data.msg);
                }
            });
        });
    });


</script>
